// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/domain/domain_member_map.c
// Description:

/*
 * Dieser File muss von jedem Domain-Mitglied-map.c-File inherited werden !
 *
 *	In diesem wird nur die Routine
 *
 *		setup_room(object room, int x, int y)
 *
 *     aufgerufen. Ist diese Routine nicht definiert, so werden die
 *     Defaults der Domain benuetzt.
 *
 *     x und y sind lokal zum Bereich, nicht zur Domain !
 */

#pragma save_types

private mixed *karte_files=({});
private mixed *karte_y=({});
private int *karte_x=({});


/*
FUNKTION: setup_room
DEKLARATION: int setup_room(object room, int x, int y, int domain_x, int domain_y)
BESCHREIBUNG:
Diese Funktion wird aufgerufen, wenn ein Map-Raum geladen wird, fuer
den es kein File auf Platte gibt.
Uebergeben wird der Objekt-Pointer auf den Raum und die LOKALEN Koordinaten
innerhalb der Domain.
Hierin kann man das Aussehen des Raumes setzen.
Beispiel:
int setup_room(object room, int x, int y, int domain_x, int domain_y) {
    room->set_short("Neue Sub-Domain");
    room->set_long("Du bist in einer neuen Sub-Domain.\n");
    return 1;
}

Wenn 1 returned wird, bedeutet dieses, dass das Aussehen des
Raumes veraendert wurde.
Wenn 0 returned wird, setzt die uebergeordnete Map das Aussehen.

Bei einer Submap werden zusaetlich zu den lokalen Koordinaten auch
noch die Koordinaten innerhalb der Domain uebergeben:

int setup_room(object room, int x, int y, int domain_x, int domain_y)

VERWEISE:
GRUPPEN: map, domain
*/
int setup_room(object room, int x, int y, int domain_x, int domain_y)
{
    room->set_short("Domain-Bereich");
    room->set_long("Domain-Bereich von bsp_member in der Domain.\n");
    return 1;
}

string query_room_file(int x, int y)
{
    return 0;
}
 
void create()
{
}

varargs void add_karte(string file, int x, int y)
{
    if (file_size(file)<0)
	return;
    karte_files+=({explode(read_file(file),"\n")[0..<2]});
    karte_x+=({x});
    karte_y+=({({y,y+sizeof(karte_files[<1])-1})});
}

string query_room_icon(int x, int y)
{
    int i;
    string tmp;

    for(i=0; i<sizeof(karte_files); i++)
	if (y>=karte_y[i][0] && y<=karte_y[i][1] && x>=karte_x[i] &&
		((tmp=karte_files[i][karte_y[i][1]-y][x-karte_x[i]..x-karte_x[i]
])!=""))
            return tmp;
    return 0;
}
