// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/item/feel.c
// Description: Tastsinn

#pragma save_types
#pragma strong_types

inherit "/i/tools/description";

#include <description.h>

private mixed feel;

/*
FUNKTION: set_feel
DEKLARATION: void set_feel(mixed gefuehl)
BESCHREIBUNG:
Setzt fuer ein Objekt, wie es sich anfuehlt.

Statt eines Strings kann auch eine komplexere Beschreibung mit Bedingungen
angegeben werden. Siehe dazu /doc/funktionsweisen/beschreibungen.

VERWEISE: query_feel, T_LISTE
GRUPPEN: grundlegendes
*/
void set_feel(mixed str)
{
    feel = compile_desc(str, 0);
    if (stringp(feel) || !feel)
    {
        this_object()->add_setter_conservation("set_feel",({feel}) );
    }
    else
    {
        this_object()->add_setter_conservation("set_feel", 0);
        this_object()->set_conservation_constraint("set_feel",1);
    }
}

/*
FUNKTION: query_feel
DEKLARATION: string query_feel()
BESCHREIBUNG:
Gibt fuer ein Objekt zurueck, wie es sich anfuehlt.
VERWEISE: set_feel, query_feel_msg
GRUPPEN: grundlegendes
*/
string query_feel()
{
    mapping info = get_desc_info_mapping(this_player());
    string res;

    if(!feel)
        return 0;

    res = funcall(feel, info);
    if(strlen(res) && res[<1]!='\n')
	res = wrap(trim(res));

    return res;
}
