// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/object/chest.c
// Description:	Eine Kiste zum Vergraben von Geld
// Author:	Francis '92
// Modified by:	Freaky (16.02.2000) auf /i/base/container umgestellt
// 		Freaky (07.05.2000) auf /i/object/kiste umgestellt

#pragma save_types

inherit "/i/object/kiste";
inherit "/i/tools/chest";

#include <room.h>

private string owner_name;

void init()
{
    "*"::init();
    add_action("schreibe","schreibe",-7);
    if (environment() == this_player() && owner_name == "niemand")
	owner_name = this_player()->query_real_name();
}

string gravur_read(string str)
{
    string name;

    if (!strlen(owner_name) || owner_name == "niemand")
	name = "";
    else
	name = capitalize(owner_name);

    return right("*",19)+copies("*",25)+"\n"+
	  right("*",17)+copies(" ",28)+"*\n"+
	  right("*",15)+center(name,32)+"*\n"+
	  right("*",17)+copies(" ",28)+"*\n"+
	  right("*",19)+copies("*",25)+"\n";
}

void create()
{
    "*"::create();
    set_id(({"kiste", "schatzkiste", "truhe", "schatztruhe"}));
    set_name("schatztruhe");
    set_gender("weiblich");
    set_material("holz");
    set_value(20);
    set_weight(8);
    set_max_internal_encumbrance(10);
    set_long("Eine Truhe von vermutlich hohem Wert. Auf ihr ist etwas "
	    "eingraviert.\n");
    owner_name = "niemand";
    add_v_item((["name":"gravur",
	"gender":"weiblich",
	"long":"Eine Gravur. Man kann sie lesen.",
	"read":#'gravur_read ]));
    set_no_lock(1);
}

void set_owner_name(string str) { owner_name = str; }

string query_owner_name() { return owner_name; }

int schreibe(string str)
{
    string st1,st2;

    if (!str)
	return notify_fail("Schreibe was auf " + den() + "?\n");
    if (sscanf(str,"%s auf %s",st1,st2) != 2 || !me(st2))
	return notify_fail("Schreibe was worauf?\n");
    if (!this_player()->can_see(this_object()))
    {
        write("Dafür ist es viel zu dunkel.\n");
        return 1;
    }
    owner_name = explode(st1,"|")[0]; // Damit niemand sowas macht:
                                      // schreibe Goldesel|taler|taler|100000
    say(wrap(Der(this_player()) + " schreibt etwas auf " + seinen() + "."));
    write("Ok.\n");
    return 1;
}

mapping bury_chest()
{
    mapping data = chest::bury_chest();

    m_add(data, CHEST_NAME, sizeof(owner_name) ? owner_name : "niemand");
    return data;
}

void init_chest(mapping data)
{
    chest::init_chest(data);

    owner_name = data[CHEST_NAME];
    if(!sizeof(owner_name))
        owner_name = "niemand";
}
