// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/object/multiob.c
// Description: Multiobjekt fuer Pfeile, Knaller, Streichoelzer...
// Author:	Garthan

#pragma save_types

virtual inherit "/i/object/countob";
virtual inherit "/i/value";

varargs void set_value(int i)
{
   ::set_value(i / (query_count() || 1));
}

int query_value()
{
   return ::query_value() * (query_count() || 1);
}

/*
FUNKTION: set_singular_value
DEKLARATION: void set_singular_value(int i)
BESCHREIBUNG:
Setzt den Wert, den das Multi-Objekt mit der Anzahl 1 haette.
VERWEISE: set_singular_value, query_singular_value, set_value, query_value
GRUPPEN: countob, handel
*/

void set_singular_value(int i)
{
   ::set_value(i);
}

/*
FUNKTION: query_singular_value
DEKLARATION: int query_singular_value()
BESCHREIBUNG:
Liefert den Wert, den das Multi-Objekt mit der Anzahl 1 haette.
VERWEISE: set_singular_value, query_singular_value, set_value, query_value
GRUPPEN: countob, handel
*/

int query_singular_value()
{
   return ::query_value();
}

void create()
{
   ::create();
   set_id("Multiobjekt");
   set_plural_id(({"Multiobjekte"}));
   set_name("multiobjekt");
   set_singular_name("multiobjekt");
   set_plural_name("multiobjekte");
   set_gender("saechlich");
   set_count_type("multiobjekt");
   set_count(1);
   set_value(1);
}

object split_object(int i)
{
   object ob;

   if((ob = ::split_object(i)) && ob != this_object())
   {
      ob->set_plural_name(query_plural_name());
      ob->set_singular_name(query_singular_name());
      ob->set_id(query_id());
      ob->set_gender(query_gender());
      ob->set_adjektiv(query_adjektiv());
      ob->set_material(query_material());
      ob->set_noise(query_noise());
      ob->set_smell(query_smell());
      ob->set_plural_id(query_plural_id());
      ob->set_count_type(query_count_type());
      ob->set_singular_value(query_singular_value());
   }
   return ob;
}
