// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/player/appreciations.c
// Description: Wuerdigungen fuer Goetter, dieses Inherit wird auch von
//              /apps/wizard_appreciations verwendet.
// Author:      Sissi

#pragma save_types
#pragma strong_types

#define APPRECIATION_CONTROLLER  "/room/rathaus/filed"

#include <apps.h>
#include <level.h>

private mixed wizard_appreciations;


private string wiz_appreciation_secure (string gebiet)
{
    if ((object_name (previous_object()) != APPRECIATION_CONTROLLER) ||
        (!this_interactive() || this_interactive() != this_player()))
        return "Das geht nur vom Gouverneursbüro aus.\n";
    if (!gebiet) return "Kein Bereich (Raetsel, Gilden, Vaniorn usw.) angegenben.\n";
    if (adminp (this_interactive())) return 0;
    gebiet = lower_case (gebiet);
    if ((member (DOMAIN_INFOS->query_domains_of(this_player()->query_real_name()), capitalize(gebiet)) == -1)
        && (member (FILED->query_auth (gebiet),this_player()->query_real_name()) == -1))
        return wrap ("Du wurdest für das Gebiet "+gebiet
            +" nicht als zuständig erkannt.\n");
    return 0;
}

nomask mixed query_wiz_appreciations (string gebiet)
{
    mixed res;
    int i;
    if (!wizard_appreciations) return ({});
    if (!gebiet) return deep_copy (wizard_appreciations);
    gebiet = lower_case (gebiet);
    for (res = ({}), i = 0; i < sizeof (wizard_appreciations); i++)
        if (wizard_appreciations[i][0] == gebiet)
            res += ({wizard_appreciations[i]});
    return res;
}

nomask mixed change_wiz_appreciation (int nummer, string neuer_text)
{
    string err;
    if (!wizard_appreciations || sizeof (wizard_appreciations) <= nummer)
        return "Es gibt keine Würdigung mit dieser Nummer.\n";
    if (err = wiz_appreciation_secure(wizard_appreciations[nummer][0]))
        return err;
    wizard_appreciations[nummer][1] = time ();
    wizard_appreciations[nummer][2] = this_player()->query_real_name ();
    wizard_appreciations[nummer][3] = neuer_text;
    return 1;
}

nomask mixed add_wiz_appreciation (string gebiet, string neuer_text)
{
    string err;
    if (err = wiz_appreciation_secure (gebiet)) return err;
    if (!wizard_appreciations) wizard_appreciations = ({});
    wizard_appreciations +=
        ({({lower_case(gebiet), time(), this_player()->query_real_name(), neuer_text})});
    return 1;
}

// Fuer den Player-modifier:
protected void clear_wiz_appreciations()
{
    wizard_appreciations = 0;
}
