// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/player/player.c
// Description: Das Hauptfile des Playerobjekts
// Modified by:	Pulami	  (03.03.1994)  'hilfe <dein_name>'
//		Freaky	  (20.05.1994)  query_age() berechnet jetzt das Alter neu
//		Monty	  (15.08.1994)  set_no_wer() und query_no_wer()
//		Freaky	  (14.10.1994)  advanced security-check in do_command()
//		Garthan	  (20.10.1994)  get_start_room eingefuehrt.
//		Garthan	  (13.12.1994)  nomask query_age
//		Freaky    (14.03.1995)  last_host nach /i/player/login gemoved
//              Garthan	  (20.03.1995)  logs fuer damische set_short/long
//		Monty	  (27.05.1995)  neues FEHLER-handling
//		Freaky,
//              Garthan   (28.11.1995)  Beim Sterben wird in der Gilde
//				        player_died(this_object()) aufgerufen.
//              Sissi	  (29.05.1996)  notify_quit in quit
//		Sissi	  (25.06.1996)  Beim Mord an einem Spieler wird in der
//                                      Gilde player_murdered(this_object(),opfer)
//                                      aufgerufen.
//
//              Sissi	  (04.07.1996)  Aussehen eines Spielers
//              Garthan	  (19.07.1996)  Hilfe ueberarbeitet
//
//              Sissi     (14.08.1996)  add_init_ob, delete_init_ob, init
//              Garthan   (03.09.1996)  opfer loeschen wenn nicht mehr existent
//              Sissi     (24.02.1997)  Fluchtmodus variabel einstellbar
//              Sissi     (30.04.1997)  Finsterlinge sind vogelfrei
//              Sissi     (16.07.1997)  Gilden koennen eigene Todessequenzen haben
//		Freaky    (10.09.1998)  message auf send_message umgebaut.
//		Parsec    (28.09.1998)  Player-Version auf 2 erhoeht. Gildenskills
//				        werden ab jetzt aus Spieler geloescht
//		Freaky    (24.11.1998)  VERSION_RASSEN_UPDATE eingebaut
//              Sissi (30./31.01.1999)  Beim Ausloggen gehen Gegenstaende nicht
//                                      mehr verloren.
//              Sissi     (04.02.1999)  query_no_retain wird (rekursiv) beruecksichtigt
//		Freaky    (05.02.1999)  Kleindung-Handling: Angezogene
//					Kleidungen 'wiegen' 1 weniger
//		Freaky    (15.02.1999)  Aggression-Victims bei Tot loeschen
//              Sissi     (20.06.1999)  Mit dem gleichzeitigen Reden zu mehreren
//                                      Leuten das Intermud - rede nach
//                                      /i/living/voice verschoben
//              Parsec    (24.09.1999)  Kommunikationskram aus Seele nach voice
//              Freaky    (01.03.2000)  an das neue add_encumbrance() angepasst
//              Sissi     (05.06.2000)  Anzieh- und Auszieh - addactions aus
//                                      Kleidung aufgenommen
//              Sissi     (21.06.2000)  query_no_www_page
//              Parsec    (27.06.2000)  savings und Skills

#pragma save_types
#pragma strong_types

inherit "/i/move";
inherit "/i/tools/move_msg";
inherit "/i/tools/getopt";
inherit "/i/contain";
inherit "/i/message";
inherit "/i/living/body";
inherit "/i/living/command";
inherit "/i/living/die";
inherit "/i/living/eyes";
inherit "/i/living/face";
inherit "/i/living/hands";
inherit "/i/living/legs";
inherit "/i/living/nose";
inherit "/i/living/ears";
inherit "/i/living/sp";
inherit "/i/living/stats";
inherit "/i/living/voice";
inherit "/i/living/team";
#ifdef META_TRANSFORM
inherit "/i/living/transform";
#endif
inherit "/i/player/login";
inherit "/i/player/inv";
inherit "/i/player/wiz_soul";
inherit "/i/player/files";
inherit "/i/player/more";
inherit "/i/player/editor";
inherit "/i/player/tippse";
inherit "/i/player/magen";
inherit "/i/player/skills";
inherit "/i/player/spells";
inherit "/i/player/event";
inherit "/i/player/fehler";
inherit "/i/player/colours";
inherit "/i/player/appreciations";
inherit "/i/player/options";
inherit "/i/player/filter_messages";
inherit "/i/player/telnet_neg";
inherit "/i/player/input_to";
inherit "/i/player/vt100client";
inherit "/i/player/webmud3";
inherit "/i/player/webmud";
inherit "/i/player/mxp";
inherit "/i/player/gmcp";
inherit "/i/player/intermud";
inherit "/i/player/diary";

#include <add_hp.h>
#include <apps.h>
#include <commands.h>
#include <config.h>
#include <deklin.h>
#include <delayed_action.h>
#include <error.h>
#include <event.h>
#include <finger.h>
#include <getopt.h>
#include <gilden.h>
#include <hpspview.h>
#include <interactive_info.h>
#include <invis.h>
#include <level.h>
#include <message.h>
#include <more.h>
#include <move.h>
#include <news.h>
#include <notify_fail.h>
#include <parse_com.h>
#include <portal.h>
#include <rtlimits.h>
#include <shadow.h>
#include <soundcheck.h>
#include <stats.h>
#include <strings.h>
#include <telnet.h>
#include <term.h>
#include <time.h>
#include <tips.h>
#include <touch.h>
#include <udp.h>

#include "/sys/player.h"
#include "player.h"

#define VERSION_RAETSEL_UPDATE_FEB_98		1
#define VERSION_GILDENSKILL_LOESCHEN_OKT_98	2
#define VERSION_RASSEN_UPDATE_NOV_98		3
#define VERSION_PLAYER_DAY_APRIL_2001		4
#define VERSION_QUERY_GAME_COUNT_DEZ_2001	5
#define VERSION_QUERY_QUEST_COUNT_JAN_2002	6
#define VERSION_NEWS_UMBAU_FEB_2002		7
#define VERSION_QUERY_QUEST_COUNT_MAY_2002	8
#define VERSION_TAGEBUCH                        9
#define VERSION_TRIGGER_RECOMPILATION          10

// Wie lange darf man sich raechen (10 Minuten):
#  define AGGRESSION_TIMEOUT 600
// Wie lange merken wir uns die Kaempfe mit Viehzeug (60 Minuten):
#  define CRITTERS_TIMEOUT 3600

#define MIN_WIDTH 79

private static int last_time, auto_save, heal;
private static object me;
private static string last_room;
private static mixed which_death;
#ifdef UNItopia
private static string *header;
#endif
private static string* no_www_pages;
private int player_age;
private int ghost;
private string kirche;
private int konto;
private int konto_age;
private int scar;
private int last_login;
private int no_wer;
private int no_tips;
private int no_ascii_art;
private int client_options;
private int client_width;
private int player_flags;
private int own_finger_flags, other_finger_flags;
private string *opfer;
private mixed *erf_gestorben;
private mixed artikel;
private mapping newsreader_settings;
private static object *to_notify_on_init;
private int *descr_source;
private string clone_msg;
private string home_msg;
private string destruct_msg;
private mixed start_room;
private string finger_info;
private string descr;
private int no_airport;
private int version;
private string no_retain_messages;
private string* temporal_adjektives;
private int alignCounter;
private int filter_spam;
private int telnet_ping;
private nosave int telnet_ping_counter;
private string usenet_email;
private int pid;

static nomask int query_client_option(int opt);
static nomask void set_client_option(int opt, int value);

// Testet, ob ein Timeout angehalten werden soll.
#define FIGHTER_AVAILABLE(ob,flags)	((ob) && interactive(ob) && \
		(!((flags)&(TO_IS_AGGRESSOR|REVENGE)) || \
		    (environment(ob) && \
		    !environment(ob)->query_type("kaempfen_verboten") && \
		    !environment(ob)->query_type("sperrgebiet") && \
		    !IS_INVIS(ob))))

// Die Mapping-Eintraege
#define CR_LAST_HIT	0
#define CR_COMMANDER	1

#define OPP_TIMEOUT	0
#define OPP_FLAGS	1

// Die Flags
#define TO_IS_AGGRESSOR	1	// Ich hab angegriffen.
#define REVENGE		2	// Aber er hat vorher mal.
#define FIGHT_STOPPED	4	// Ich hab aber aufgehoert.
#define TIMEOUT_STOPPED 8	// Und er hat sich ausgeloggt.
#define DIRTY		16	// Und danach ist noch irgendwas passiert.
#define SILENT		32	// Dieses wird dem Spieler nicht bekannt gemacht.
#define AGG_LEFT_ROOM	64	// Der Aggressor verliess den Raum
#define VIC_LEFT_ROOM	128	// Das Opfer verliess den Raum
#define FLAG_MASK	255	// Alle bekannten Flags zusammen

// Befehle fuer die internen Funktionen:
#define INC_TIMEOUT		0x100
#define FULL_TIMEOUT		0x200
#define REMOVE_OPPONENT		0x400
#define CHANGE_AGGRESSOR	0x800
#define BECOME_AGGRESSOR	(CHANGE_AGGRESSOR|TO_IS_AGGRESSOR)
#define BECOME_VICTIM		CHANGE_AGGRESSOR
#define CHANGE_REVENGE		0x1000
#define SET_TO_REVENGE		(CHANGE_REVENGE|REVENGE)
#define STOP_REVENGE		CHANGE_REVENGE
#define STOP_FIGHT		FIGHT_STOPPED
#define CHANGE_TIMEOUT_STATUS	0x2000
#define STOP_TIMEOUT		(CHANGE_TIMEOUT_STATUS|TIMEOUT_STOPPED)
#define CONTINUE_TIMEOUT	(CHANGE_TIMEOUT_STATUS)
#define LEFT_ROOM		0x4000

private nosave mapping critters = ([:2]);
// Enthaelt die ganzen Viecher, die einen Kampf mit uns wollten
// Viech-Objekt: Zeitpunkt des letzten Schlages;
//		 Commander (real_cap_name), falls das Vieh angegriffen hat,
//			sonst 0.
private mapping saved_critters; // Zum Abspeichern.

private mapping opponents = ([:2]);
// Enthaelt alle Kaempfe
// Opfer: Timeout-Zeitpunkt oder Restzeit (letzteres bei gesetzten Bit 3)
//		oder -1 (wenn der Eintrag eigentlich nicht mehr existiert);
//	  Flag;
//	    Bit 0: Ich habe begonnen
//	    Bit 1: Es gibt kein M mehr
//          Bit 2: Der Raum wurde verlassen
//	    Bit 3: Timeout angehalten (Logout von mir oder mein Gegner)
//          Bit 4: Es gab Aenderungen bei den Bits, die noch nicht
//                 beim Gegner gespeichert wurden (falls dieser ausgeloggt ist)

/*
Beschreibung als endlicher Automat:	 
-----------------------------------

Zustaende:
    Nix:	Kein Eintrag
    Notwehr: 	Bit 0 und 1 geloescht.
    Angriff:    Bit 0 gesetzt, Bit 1 geloescht
    Racheopfer:	Bit 0 geloescht, Bit 1 gesetzt.
    Rache:	Bit 0 und 1 gesetzt

Uebergaenge:
    IA: Ich greife an
    IT: Ich sterbe
    GA: Der Gegner greift mich an
    GT: Der Gegner stirbt

Automat:
    Nix:
	IA -> Angriff
	GA -> Notwehr
    Notwehr:
	IA -> Rache
	GA -> Notwehr
	IT -> Nix (Es gibt ein (M))
	GT -> Nix
    Angriff:
	IA -> Angriff
	GA -> Racheopfer
	IT -> Nix
	GT -> Nix (Ich bekomme ein (M))
    Racheopfer:
	IA -> Rache
	GA -> Racheopfer
	IT -> Notwehr
	GT -> Angriff
    Rache:
	IA -> Rache
	GA -> Racheopfer
	IT -> Notwehr
	GT -> Angriff
*/
/*
Behandlung von query_commander:
-------------------------------
  Beim Beginn eines Kampfes mit einem Monster, wird gemerkt,
  ob das Monster den Kampf gestartet hat und falls ja, wie sein Commander
  hiess. Ausserdem merkt man sich, wann der letzte Schlag war (um
  die Datenstruktur nach einer Weile aufzuraeumen.)

  Falls ein Commander nun diesen Kampf gestartet hat, geht jeder Schlag
  des Lebewesens auf das Konto des Commander (als ob der Commander
  selbst zugeschlagen haette). Anderenfalls werden diese Schlaege ignoriert.
  
  Die zugehoerige Datenstruktur ist resistent gegen das Ausloggen.
*/
#if 0
#define AGGLOG(str) sys_log("Aggression",sprintf("[%s] %O->%O: %s->%s - Opp: %s, critters: %s\n",\
			shorttimestr(time()), previous_object(1), previous_object(), query_real_cap_name(), (str), mixed2str(opponents), mixed2str(critters)))
#else
#define AGGLOG(str) 
#endif

void aggression_login();
void aggression_meldung();
void aggression_logout();
void aggression_invis(string controller, object who, int alt, int neu);

nomask int query_moerder();

static int query_skill_update_time();
static void reset_skill_update_time();

/* --- Ueberlagerungen: --- */

#define LOG	\
    if(this_interactive() && this_interactive()!=this_object() &&\
	!wizp(this_object()) && !testplayerp(this_object()) &&\
	wizp(this_interactive())) \
	    touch("/secure/log_adjektiv")

void set_short(string str)
{
    LOG->log_whatever("SET_SHORT", query_short_string(), str);

    ::set_short(str);
}

void set_long(string str)
{
    LOG->log_whatever("SET_LONG", query_long_string(), str);

    ::set_long(str);
}

void set_own_light(int val)
{
    do_error(wrap("set_own_light("+val+") wurde in Spieler '"+
                this_object()->query_real_name()+"' aufgerufen."));
}

void add_own_light(int val)
{
    do_error(wrap("add_own_light("+val+") wurde in Spieler '"+
                this_object()->query_real_name()+"' aufgerufen."));
}

int query_own_light()
{
    int licht_level = sizeof(filter(this_object()->query_all_v_items()||({}),
        function int (mapping vi) {
            return mappingp(vi) && sizeof(vi["id"]) &&
                member(vi["id"]||({vi["name"]}),"feuer#kugel")!=-1;
        }));
    return (find_call_out("licht_aus") == -1 ? 0 : licht_level);
}

void set_material(mixed materialien)
{
    if(previous_object() && 
       strstr(object_name(previous_object()), "/secure/obj/login#") == 0)
    {
        return ::set_material(materialien);
    }

    do_error(wrap(sprintf("set_material(%#Q) wurde in Spieler '%s' aufgerufen.",
                        materialien, this_object()->query_real_name())));
}

void add_material(mixed materialien)
{
    do_error(wrap(sprintf("add_material(%#Q) wurde in Spieler '%s' aufgerufen.",
                        materialien, this_object()->query_real_name())));
}

#if 0 // Benoetigt Recht auf debug_info im Master
#include <debug_info.h>
void set_max_internal_encumbrance(int max)
{
    if(extern_call())
    {
        do_error(wrap("set_max_internal_encumbrance("+max+") wurde in Spieler '"+
                    this_object()->query_real_name()+"' aufgerufen."));
    }
    else
    {
	sys_log("max_internal_enc",
	    sprintf("[%s] %O, smie(%O): %=-100s\n", shorttimestr(time()),
		query_max_internal_encumbrance(),
		max, efun::debug_info(DINFO_TRACE, DIT_STR_CURRENT)));
    }
    ::set_max_internal_encumbrance(max);
}
#endif

void notify_moved_for_delayed_action(string ctrl,mapping mv_infos)
{
    last_room = mv_infos[MOVE_OLD_ROOM] 
             ? object_name(mv_infos[MOVE_OLD_ROOM]) : 0;
    if (in_delayed_action() && !(query_da_flag() & DA_OK_MOVE))
        halt_delayed_action(DA_BREAK);
}

void notify_move_failed_for_da(string ctrl, mapping mv_infos, int ret)
{
    if ((ret == MOVE_OK) || (this_interactive() == this_object()))
      if (in_delayed_action() && !(query_da_flag() & DA_OK_MOVE))
	   halt_delayed_action(DA_BREAK);
}

/* --- Ende Ueberlagerungen. --- */

/*
FUNKTION: query_age
DEKLARATION: nomask int query_age()
BESCHREIBUNG:
Diese Funktion liefert das Alter des Spielers.
GRUPPEN: spieler
*/
nomask int query_age()
{
    if (interactive(this_object()) && (query_idle(this_object()) < 600))
	player_age += time() - last_time;
    last_time = time();
    return player_age;
}

static void restart_age()
{
    last_time = time();
}

protected void add_actions() {
    "*"::add_actions();

    add_action("suicid",	"suizid");
    add_action("suicid",	"selbstloeschung",-12); // fuer MGler
    add_action("suicid",	"suicide"); // fuer unsere englischen Freunde
    add_action("selbstsperrung","selbstsperrung");
    add_action("save_command",	"sichern",-6);
    add_action("save_command",	"#sichern",-7);
    add_action("quit",		"ende");
    add_action("quit",		"#ende");
    add_action("verweise",	"exit");
    add_action("verweise",	"quit");
    add_action("read_news",	"neues");
    add_action("skill", 	"erfahrung",-3);
    add_action("score",		"spielstand");
    add_action("score",		"sp");
    add_action("score",         "info");
    add_action("score",         "score");
    add_action("hp_sp_view_command","ap");
    add_action("hp_sp_view_command","hp");
    add_action("hp_sp_view_command","zp");
    add_action("hp_sp_view_command","mp");
    add_action("hp_sp_view_command","kp");
    add_action("toggle_whimpy",	"vorsicht");
    add_action("toggle_whimpy",	"flucht");
    add_action("help",		"hilfe");
    add_action("help",		"#hilfe");
    add_action("help_english",	"help");
    add_action("muds",		"mudlink");
    add_action("muds",		"muds");
    add_action("muds",		"#mudlink");
    add_action("muds",		"#muds");
    add_action("who",		"wer");
    add_action("who",		"#wer");
    add_action("change_password","passwort");
#if 0
    add_action("forwarding",    "forward");
#endif
    add_action("feedback",      "feedback");
    add_action("feedback",      "fehlerfeedback");
    add_action("feedback",      "#feedback");
    add_action("feedback",      "#fehlerfeedback");
    add_action("fehler",	"fehler");
    add_action("fehler",	"idee");
    add_action("fehler",        "detail");
    add_action("fehler",        "toll");
    add_action("fehler",        "würdige");
    add_action("fehler",        "würdigung");
    add_action("fehler",        "typo");
    add_action("fehler",	"#fehler");
    add_action("fehler",	"#idee");
    add_action("fehler",        "#detail");
    add_action("fehler",        "#toll");
    add_action("fehler",        "#wuerdige");
    add_action("fehler",        "#wuerdigung");
    add_action("fehler",        "#typo");
    add_action("stop_da_command",DA_STOP_ACTION);
    add_action("inventory",	"ausrüstung",-4);
    add_action("do_cmd",	"tue");
    add_action("stop_do_cmd",	"stoppe", -4);
    add_action("player_stoppe", "stoppe", -4);
    add_action("player_verzicht","verzichte", -8);
    add_action("puffer_command","puffer");
    add_action("puffer_command","erinnerungen",-5);
    add_action("puffer_command","Erinnerungen",-5);
    add_action("speicher_command","speichere",-6);
    add_action("speicher_command","sichere",-6);
    add_action("speicher_command","#speichere",-7);
    add_action("speicher_command","#sichere",-7);
    add_action("history",	"history");
    add_action("alias",		"kürzel");
    add_action("alias",         "alias");
    add_action("alias",         "aliase");
    add_action("unalias",       "unkuerzel");
    add_action("unalias",       "entkürzel");
    add_action("unalias",       "entalias");
    add_action("unalias",       "unalias");
    add_action("conversation_command", "gespräch",-5);
    add_action("listener_cmd",  "hörer");
    add_action("listener_cmd",  "zuhörer");
    add_action("listener_cmd",  "#hoerer");
    add_action("listener_cmd",  "#zuhoerer");
    add_action("channel","+",AA_NOSPACE);
    add_action("away_command",	"weg");
    add_action("away_command",	"#weg");
    add_action("shout_verweis",	"rufe",-3);
    add_action("licht_command",	"licht");
    add_action("sicht_command",	"sicht");
    add_action("aura_command",	"aura");
    add_action("sinn_command",	"sinn");
    add_action("bewerte_command","bewerte");
    add_action("finger",	"finger");
    add_action("finger",	"#finger");
    add_action("describe_me",   "beschreiben",-9);
    add_action("untersuche_verweis","unt");
    add_action("untersuche_verweis","untersuche",-9);
    add_action("options_command","einstellungen",-5);
    add_action("options_command","#einstellungen",-6);
    add_action("clear_command","clear");
    add_action("clear_command","cls");
    if(spielerratp(this_object()) || adminp(this_object()))
        add_action("srurne","srurne");
}

void define_wiz_commands()
{
    if (query_wiz_level())
    {
	init_current_path();
	add_wizard_menues();
	add_action("get_zauberstab","zauberstab");
	add_action("get_rid_of_zauberstab","werfe_zauberstab_weg");
	add_action("augen", "augen");
	add_action("pk","pk");
	add_action("unpk","unpk");
	add_action("cd","cd");
	add_action("pwd","pwd");
        add_action("change_likes_attacks","angreifbar");
        add_action("driver_status", "status");
	if (query_wiz_level() >= LVL_VOGT)
	{
	    add_action("snoop_on", "beobachte");
	    add_action("trust_command", "vertraue",-7);
	    add_action("trust_command", "trust");
    	}
        add_action("say_command", "zsage",-4);
        add_action("say_command", "z'",AA_NOSPACE);
    }
}

void create()
{
    if (me)
	return;
    me = this_object();
    last_time = time();
    set_name("player");
    set_id( ({"player"}) );
    MONSTER_MASTER->init_monster(this_object(),MD_DEF_RASSE,1);
    set_message_filter(MT_MASK);
    set_transparent(1);
    seteuid(getuid());
#ifdef UNItopia
    if (!clonep(this_object()))
    {
	string h = read_file("/static/adm/WER_HEADER");
	header = h ? explode(h,"\n") : ({"In "+MUD_NAME+" befinden sich:"});
	h = read_file("/static/adm/NO_WWW_PAGES");
	if (h) no_www_pages = explode(h,"\n") - ({0});
    }
    else
    {
       call_out("test_some_things",2);
    }
#endif

    "*"::create();
}

int remove()
{
    if(interactive() && query_client_option(CLIENT_VT100))
	stop_mudclient();
    if(extern_call() && previous_object() != this_object())
	// Warnung an Root, damit es im Bilde ist, wenn Spieler Meldungen von Armageddon bekommen.
	do_my_warning(sprintf("remove() wurde im Player von %Q aufgerufen!\n", previous_object()));
    if(is_intermud_guest())
       quit_intermud_guest();
    return ::remove();
}

#ifdef UNItopia

void update_artikel_struktur();


nomask static void update_version()
{
    switch (version) {
        case 0:
        case VERSION_RAETSEL_UPDATE_FEB_98:

            // Raetsel - und Gildenskills loeschen:
	    if (!guestp(this_object()))
	    {
		// Freaky: Fuer die Stats
		update_stats();
		update_max_hp();
		update_max_sp();

		skill_checker_update_skill_structure();
		update_sum_skill();
		compute_quest_count();
		touch(LEVEL_LISTER)->new_enter(this_object());
	    }

	case VERSION_GILDENSKILL_LOESCHEN_OKT_98:

            // Rassen Update vornehmen:
	    set_race(MONSTER_MASTER->query_rassen_def(MD_DEF_RASSE,MD_RASSE));
	    set_koerperform(MONSTER_MASTER->query_rassen_def(MD_DEF_RASSE,MD_KOERPERFORM));
	    set_koerpergroesse(MONSTER_MASTER->query_rassen_def(MD_DEF_RASSE,MD_KOERPERGROESSE));
	    set_abilities(MONSTER_MASTER->query_rassen_def(MD_DEF_RASSE,MD_ABILITIES));

        case VERSION_RASSEN_UPDATE_NOV_98:

            // Player Day Anpassungen:
            if (level >= LVL_WIZ) {
                opfer = ({});
                konto = 20000;
                set_invis (0);
            }

        case VERSION_PLAYER_DAY_APRIL_2001:
    
            // Game Count neu berechnen:
            call_out ("compute_game_count",2);
            
        case VERSION_QUERY_GAME_COUNT_DEZ_2001:
        
        case VERSION_QUERY_QUEST_COUNT_JAN_2002:
            
            // News-Struktur umbauen
            call_out("update_artikel_struktur",0);

        case VERSION_NEWS_UMBAU_FEB_2002:
        
            // query quest count nochmal neu berechnen
            call_out ("compute_quest_count",2);
            version = VERSION_QUERY_QUEST_COUNT_MAY_2002;

        case VERSION_QUERY_QUEST_COUNT_MAY_2002:
            call_out ("get_me_a_diary",2);
            version = VERSION_TAGEBUCH;
        
        case VERSION_TAGEBUCH:
            recompile_trigger();
            version = VERSION_TRIGGER_RECOMPILATION;

        case VERSION_TRIGGER_RECOMPILATION:
            // Aktuelle Version.
    }
}

void get_me_a_diary()
{
    clone_object ("/obj/tagebuch")->move(this_object());
}

nomask static void test_some_things()
{
    if (this_object()->query_whimpy() == 1)
	this_object()->set_whimpy(this_object()->query_max_hp()/5);
    if (!environment())
	move(DEFAULT_START_ROOM);
    update_letzte_gilden();
    update_version();
    update_skill_structure();
    this_object()->feedbacktest();
}

#endif // UNItopia

private void birth()
{
    // wird aufgerufen, wenn ein neuer Spieler geboren worden ist
    CONTROL->notify("birth", this_object());
}

/*
FUNKTION: notify_birth
DEKLARATION: void notify_birth(object player)
BESCHREIBUNG:
Wenn ein neuer Spieler player sich einloggt, dann wird
CONTROL->notify("birth", player) aufgerufen. Blueprints
koennen sich an CONTROL anmelden, um dies mitzubekommen.
Siehe dazu auch die Kommentare am Anfang von /apps/control.c
VERWEISE: notify, notify_login
GRUPPEN: spieler
*/

private void handle_m_v_item ();

private void opfer_konsistenz()
{
   // Testen ob die Spieler die dieser hier ermordert hat auch
   // noch tatsaechlich existieren.

   int i;

   if (i = sizeof(opfer))
   {
      for(; i--;)
	 if (!player_exists(opfer[i]))
	    opfer[i] = 0;
      opfer -= ({ 0 });
   }
   handle_m_v_item ();
}

private mixed limited_eval(closure cl, int evals)
{
    // Sprung ueber Unlimited machen, damit die verbrauchten
    // Evals nicht fuer den normalen Ablauf mitzaehlen.
    return limited( (: limited($1, ({$2})) :),
	({ LIMIT_UNLIMITED }), cl, evals);
}

nomask void setup_player()
{
    string nam, gilden_master_ob;
    int last_last_login, logon_mode;

    if (nam)
	return;

    heal = 0;
    auto_save = 15;
    last_time = time();
    nam = get_real_name();
    if (nam)
    {
	if (!guestp(this_object()) && !is_intermud_guest())
	    restore_object(PLAYER_FILE(nam));

        if(pid > 0)
        {
            // Player ID wird negativiert.
            // Bei der ersten Abfrage wird geprueft, ob die PID gueltig ist.
            pid = -pid;
        }

#ifdef PLAYER_DAY
        is_player_day = PLAYER_DAY;
#endif
	setup_colours();
	check_level();
        last_last_login = last_login;
	last_login = time();
	set_name(nam);
	if(lower_case(query_real_cap_name()) == nam) {
	    set_cap_name(query_real_cap_name());
	}
	set_short(0);
	set_id(nam);
	set_living_name(nam);
	set_personal(1);
        ::set_own_light(0);
        ::set_material(({"biologisch"}));
	set_show_align_title(0);
	set_transparent(1);
	set_min_damage(1);
	set_max_damage(5);
	if (temporal_adjektives) {
	    delete_adjektiv (temporal_adjektives);
	    temporal_adjektives = 0;
	}
	if(!wizp(this_object()) && query_invis()!=V_SHIMMER)
	    set_invis(V_VIS);
	set_prevent_cleanup();
	/* Goetter brauchen keinen heart_beat */
	if (query_level() < LVL_GESELLE || this_object()->query_telnet_ping())
	    set_heart_beat(1);
	set_msg_in(query_msg_in());
	set_msg_out(query_msg_out());
	set_mmsg_in(query_mmsg_in());
	set_mmsg_out(query_mmsg_out());
	set_msg_invis(query_msg_invis());
	set_msg_vis(query_msg_vis());
	set_sp_name("Zauberpunkte");
	set_sp_short_name("ZP");
	update_sum_skill();
	enable_commands();
	init_aliases();
	add_actions();
#if __EFUN_DEFINED__(set_is_wizard)
	/* Deactivate driver commands. */
	efun::set_is_wizard(me,0);
#endif
	if (query_wiz_level())
	{
	    define_wiz_commands();
	}
	else
	{
	    set_new_wiz_errors(0);
	    set_path_aliases(([]));
	}
	    
	telnet_neg::set_eor_protokoll(!query_client_option(CLIENT_NO_EOR));
	if (!is_intermud_guest())
	    telnet_neg::update_encoding();
	
	PLAYER_DELETER->unsuicide();
	event::setup_player();
	restore_properties();
	STATISTIK->process_logon(nam);
    // set_last_room wird in notify_moved_for_delayed_action miterledigt
    add_controller("notify_moved",#'notify_moved_for_delayed_action);
    add_controller("notify_move_failed",#'notify_move_failed_for_da);
	add_controller("notify_invis", #'aggression_invis);
	add_controller("notify_unshadow",
	    (: // $1: "notify_unshadow", $2: object shadow, $3: this_object()
		if($2 && function_exists("query_stat",$2))
		{
		    closure cl = 
			(:
			    update_max_sp();
			    update_max_hp();
			    update_max_encumbrance();
			:);
		    if(find_call_out(cl)<0)
			call_out(cl,0);
		}
	    :));
	if (query_wiz_level())
        limited_eval(#'load_auto_obj, 1000000);
    else
        limited_eval(#'load_auto_obj, 500000);
#ifdef PLAYER_NOTIFY_MODES
    logon_mode = get_logon_mode();
#endif
        if (gilden_master_ob = query_gilden_info(FILE_NAME))
        {
#ifdef PLAYER_NOTIFY_MODES
            limited_eval((: catch(
                gilden_master_ob->do_notify_login(this_object(),
                    NL_LOGON, logon_mode); publish
#else
            limited_eval((: catch(gilden_master_ob->do_notify_login(this_object(),0); publish
#endif
#if __VERSION__ > "3.3.560"
                , reserve 10000
#endif	        
                ) :), 200000);
        }
        else if(query_gilde())
	{
	    sys_log("OhneGilde", sprintf("%s: %O, %O\n", nam, query_gilde(), query_rang()));
	    internal_leave_gilde();
	}
#ifdef RETAIN_PLAYER_INVENTORY
	if (limited_eval(#'load_player_inv, 500000) && no_retain_messages)
	    write (no_retain_messages+"\n");
	no_retain_messages = 0;
#endif
	update_last_host();
	opfer_konsistenz();
	aggression_login();
	update_max_encumbrance();
	if (!player_age)
	    call_out(#'birth,2);
	if (query_wiz_level())
	    limited_eval((: clone_object("/obj/zauberstab")->move(this_object()) :),
		250000);
	call_out ("execute_login_command",4);
        if (!no_tips && (last_login-last_last_login>MIN_TIME_BETWEEN_TIPS))
            call_out ("get_tip",10);
#ifdef UNItopia
        if(spielerratp(this_object()) || adminp(this_object()))
            call_out ("srurne_info",16);
#endif
        if(wizp(this_object()) 
                && (last_login-last_last_login>WIZ_WIEDEREINSTIEG_TIME))
            call_out("msg_wiedereinstieg",20);
	PLAYER_ANNOYER->setup_player(this_object());
	init_webmud();
	init_webmud3();
	
	if(query_client_option(CLIENT_VT100))
	    start_mudclient();
	init_mxp();
	init_gmcp();
    call_out( function void () {
        process_gmcp(([ // Char.Name initially. (wizard)
            "name":query_real_cap_name(),
            "fullname":query_short(this_object()),
            "gender":query_real_gender(),
            "wizard":wizp(this_object()),
            ]),"Char","Name"); // Explain fields
        process_gmcp(([]),"Char","StatusVars"); // Explain fields once
        update_gmcp_guild_rank(); // Send Char.Status initially
        update_points_display(); // Stats and Vitals
        },2);
    }
}

nomask int query_prevent_shadow(object ob)
{
    if ((function_exists("receive_message", ob) ||
        function_exists("send_message", ob) ||
	function_exists("send_message_to", ob)) &&
	!MASTER_OB->mudlib_privilege_violation("receive_message", ob))
	    return 1;

    if (function_exists("query_magic_disguise",ob) &&
	!MASTER_OB->mudlib_privilege_violation("magic_disguise", ob))
	    return 1;

    if (function_exists("hp_sp_view", ob) &&
	!MASTER_OB->mudlib_privilege_violation("hp_sp_view_shadow", ob))
	    return 1;

    if (function_exists("query_one_description", ob) &&
	!MASTER_OB->mudlib_privilege_violation("query_one_description", ob))
	    return 1;

    return 0;
}

static int active_prompt;
static nomask void set_active_prompt(int i)
{
    active_prompt=i;
}

private nosave mapping ignored_actions =
    ([
	MA_LOOK: IGN_ACTIONS,
	MA_NOISE: IGN_ACTIONS,
	MA_FEEL: IGN_ACTIONS,
	MA_TASTE: IGN_ACTIONS,
	MA_SMELL: IGN_ACTIONS,
	MA_SENSE: IGN_ACTIONS,
	MA_EMOTE: IGN_SOUL,
	MA_WIELD: IGN_WEAPONS,
	MA_UNWIELD: IGN_WEAPONS,
	MA_WEAR: IGN_ACTIONS,
        MA_UNWEAR: IGN_ACTIONS,
	MA_EAT: IGN_ACTIONS,
	MA_DRINK: IGN_ACTIONS,
	MA_READ: IGN_ACTIONS,
    ]);

// Wird von receive_message und vom Master aufgerufen.
varargs void receive_message_low(string msg, mapping attributes)
{
    if(query_client_option(CLIENT_VT100))
	vt100client::receive_message_low(msg);
    else
    {
	if(active_prompt)
	{
    	    if(interactive())
                efun::tell_object(this_object(),"\n");
	    active_prompt=0;
	}
        if(interactive())
	    efun::tell_object(this_object(),msg);
    }
}

#if 0
nomask void catch_tell(string str)
{
    if (interactive())
    {
	if (query_wiz_level())	// Wegen zdbg
	    receive_message_low(str);
	else
	    efun::tell_object(this_object(),str);
    }
    else
	do_error("Aufruf von catch_tell: " + str + ".\n");
}
#endif

/*
FUNKTION: filter_message
DEKLARATION: int filter_message(int msg_type, int msg_action)
BESCHREIBUNG:
Diese Funktion wird aufgerufen, um herauszufinden ob eine Message vom
Spieler oder NPC empfangen werden darf. Es liefert 1, wenn die Meldung
unterdrueckt werden soll. Eine ueberlagernde Funktion sollte aber niemals
direkt 0 liefern, sondern den Aufruf an die ueberlagerten weiterreichen.

Um zu verhindern, dass ein Spieler z.B. etwas hoeren kann, ueberlagert
man filter_message folgendermassen:

int filter_message(int msg_type, int msg_action)
{
    if(msg_action == MA_EMOTE) // Kein Unfug heute.
	return 1;

    return query_shadow_owner()->filter_message(msg_type, msg_action);
}

VERWEISE: send_message, send_message_to, query_messages_filter
GRUPPEN: message, spieler, monster
*/
int filter_message(int msg_type, int msg_action)
{
    if(msg_type)
	return (msg_type & this_object()->query_messages_filter()) == msg_type;

    return 0;
}

int query_client_width();
protected int query_eye_description_width()
{
    return wizp(this_player()) ? query_client_width() : 75;
}

private string wrap_message(int msg_type, int msg_action, string msg)
{
    if(!sizeof(msg) || (msg_type & MT_NO_WRAP))
        return msg;

    // Pruefen, ob "\n[evntl. Escape-Sequenzen]" am Ende
    // Wir machen einen Kurztest, sonst spaeter einen via regexp.
    int hasr = member(msg, '\r') >= 0;

    if(!hasr && msg[<1] == '\n')
        return msg;

    if(hasr || rmember(msg, '\e') < 0 || !regmatch(msg, "\n(\e[\\[!0-9;]*[A-Za-z])*$"))
    {
        int width = wizp(this_player()) ? query_client_width() : 79;
        int indent = 0;

        if ((msg_type & MT_INDENT) || msg_action == MA_COMM)
            indent = 8;

        msg = terminal_colour(
            trim(regreplace(regreplace(msg, "(\n|)\r[\r\n]*", "\n", 1),
                "(\e(\\[[^a-zA-Z]*[a-zA-Z]|[A-Za-z]))|%\\^|\a", "%^\\1%^", 1), TRIM_RIGHT),
            function string(string str) { return str; }, width, indent);
        if(sizeof(msg) && msg[<1] != '\n')
            msg += "\n";
        return msg;
    }

    return msg;
}

private int filter_received_message(int msg_type, int msg_action, object who, string msg, mapping attributes)
{
    int ign;
    string verursacher;
    object owner;

    // Keine Meldung erhalten?
    if (!stringp(msg) || !strlen(msg))
        return 1;

    // Filter nach Message-Typ?
    if (this_object()->filter_message(msg_type & MT_MASK, msg_action))
        return 1;

    // MT_DEBUG an Nicht-Götter?
    if ((msg_type&MT_DEBUG) && !wizp(this_object()))
        return 1;

    // Ignore-Liste.
    if(objectp(who) && !living(who))
        owner = (({0})+filter(all_environment(who)||({}),#'living))[<1];

    if(playerp(who))
        ign=query_ignored_player(who->query_real_name());
    else if(playerp(owner))
        ign=query_ignored_player(owner->query_real_name());
    else if(who && !strstr(object_name(who),"/secure/udp/"))
    {
        string sender = who->query_current_sender();

        if(sender)
        {
            string name,mud;

            sscanf(sender, "%s@%s", name, mud);

            ign = query_ignored_player(sender)
                | query_ignored_player("@"+mud)
                | query_ignored_player(name+"@");
        }
    }
    else if(objectp(who) && playerp(environment(who)))
        ign=query_ignored_player(environment(who)->query_real_name());

    if(ign)
    {
        if(msg_type&MT_CHANNEL)
            ign &= IGN_SHOUT;
        else if(msg_action==MA_COMM)
            ign &= (msg_type&MT_FAR)?IGN_TELL:IGN_SAY;
        else
            ign &= ignored_actions[msg_action];
    }

    if(playerp(who))
        verursacher = who->query_real_name();
    else
    {
        verursacher = sprintf("%O",who);
        if(objectp(who) && !living(who))
        {
            if(playerp(owner))
                verursacher += " in " + owner->query_real_name();
            else if(owner)
                verursacher += " in " + add_commander(sprintf("%O",owner),owner);
            else if(playerp(this_player()))
                verursacher += " (TP: " + this_player()->query_real_name()+")";
            else if(this_player())
                verursacher += " (TP: " + add_commander(sprintf("%O",this_player()),this_player())+")";
        }
        else
            verursacher = add_commander(verursacher, who);
    }

    if(ign)
    {
        add_to_meldungspuffer("log", verursacher+"*", msg);
        return 1;
    }

#ifdef FILTER_MSG_BY_ATTRIBUTES
    if (mappingp(attributes) &&
        filter_msg_by_attributes(msg_type,msg_action,attributes,who,verursacher,msg))
    {
        return 1;
    }
#endif

    add_to_meldungspuffer("log", verursacher, msg);

    return 0;
}

private string process_received_message(int msg_type, int msg_action, string msg, mapping attributes)
{
    // Farb- und Soundtrigger anwenden.
    msg = process_trigger(msg);

    // Zeilenumbrüche einfügen.
    msg = wrap_message(msg_type, msg_action, msg);

    // Entsprechend Type einfärben.
    msg = colour_msg(msg_type,msg_action, msg);

    // Überlappende Farbcodes korrigieren.
    msg = process_color_savings(msg);

    // Soundchecker-Meldungen an SOUNDCHECK weitergeben.
    string sound = attributes && attributes[MSG_SOUND];
    if (sound && strstr(object_name(previous_object()),SC_SOUNDCHECKER)!=0)
    {
        // Nur wenn ueberhaupt ein Sound und
        // Nur wenn es nicht vom SC_SOUNDCHECKER kommt, dann registrieren
        SOUNDCHECK->register_soundfile(sound,SC_SOUNDFILE_PLAY);
    }

    // Temporäre MXP-Codes ersetzen bzw. entfernen.
    msg = process_mxp(msg, attributes);

    // Sound ausgeben.
    process_gmcp(attributes);

    // Umlauttransliteration korrigieren.
    if (has_only_ascii())
        msg = regreplace(msg, "[ÄÖÜ][a-zäöüß]", function string(string sub)
        {
            switch(sub[0])
            {
                case 'Ä':
                    return "Ae" + sub[1..];
                case 'Ö':
                    return "Oe" + sub[1..];
                case 'Ü':
                    return "Ue" + sub[1..];
            }
            return sub;
        }, 1);

    return msg;
}

varargs void receive_message(int msg_type, int msg_action, object who,
    string msg,mapping attributes)
{
    string processed_msg;

    if (filter_received_message(msg_type, msg_action, who, msg, attributes))
        return;

    processed_msg = process_received_message(msg_type, msg_action, msg, attributes);

    if(this_object()->is_intermud_guest())
        this_object()->send_intermud_msg(msg, processed_msg, msg_type, msg_action);
    else
        receive_message_low(processed_msg, attributes);

    if (msg_action == MA_COMM || msg_action == MA_EMOTE || (msg_type & MT_DEBUG))
    {
        string origin = objectp(who)?add_commander(Name(who),who):0;

        if (msg_action == MA_COMM && ((msg_type&MT_NOISE) || !(msg_type&MT_FAR)))
            this_object()->add_to_meldungspuffer("sage", origin, msg);
        else if (msg_action == MA_EMOTE)
            this_object()->add_to_meldungspuffer("seele", origin, msg);
        else if(msg_type&MT_DEBUG)
            this_object()->add_to_meldungspuffer("debug", origin, msg);

        this_object()->handle_gmcp_communication(msg_type,msg_action,msg,origin);
    }

}

void receive_notify_fail(string msg, object msgobj, object orig_cmd_giver)
{
#ifdef MT_FAIL
    this_object()->receive_message(MT_FAIL|MT_NOTIFY,MA_UNKNOWN,
        msgobj || this_object(),msg);
#else
    this_object()->receive_message(MT_NOTIFY,MA_UNKNOWN,
        msgobj || this_object(),msg);
#endif
}

// H_PRINT_PROMPT-Hook
void print_prompt(mixed prompt)
{
    if(is_intermud_guest())
        intermud::send_intermud_prompt(prompt);
    else if(!query_client_option(CLIENT_VT100) ||
	!vt100client::print_prompt(prompt))
	    telnet_neg::print_prompt(prompt);
}

// Sefun input_to
nomask int start_input_to(closure callback, mixed prompt, int flags)
{
    if(this_player()!=this_object())
        return 0;

    if((this_object()->query_client_option(CLIENT_VT100) && uses_vt100client())
    || is_intermud_guest())
        return input_to::start_input_to(callback, prompt, flags);
}

/*
FUNKTION: query_client_width
DEKLARATION: int query_client_width()
BESCHREIBUNG:
Diese Funktion liefert die Breite des MUD-Client-Fensters
zurueck, oder 0, falls sie unbekannt ist.
VERWEISE: query_client_height
GRUPPEN: spieler
*/
int query_client_width()
{
    mixed sb;

    if(client_width)
        return client_width;

    if(this_object()->query_telnet(TELOPT_NAWS,&sb) && sizeof(sb) > 1 && sb[0] > MIN_WIDTH)
        return sb[0];

    return MIN_WIDTH;
}

int query_set_client_width()
{
    return client_width;
}

static void set_client_width(int w)
{
    if(!w)
        client_width = 0;
    else if (w > 0)
        client_width = w < MIN_WIDTH ? MIN_WIDTH : w;
}

/*
FUNKTION: query_client_height
DEKLARATION: int query_client_height(int full)
BESCHREIBUNG:
Diese Funktion liefert die Anzahl an Zeilen des MUD-Client-Fensters 
urueck, oder 0, falls sie unbekannt ist. Falls full=1 so werden
fuer die getrennte Eingabezeile reserverte Bereiche ignoriert
(ansonsten bei full=0 von der tatsaechlichen Anzahl abgezogen).
VERWEISE: query_client_height
GRUPPEN: spieler
*/
int query_client_height(int full)
{
    mixed sb;
    int res = full?0:vt100client::query_reserved_height();
    
    if(this_object()->query_telnet(TELOPT_NAWS,&sb) && sizeof(sb) > 1 && sb[1] > res)
	return sb[1] - res;
    return 0;
}

nomask int query_client_options()
{
    if(extern_call() && wizardshellp(previous_object()))
	return client_options;
}

static nomask int query_client_option(int opt)
{
    return (client_options & opt) / (opt & -opt);
}

static nomask void set_client_option(int opt, int value)
{
    int old_option = client_options & opt;
    
    client_options = (client_options & ~opt) | ((value * (opt & -opt)) & opt);

    switch(opt)
    {
	case CLIENT_VT100:
	    if((value!=0) != (old_option!=0))
	    {
		if(value)
		    start_mudclient();
		else
		    stop_mudclient();
	    }
	    break;
	case CLIENT_VT100_NUMPAD:
	    if(client_options & CLIENT_VT100 &&
	       (value!=0) != (old_option!=0))
	    {
		if(value)
		    start_numpad();
		else
		    stop_numpad();
	    }
	    break;
	
	case CLIENT_NO_EOR:
	    telnet_neg::set_eor_protokoll(!value);
	    break;
    }
}

static nomask int query_player_flag(int bits)
{
    return (player_flags & bits) / (bits & -bits);
}

static nomask int set_player_flag(int bits, int value)
{
    player_flags = (player_flags & ~bits) | (( value * (bits & -bits)) & bits);
}

nomask int query_telnet_ping()
{
    if (!extern_call() || previous_object()==this_object() ||
	wizardshellp(previous_object()))
	return telnet_ping;
}

static nomask void set_telnet_ping(int tp)
{
    telnet_ping = tp;
}

nomask string query_usenet_email()
{
    if(previous_object() == this_object() ||
       member(({INEWSD, PLAYER_READER}), object_name(previous_object()))>=0)
	return usenet_email;
}

static nomask void set_usenet_email(string addr)
{
    usenet_email = addr;
}

int clear_command(string str)
{
     receive_message_low(VT_CLR_SCR VT_HOME);

     return 1;
}

/*
FUNKTION: query_messages_filter
DEKLARATION: int query_messages_filter()
BESCHREIBUNG:
Diese Funktion wird aufgerufen, um herauszufinden ob eine Message vom
Spieler empfangen werden darf.
Um zu verhindern, dass ein Spieler z.B. etwas hoeren kann, ueberlagert
man query_messages_filter() folgendermassen:

int query_messages_filter()
{
    return query_shadow_owner()->query_messages_filter() | MT_NOISE;
}
VERWEISE: send_message, send_message_to, filter_message
GRUPPEN: message, spieler
*/

#define SERVER_START_ROOM (STARTRAUM_SERVER->query_startraum(this_object()))

mixed get_start_room(string str)
{
    mixed * start;
    string * done;
    mixed tmp;
    object raum;
    int i;

    // Ist eine Sonderbehandlung erwuenscht?
    if(query_wiz_level() && str != "hier")
    {
        // Alter Startraum bleibt.
        return start_room;
    }

    // Ende stadt/start geht nur, wenn man
    // sich nicht im Todesraum aufhaelt.
    if((str == "stadt" || str == "start") &&
	(query_ghost()<=0 || !environment() || !environment()->query_death_room()))
    {
        // Startraum auf naechste Stadt / Start setzen.
        return (str == "stadt" ? SERVER_START_ROOM : 0);
    }

    // Startraum ermitteln.
    if(!environment())
    {
        // Ohne Umgebung kann man nichts machen.
        return SERVER_START_ROOM;
    }

#ifdef STATUE_ROOM
    if (object_name(environment()) == STATUE_ROOM)
        return start_room;
#endif

    // Umgebende Raeume sammeln.
    start = ({object_name(environment())});
    done = ({}); // Vermeidung von Endlosrekursion durch Startraum-Typen,
                 // die auf sich selbst oder gegenseitig aufeinander zeigen

    for(i = 0; i < sizeof(start); i++)
    {
        raum = 0;

        if(stringp(start[i]))
        {
            // Raumname "[modifier#]/pfad/zum/raum[#clonenummer]"
            // Falls geladen, Objektpointer suchen und Raumtypen beachten.
            raum = find_object(start[i][member(start[i],'/')..]);

            if(!raum)
                continue;
        }

        else if(objectp(start[i]))
        {
            raum = start[i];
            start[i] = object_time(raum) + "#" + object_name(raum);
        }

        if(!objectp(raum) || !raum->query_room())
        {
            // Kein Raum.
            continue;
        }

        // Hat der Raum einen Startraum gesetzt?
        // Nur einmal pro Raum abfragen, sonst Rekursionsgefahr,
        // wenn der Raum (indirekt) auf sich selbst verweist.
        if(member(done, object_name(raum)) == -1)
        {
            done += ({object_name(raum)});

            tmp = raum->query_type("startraum");

            if(tmp)
            {
                if(!pointerp(tmp))
                    tmp = ({tmp});

                // Diesen Raum loeschen.
                start[i] = 0;

                // Weitergehende Startraeume ueberschreiben.
                start[i+1..] = tmp;
                continue;
            }
        }

        // Darf man in diesem Raum gar nicht starten?
        tmp = raum->query_type("kein_startraum");

        if(tmp)
        {
            // Diesen Raum loeschen.
            start[i] = 0;
        }

        // Hat der Raum eine Umgebung?
        tmp = raum->query_room_environment(1);

        if(sizeof(tmp))
        {
            // Filtern und umwandeln.
            tmp = filter(tmp, function int (mixed room) 
                { 
                    return objectp(room) && room->query_room() 
                        && !room->query_type("kein_startraum"); 
                });
            tmp = map(tmp, (: clonep($1) ? $1 : object_name($1) :));

            // Was uebrig?
            if(sizeof(tmp))
            {
                // Die Umgebung als Alternative einfuegen.
                start[i+1..] = tmp + start[i+1..];
                continue;
            }
        }
    }

    // Alternativen zurueckliefern.
    start = start + ({SERVER_START_ROOM}) - ({0});

    // Default-Start-Room muss nicht mitgespeichert werden.
    if(sizeof(start) && start[<1] == DEFAULT_START_ROOM)
        start = start[..<2];

    if(sizeof(start) == 1)
        return start[0];

    return start;
}

static void move_to (object was, object zu_betrachtender_container, object wohin)
{
    int geschlossen;
    if (zu_betrachtender_container == wohin) {
	if (was->move (wohin) != MOVE_OK) {
	    was->remove ();
	    if (was) destruct (was);
	}
	return;
    }
    if (zu_betrachtender_container->query_con_close()) {
	zu_betrachtender_container->open_con();
	geschlossen = 1;
    }
    move_to (was, environment (zu_betrachtender_container), wohin);
    if (geschlossen)
	zu_betrachtender_container->close_con();
}


/*
FUNKTION: query_no_retain
DEKLARATION: string query_no_retain()
BESCHREIBUNG:
Antwortet ein Objekt auf die Frage query_no_retain() mit etwas anderem als 0,
so behaelt ein Spieler, der sich ausloggt, das Objekt nicht bei sich.
Wenn es moeglich ist, so wird es in den Raum gelegt, in welchem sich der
Spieler befindet, selbst dann, wenn der Spieler es in geschlossenen Taschen
oder Rucksaecken aufbewahrt. Ist dies aus irgendeinem Grunde nicht moeglich,
weil sich beispielsweise ein Container, in welchem sich das Objekt befindet,
nicht oeffnen laesst, so wird es zerstoert.
Der Rueckgabewert dieser Funktion ist ein String, welcher dem Spieler beim
naechsten Einloggen erklaeren soll, warum der Gegenstand weg ist.
Diese Funktion ist sehr sparsam einzusetzen und sollte wirklich nur fuer
ganz besondere Objekte verwendet werden. Also NICHT fuer besonders gute
Waffen. Es sollte dem Spieler, wenn er das Mud wieder betritt und den
Gegenstand nicht mehr vorfindet, logisch erscheinen, dass er weg ist.
So koennte man sich beispielsweise bei einer Taube, die der Spieler
genommen hat, vorstellen, dass sie weggeflogen ist.

Beispiel:
    string query_no_retain()
    {
	return "Die Taube scheint Dir davongeflogen zu sein.";
    }

Will man keine Meldung haben, aber dennoch erreichen, dass der Gegenstand nicht
behalten wird, so liefert man einfach "" als Antwort.

VERWEISE: notify_quit
GRUPPEN: spieler
*/

/*
NOENZY: notify_quit (veraltet, s.u.)
DEKLARATION: void notify_quit(object who, int flag)
BESCHREIBUNG:
Verlaesst ein Spieler das MUD so wird diese Funktion mit dem Spieler als
Parameter in allem, was er dabei hat, in allem, was in seiner Umgebung liegt,
in allen per add_follower eingetragenen Verfolgern, in allen fuer "notify_quit"
beim Spieler angemeldeten Controllern sowie in seiner Umgebung aufgerufen.
Diese Funktion wird auch aufgerufen, wenn die Statue eines Spielers
zerfaellt oder er sich suizidet.

Die Verfolger und damit der Aufruf dieser Funktion bei ihnen gelten als
veraltet. Man sollte die Controller dafuer nutzen.

Flag:
 0 : Spieler hat 'ende' eingegeben
 1 : Spieler war netztot und zerfaellt jetzt zu Staub
 2 : Spieler hat sich suizidet
VERWEISE: notify_net_dead, notify_login
GRUPPEN: spieler
*/

/*
FUNKTION: notify_quit
DEKLARATION: void notify_quit(object who, int flag, int mode)
BESCHREIBUNG:
Verlaesst ein Spieler das MUD so wird diese Funktion mit dem Spieler als
Parameter in allem, was er dabei hat, in allem, was in seiner Umgebung liegt,
in allen per add_follower eingetragenen Verfolgern, in allen fuer "notify_quit"
beim Spieler angemeldeten Controllern sowie in seiner Umgebung aufgerufen.
Diese Funktion wird auch aufgerufen, wenn die Statue eines Spielers
zerfaellt oder er sich suizidet.

Die Verfolger und damit der Aufruf dieser Funktion bei ihnen gelten als
veraltet. Man sollte die Controller dafuer nutzen.

Fuer Flag werden folgende Werte aus /sys/player.h genutzt:
 NQ_ENDE    : Spieler hat 'ende' eingegeben
 NQ_NETZTOT : Spieler war netztot und zerfaellt jetzt zu Staub
 NQ_SUIZID  : Spieler hat sich suizidet
Fuer Mode werden folgende Werte aus /sys/player.h verwendet:
  NQ_KEIN_ENDE     : Ein systemseitiges Beenden (siehe flag)
  NQ_ENDE_BLANK    : Ende wurde ohne Parameter angegeben.
  NQ_ENDE_STADT    : ende stadt wurde angegeben
  NQ_ENDE_START    : ende start wurde angegeben
  NQ_PORTAL_LEAVE  : Ein Spieler aus einem anderen Mud verlaesst dieses Mud.
  NQ_PORTAL_TRAVEL : Ein spieler aus diesem Mud reist in ein anderes Mud.
VERWEISE: notify_net_dead, notify_login
GRUPPEN: spieler
*/

int quit(string str)
{
    object home, *inv, invcontainer, *auto_loader;
    string name, ob_no_retainstring;
    int i, quit_mode;

    if(str && str != "hier" && str != "stadt" && str != "start"
#ifdef KULTURMARKT
       && str != "zkm"
#endif
#ifdef STATUE_ROOM
	&& !(str == "ende" && testplayerp(this_object()))
#endif
      )
    {
       notify_fail("'ende', 'ende hier', 'ende stadt' oder 'ende start'\n");
       return 0;
    }

    if (query_in_fight()) {
	write ("Dazu bist Du viel zu beschäftigt: Du kämpfst gerade.\n");
	return 1;
    }
    // delayed_action stoppen
    halt_delayed_action(DA_STOPPED);

    // Startraumgekroese
    start_room = get_start_room(str);

    // Playeraging
    query_age();
    last_login = time();
#ifdef PLAYER_NOTIFY_MODES 
    if (!extern_call() || strstr(object_name(previous_object()),
                            "/secure/portal"))
    {
        switch (str)
        {
        case "stadt": quit_mode = NQ_ENDE_STADT; break;
        case "start": quit_mode = NQ_ENDE_START; break;
        default:
            quit_mode = stringp(str) ? NQ_ENDE_BLANK : NQ_KEIN_ENDE;
        }
        // Bei ende_statue muss eine 1 angeeben werden...
        do_notify("quit", (!interactive(this_object()) 
                && previous_object(0)==this_object())?1:0,quit_mode);
    }
#else
    // Bei ende_statue muss eine 1 angeeben werden...
    do_notify("quit", (!interactive(this_object()) 
            && previous_object(0)==this_object())?1:0);
#endif
    aggression_logout();
    
#ifdef RETAIN_PLAYER_INVENTORY
    if ((str == "stadt") || (str == "start"))
    {
        if(!query_wiz_level() && query_sp() > 5)
            set_sp(5);
#ifdef PLAYER_NOTIFY_MODES
        set_logout_via_start_or_stadt(
            (str=="stadt") ? NQ_ENDE_STADT : NQ_ENDE_START);
#else
        set_logout_via_start_or_stadt(1);
#endif
    }
    else
    {
#ifdef PLAYER_NOTIFY_MODES
        set_logout_via_start_or_stadt(NQ_KEIN_ENDE);
#else
        set_logout_via_start_or_stadt(0);
#endif
    }
    
    // Meldungen
    if (!IS_INVIS(this_object()))
	this_object()->send_message(MT_LOOK,MA_MOVE_OUT,Der()+" hat "+MUD_NAME+" verlassen.\n");

    if (query_wiz_level())
	name = query_real_name();
    else
	name = testplayerp(this_object());

    if (name)
    {
	if(!player_exists(name) ||
	  catch(home = touch("/w/"+name+"/workroom", NO_WRITE)) || !home)
	    move("/room/void", ([MOVE_FLAGS: MOVE_FORCE|MOVE_SECRET]));
	else if(home != environment())
	    move(home, ([MOVE_FLAGS: MOVE_FORCE|MOVE_SECRET]));
    }

    if (!guestp(this_object()) && (!str || (str != "stadt" && str != "start")))
    {
        invcontainer = touch (PLAYER_INVENTORY_CONTAINER+query_real_name()) || environment();
        inv = deep_inventory();
        // Wie beim Einloggen muss man auch hier das max_enc auf 0 setzen, damit
        // man beliebig viele Sachen aufnehmen kann, um sie zu moven
        // siehe auch login::load_player_inv()
        call_out("update_max_encumbrance",0);
        for (i = sizeof(inv); i--; )
	    if (inv[i])
	        if (ob_no_retainstring = inv[i]->query_no_retain())
		{
    		    set_max_internal_encumbrance(0);
                    if (inv[i]) // es gibt Objekte, die sich im query_no_retain
                                // selbst zerstoeren, argl!
			move_to (inv[i],environment(inv[i]),environment());
		    if (stringp (ob_no_retainstring) && strlen (ob_no_retainstring))
		        no_retain_messages = (no_retain_messages||"")+wrap(ob_no_retainstring);
	        }

        update_max_encumbrance();
	do_save ();
        set_max_internal_encumbrance(0);

	auto_loader = query_auto_loading_objects ();
        inv = all_inventory() - auto_loader;
        for (i = sizeof(inv); i--; )
	    if (inv[i] && present(inv[i],this_object()))
	    {
		mixed state = inv[i]->get_object_state();
		if(!state)
		{
		    if(inv[i]->query_cloth())
			state = inv[i]->query_worn();
		    else if(inv[i]->query_weapon())
			state = inv[i]->query_wield();
		}

    		set_max_internal_encumbrance(0);
	        if (inv[i]->move(invcontainer) == MOVE_OK)
		    invcontainer->set_object_state(inv[i], state);
		else if (inv[i])
		    inv[i]->move(environment());
	    }
        // Encumbrance wieder zuruecksetzen
        update_max_encumbrance();
        remove_call_out("update_max_encumbrance");
    }
    else
    {
        do_save ();
	auto_loader = query_auto_loading_objects ();
    }
#else
    do_save ();
    auto_loader = query_auto_loading_objects ();
#endif

    // Logout
    if (me)
    {
        process_gmcp((["msg":"Auf Wiedersehen!"]),"Core","Goodbye");
        this_object()->send_message_to(me,MT_NOTIFY,MA_UNKNOWN,
            "Auf Wiedersehen!\n");
        
    }
        

    STATISTIK->process_logoff(query_real_name());
    if (interactive(this_object()))
        EVENT_MASTER->event("Logout", this_object());

#ifdef STATUE_ROOM
    if (query_wiz_level() || guestp(this_object()) ||
	(str == "ende" && name))
	return remove();
    else
    {
	if (str && str != "hier")
	{
	    inv = all_inventory() - auto_loader;
	    for (i = sizeof(inv); i--; )
		if (inv[i] && present(inv[i],this_object()))
		    inv[i]->move(environment());
	}
	move_to_statue_room();
	remove_interactive(this_object());
	return 1;
    }
#else
    for (i = 0; i < sizeof (auto_loader); i++)
        if (auto_loader[i])
            auto_loader[i]->remove ();
    return remove();
#endif
}

/*
FUNKTION: query_start_room
DEKLARATION: nomask mixed query_start_room()
BESCHREIBUNG:
Die Funktion liefert den zuletzt fuer den Spieler ermittelten Startraum.
Das ist entweder ein String (Objektname des Raumes) oder ein String-Array
(mehrere Startraum-Alternativen, die der Reihe nach durchprobiert werden).

Bei Spielern wird dieser Wert bei jedem Logout ueberschrieben.
Die Funktion dient nur zu Debugzwecken.
GRUPPEN: spieler
*/
nomask mixed query_start_room() { return start_room; }

/*
FUNKTION: set_start_room
DEKLARATION: void set_start_room(mixed start)
BESCHREIBUNG:
Diese Funktion setzt den Raum, in dem der Spieler das Spiel beginnt.

Der Wert wird beim Logout ueberschrieben und kann hoechstens in
notify_quit nochmals geaendert oder per Shadow beeinflusst werden.
Die Benutzung des Raumtyps "startraum" ist dem jedoch vorzuziehen.

Goetter koennen sich mit dieser Funktion einen neuen Default-Raum
setzen, wenn sie sich nicht extra dafuer mit 'ende hier' ausloggen
wollen.
GRUPPEN: spieler
*/
void set_start_room(mixed start) { start_room = start; }



static void reset_auto_save()
{
    // Nja eigentlich sind es ja 2 * auto_save Sekunden gewesen, aber da
    // es ja nur eine Vergleichsgroess ist, macht das nichts
    add_sum_weight(query_internal_encumbrance() * auto_save);
    auto_save = 0;
}

/* wird von heart_beat aufgerufen */
void saving()
{
    int  sut ;

    // nach reset_auto_save() verschoben
    // add_sum_weight(query_internal_encumbrance() * auto_save);
    update_stats();
    update_max_encumbrance();
    update_max_hp();
    update_max_sp();
    if ( (sut = query_skill_update_time()) && time() > sut )
    {
        update_sum_skill() ;
        reset_skill_update_time() ;
    }

    // Startraum aktualisieren
    if(environment())
    {
        start_room = get_start_room("");
    }

    do_save();
}

#if MAX_IDLE_TIME > 0 || MAX_WIZ_IDLE_TIME > 0
void reset() 
{
    object env;

    if ((env=environment(this_object())) &&
        env->query_no_idle_logout(this_object()) &&
        MASTER_OB->mudlib_privilege_violation("query_no_idle_logout", 
                                              env, this_object()))
        return;
 
    if (interactive(this_object()) &&
        ((MAX_IDLE_TIME && !query_wiz_level() &&
          query_idle(this_object()) > MAX_IDLE_TIME) ||
         (MAX_WIZ_IDLE_TIME && query_wiz_level() &&
          query_idle(this_object()) > MAX_WIZ_IDLE_TIME)))
    {
        this_object()->send_message_to(this_object(),MT_NOTIFY,MA_UNKNOWN,
            "Sorry, Du bist zu lange untätig.\n");
        saving();
        remove_interactive(this_object());
    }
    return; 
}
#endif

/* Wird alle 2 Sekunden vom Driver aufgerufen */
void heart_beat()
{
    // Damit der Idle-Check im query_age() klappt.
    query_age();
    if (!query_in_fight() && (++heal >= HEALING_TIME))
    {
	heal = 0;
	healing();
    }
    if (++auto_save >= SAVE_TIME)
	saving();
        // Idle-Statuen nach reset() wegen Goetter ohne HB
    if (++alignCounter >= 60)
    {
	alignCounter = 0;
	process_alignment();
    }
    handle_attack();
    if(query_client_option(CLIENT_VT100) && interactive())
	vt100client::heart_beat();
    if(telnet_ping)
    {
	telnet_ping_counter+=2;
	if(telnet_ping_counter>=telnet_ping)
	{
	    telnet_ping_counter=0;
	    send_telopt_tm();
	}
    }
}

/*
FUNKTION: query_additional_condition_string
DEKLARATION: string query_additional_condition_string()
BESCHREIBUNG:
Der Befehl 'spielstand' ruft diese Funktion im Player auf,
um zusaetzliche Infos, welche im Spielstand direkt unter der Ausdauerpunkte-
anzeige gezeigt werden sollen, abzufragen. Shadows koennen diese
Funktion ueberlagern, um selber Infos im sp unterzubringen.

Diese Funktion sollte sehr sparsam eingesetzt werden, so dass
sie eigentlich nur fuer Gildenshadows interessant ist.
GRUPPEN: spieler
*/

int score()
{
    int i, promille;
    string bday, hlpday, tmp;
    object sn;
    
    string text="";

    if (ghost)
	text+=wrap_say("Du bist "+capitalize(query_real_name())+" der Geist.","");
    else
	text+=wrap_say("Du bist "+add_dot_to_msg(
              (this_object()->query_personal() ?
                me->query_short(this_object()) : ein(this_object()))), "")
	    + (((tmp = get_align_string(this_object()->query_align())) && strlen(tmp)) ?
	      "Du bist "+tmp+".\n":"");
	     
#ifdef SHOW_EXPERIENCE_IN_PROMILLE
    promille = query_experience_promille();
    if(promille < 1000)
       text+="Du hast "+sprintf("%d,%d",promille/10,promille%10)+"% eines langen Weges zurückgelegt.\n";
    else if(!hlpp(this_object()) && !wizp(this_object()))
       text+=wrap("Du hast den langen Weg hinter dir und "
	     "der Erfahrung nach könntest du jetzt Engel werden "+
	     "("+sprintf("%d,%d",promille/10,promille%10)+"%).");
    else
       text+="Mit "+sprintf("%d,%d",promille/10,promille%10)
           + "% liegst du über dem Soll zur Engelswerdung.\n";
    text+="Du hast ";
#else
    text+="Du hast "+query_sum_skill()+" Erfahrungs-Punkte("+
	  TOTAL_EXPERIENCE+"),\n";
#endif
    text+=me->query_hp()+" Ausdauerpunkte("+me->query_max_hp()+") und "+
	  me->query_sp()+" "+me->query_sp_name()+"("+me->query_max_sp()+").\n";
	  
    text+=this_object()->query_additional_condition_string()||"";

    text+="Deine Fähigkeiten sind:\n";

    for(i=0; i < STAT_NUMBER; i++)
       text+=capitalize(STAT_NAMES[i])+": "+PRINT_STAT(me->query_stat(i, 1))
             +"   ";

    text+="\nGelöste Rätsel: "+query_quest_count()
        + "  Gelöste Spiele: "+query_game_count()
        + "  Getötete Wesen: "+query_kill_count();

    text+="\nAlter: "+format_seconds(query_age())+".";
    if(bday = query_birthday())
       text+="\nGeburtstag: "+bday+" (Spielzeit)";
    if(hlpday = query_hlpday())
       text+="\nEngelstag: "+hlpday;
    text+="\nFluchtmodus "+(me->query_whimpy()?"bei "+
	      me->query_whimpy()+" Ausdauerpunkten":"aus")+".\n"+
	  "Verteidigungsmodus "+(query_reattack()?"an":"aus")+".\n"+
	  (query_short_combat_msg()?"Kurze":"Lange")+" Kampfmeldungen.\n";
    if (wizp (this_object()))
        text+="Angreifbarkeit: "
        +(query_wants_to_get_attacked_by_monsters()
         ? "Aggressive Monster prügeln auf Dich ein.\n"
         : "Aggressive Monster lassen Dich in Frieden.\n");

    send_message_to(this_object(),MT_NOTIFY,MA_UNKNOWN, text);
    
    temperatur_meldung(0);
    if (query_alc() > 0)
	write("Du bist betrunken.\n");
    fp_meldung();
    wp_meldung();
    headache_meldung_sp();
#if __EFUN_DEFINED__(query_snoop)
    if((sn=query_snoop(this_object())))
#else
    if((sn=interactive_info(this_object(), II_SNOOP_NEXT)))
#endif
    {
	if(wizp(this_object()))
	    write("Du wirst von "+(sn->query_real_cap_name())+" beobachtet.\n");
	else
	    write("Du fühlst Dich von einem Gott beobachtet.\n");
    }
        aggression_meldung();
    return 1;
}

// Scars
/*
FUNKTION: query_scar_description
DEKLARATION: string query_scar_description()
BESCHREIBUNG:
Liefert einen String zurueck, der alle Narben des Spielers beschreibt.
VERWEISE: query_scar, make_scar, delete_scar
GRUPPEN: spieler
*/
string query_scar_description()
{
    int i, j, first, old_value;
    string descr, possessive;
    string *scar_desc;

    if (!scar)
	return 0;
    scar_desc = ({ "em linken Fuß","em rechten Fuß","er Nase","em linken Arm",
		   "em rechten Arm","er linken Hand", "er rechten Hand",
		   "er Stirn","er linken Wange","er rechten Wange" });
    j = 1;
    first = 1;
    old_value = scar;
    possessive = this_object()->query_gender() == "weiblich" ? "ihr" : "sein";
    while(i < MAX_SCAR)
    {
	if (scar & j)
       	{
	    old_value &= ~j;
	    if (first)
	    {
		descr = Er()+" hat eine Narbe auf "+possessive+scar_desc[i];
		first = 0;
	    }
	    else if (old_value)
		descr+=", "+possessive+scar_desc[i];
	    else
		descr+=" und "+possessive+scar_desc[i];
	}
	j *= 2;
	i += 1;
    }
    return wrap(descr + ".");
}

/*
FUNKTION: query_scar
DEKLARATION: int query_scar()
BESCHREIBUNG:
query_scar Liefert eine Zahl zurueck, in der die Narben eines Spielers
bitweise codiert sind. Es sind maximal 10 Narben moeglich, d.h. ein Spieler
mit 10 Narben liefert auf player->query_scar() 2 hoch 9 zurueck.
VERWEISE: query_scar_description, make_scar, delete_scar
GRUPPEN: spieler
*/
int query_scar() { return scar; }

/*
FUNKTION: make_scar
DEKLARATION: void make_scar()
BESCHREIBUNG:
Setzt zufaellig eine neue Narbe an dem Spieler.
VERWEISE: query_scar, delete_scar, query_scar_description
GRUPPEN: spieler
*/
void make_scar() { scar |= 1 << random(MAX_SCAR); }

/*
FUNKTION: delete_scar
DEKLARATION: void delete_scar(int Nummer)
BESCHREIBUNG:
delete_scar loescht eine Narbe an der Bitposition Nummer, d.h., wenn ein
Spieler query_scar() 8 hat, dann kann man diese eine Narbe mit
delete_scar(4) loeschen.
VERWEISE: query_scar, make_scar, query_scar_description
GRUPPEN: spieler
*/
void delete_scar(int i) { scar &= ~(1 << i-1); }


/* ================= Kompatibilitaetsfunktionen =================== */
// (Werden von der Mudlib selbst nicht genutzt.)

// Liefert alle meine Opfer zurueck...
string *query_aggression_victims()
{
    return m_indices(filter(opponents,(:$1[OPP_FLAGS]&TO_IS_AGGRESSOR:)));
}

// Fuer die Vertrauten zur Erkennung einer Notwehrsituation
// Liefert den Namen des Commanders, falls ein Commander den Kampf startete.
// Ansonsten 0.
string query_fight_initiator(object monster)
{
    return critters[monster,CR_COMMANDER];
}

/* ================== Dateninterface & Protokoll ================== */
/* 
   DIE FUNKTIONEN IN DIESEM ABSCHNITT SIND NUR FUER INTERNE ZWECKE,
   SIE SOLLTEN NUR VON PLAYER-OBJEKTEN AUFGERUFEN WERDEN!       
*/

// Also grundsaetzlich sollten sich die Eintraege in 'opponents' bei mir
// und beim Gegner (bis auf Bit 0) gleichen. Die einzige Ausnahme gilt,
// wenn der Gegner ausgeloggt ist. Dann wird Bit 4 gesetzt und die
// Aenderung dann beim eigenen Logout zurueckgeschrieben oder dem
// Gegner bei seinem Login mitgeteilt.

// Lesend duerfen alle Funktionen direkt auf die Daten zugreifen.
// Zum aendern der Daten sollte change_aggression_data genutzt werden:
// (Ausnahme: Login/Logout-Funktionen)

private void change_aggression_data(string name, int command)
{
    int timeout = -1, flags;
    object opp = find_player(name);
    
    if(command != LEFT_ROOM || !member(opponents, name) ||
	!(opponents[name, OPP_FLAGS]&((flags&TO_IS_AGGRESSOR)?AGG_LEFT_ROOM:VIC_LEFT_ROOM)))
	    AGGLOG(sprintf("change_aggression_data(%O,%x)", name, command));
    
    if(command&REMOVE_OPPONENT)
    {
	if(opp)
	{
	    opp->accept_aggression_data(-1,0);
	    m_delete(opponents, name);
	}
	else if(member(opponents, name))
	    m_add(opponents, name, -1, DIRTY|TIMEOUT_STOPPED);
	return;
    }

    if(member(opponents, name))
    {
	timeout = opponents[name, OPP_TIMEOUT];
	flags = opponents[name, OPP_FLAGS];
    }
    else if(!FIGHTER_AVAILABLE(opp,0))
	flags = TIMEOUT_STOPPED;
    
    if((command&CHANGE_TIMEOUT_STATUS) &&
	((flags^command)&TIMEOUT_STOPPED))
    {
	if(flags&TIMEOUT_STOPPED)
	{
	    flags&=~TIMEOUT_STOPPED;
	    timeout += time();
	}
	else
	{
	    flags|=TIMEOUT_STOPPED;
	    timeout -= time();
	}
    }
    
    if(command&FULL_TIMEOUT)
    {
	if(command&SILENT)
	{
	    if(timeout<0) flags|=SILENT;
	}
	else if(timeout>=0)
	    flags&=~SILENT;
	    
	flags&=~(FIGHT_STOPPED|AGG_LEFT_ROOM|VIC_LEFT_ROOM);

	timeout = ((flags&TIMEOUT_STOPPED)?0:time()) + AGGRESSION_TIMEOUT;
    }
    else if((command&INC_TIMEOUT) && !(flags&TIMEOUT_STOPPED))
    {
	if(command&SILENT)
	{
	    if(timeout<0) flags|=SILENT;
	}
	else if(timeout>=0)
	    flags&=~SILENT;

	flags&=~(FIGHT_STOPPED|AGG_LEFT_ROOM|VIC_LEFT_ROOM);

	timeout = min(time()+AGGRESSION_TIMEOUT, timeout+10);
    }
	
    if(command&CHANGE_AGGRESSOR)
	flags = (flags&~TO_IS_AGGRESSOR)|(command&TO_IS_AGGRESSOR);
    if(command&CHANGE_REVENGE)
	flags = (flags&~REVENGE)|(command&REVENGE);
    if(command&LEFT_ROOM)
	flags|=(flags&TO_IS_AGGRESSOR)?AGG_LEFT_ROOM:VIC_LEFT_ROOM;
    if((command&STOP_FIGHT) ||
	(flags&(AGG_LEFT_ROOM|VIC_LEFT_ROOM))==(AGG_LEFT_ROOM|VIC_LEFT_ROOM))
	flags=(flags|FIGHT_STOPPED)&~(AGG_LEFT_ROOM|VIC_LEFT_ROOM);

    if(timeout<1)
    {
	if(opp)
	{
	    opp->accept_aggression_data(-1,0);
	    m_delete(opponents, name);
	}
	else
	    m_add(opponents, name, -1, TIMEOUT_STOPPED);
    }
    else
    {
	if(!opp)
	    flags|=DIRTY;
	else
	    opp->accept_aggression_data(timeout, flags^TO_IS_AGGRESSOR);

        m_add(opponents, name, timeout, flags);
    }
}

nomask void accept_aggression_data(int timeout, int flags)
{
    if(!playerp(previous_object()))
	return;

    if(timeout<0)
	m_delete(opponents, previous_object()->query_real_name());
    else
	m_add(opponents, previous_object()->query_real_name(), timeout, flags);
}

// Testet, ob die Timeouts schon abgelaufen sind.
// Bei big=1: grosser Konsistenzcheck (Test, ob Spieler noch existiert
// und ob die Daten uebereinstimmen (falls nicht, wird dies geloggt.))
private void aggression_consistency(int big)
{
    foreach(string name, int timeout, int flags: opponents)
	if(!(flags&TIMEOUT_STOPPED) && timeout<=time())
	    change_aggression_data(name, REMOVE_OPPONENT);

    if(!big)
	return;
	
    opponents=filter(opponents,#'player_exists);
    foreach(string name, int timeout, int flags: opponents)
    {
        object enemy = find_player(name);
	if(enemy)
	{
	    mixed data = enemy->aggression_data(query_real_name());
	    if(!data) // Wir gehen mal von einem Suizid aus.
	    {
		sys_log("Aggression",
		    sprintf("[%s] %s <-> %s: (%d, %d) <-> (-)\n",
		    shorttimestr(time()), query_real_name(), name, timeout, flags));
		change_aggression_data(name, REMOVE_OPPONENT);
	    }
	    else if(data[OPP_TIMEOUT] != timeout || data[OPP_FLAGS] != (flags^TO_IS_AGGRESSOR))
		sys_log("Aggression",
		    sprintf("[%s] %s <-> %s: (%d, %d) <-> (%d, %d)\n",
		        shorttimestr(time()), query_real_name(), name,
		        timeout, flags, data[OPP_TIMEOUT], data[OPP_FLAGS]));
	    else if( ((flags&TIMEOUT_STOPPED)?0:1)!=(
			    FIGHTER_AVAILABLE(this_object(),flags) &&
			    FIGHTER_AVAILABLE(enemy,flags^TO_IS_AGGRESSOR) && 1))
	    {
		object sh;
		sys_log("Aggression",
	    	    sprintf("[%s] %s <-> %s: Timeout wurde %sgestoppt (%d, %d).\n"
			    "                    %s: Invis: %d, Interactive: %O, Statue: %O, Kämpfen-verboten: %O (%s) -> %O\n"
			    "                    %s: Invis: %d, Interactive: %O, Statue: %O, Kämpfen-verboten: %O (%s) -> %O\n",
	    	    shorttimestr(time()), query_real_name(), name,
		    (flags&TIMEOUT_STOPPED)?"":"nicht ", timeout, flags,
		    query_real_name(), query_invis(), interactive(this_object()), this_object()->id("statue"), environment() && !environment()->query_type("kaempfen_verboten"),
		    environment() && object_name(environment()),
		    FIGHTER_AVAILABLE(this_object(),flags),
		    name, enemy->query_invis(), interactive(enemy), enemy->id("statue"), environment(enemy) && !environment(enemy)->query_type("kaempfen_verboten"),
		    environment(enemy) && object_name(environment(enemy)),
		    FIGHTER_AVAILABLE(enemy,flags^TO_IS_AGGRESSOR)
		));
		sh = environment();
		if(sh) while(sh=shadow(sh,0))
		    sys_log("Aggression",
			sprintf("                    Shadow bei %s: %s\n",
			    query_real_name(), object_name(sh)));
		    
		sh = environment(enemy);
		if(sh) while(sh=shadow(sh,0))
		    sys_log("Aggression",
			sprintf("                    Shadow bei %s: %s\n",
			    name, object_name(sh)));
	    }
	    
	}
	else if(!(flags&TIMEOUT_STOPPED))
	    sys_log("Aggression",
	        sprintf("[%s] %s <-> %s: Timeout wurde nicht gestoppt (%d, %d).\n",
	        shorttimestr(time()), query_real_name(), name, timeout, flags));
    }
}

mixed aggression_data(string name)
{
    return m_entry(opponents, name);
}

private void single_aggression_check(string name, object ob)
{
    int flags, timeout;
    if(!member(opponents, name))
	return;
	
    if(!player_exists(name))
    {
	m_delete(opponents, name);
	return;
    }
    
    timeout = opponents[name, OPP_TIMEOUT];
    flags = opponents[name, OPP_FLAGS];
    
    if(!(flags&TIMEOUT_STOPPED) && timeout<=time())
    {
	change_aggression_data(name, REMOVE_OPPONENT);
	return;
    }

    if(!objectp(ob))
	return;
	
    mixed data = ob->aggression_data(query_real_name());
    if(!data)
    {
	sys_log("Aggression",
	    sprintf("[%s] %s <-> %s: (%d, %d) <-> (-)\n",
	    shorttimestr(time()), query_real_name(), name,
	    timeout, flags));
	// Vermutlich Suizid
	change_aggression_data(name, REMOVE_OPPONENT);
    }
    else if(data[OPP_TIMEOUT] != timeout ||
	    data[OPP_FLAGS] != (flags^TO_IS_AGGRESSOR))
	sys_log("Aggression",
	    sprintf("[%s] %s <-> %s: (%d, %d) <-> (%d, %d)\n",
		shorttimestr(time()), query_real_name(), name, timeout, flags,
		data[OPP_TIMEOUT], data[OPP_FLAGS]));
}

private void clean_critters()
{
    critters = filter(critters, (: $2[CR_LAST_HIT] + CRITTERS_TIMEOUT > time() :));
}

// ===== Interface fuer die Mudlib =====

// Wird vom add_hp aufgerufen. Interface auch fuer Zaubersprueche etc.
// Mir wurde gerade wehgetan.
/*
FUNKTION: become_aggression_victim
DEKLARATION: nomask varargs void become_aggression_victim(mixed aggressor, int flags)
BESCHREIBUNG:

ACHTUNG: Aufrufe dieser Funktion muessen mit den Admins abgestimmt werden!

Diese Funktion wird im Spieler aufgerufen, wenn er Opfer eines Angriffs
von aggressor wurde. Sie dient lediglisch zur Buchfuehrung fuer die
(M)-Regelung. aggressor kann ein String (real_name oder real_cap_name eines
Spielers) oder ein Objekt sein. Falls dieses Objekt kein Spieler ist,
wird geprueft, ob dieses Objekt von einem Spieler kontrolliert wurde.

Es koennen folgende Flags (definiert in add_hp.h) angegeben werden:
    AG_SILENT	Die Spieler erhalten keine Meldung ueber diesen Angriff
		in der Spieltstandanzeige. (Dies ist fuer Angriffe,
		bei denen der Angreifer nicht offensichtlich ist.)
VERWEISE: add_hp, query_commander
GRUPPEN: spieler, kampf
*/
nomask varargs void become_aggression_victim(mixed aggressor, int avflags)
{
    string name;
    object enemy;
    int myflags = (avflags&AG_SILENT)?SILENT:0;

    if(!objectp(aggressor) || (playerp(aggressor) && aggressor!=this_object()) ||
	aggressor->query_commander())
	AGGLOG(sprintf("become_aggression_victim(%O,%x)", aggressor, avflags));

    clean_critters();
    if(objectp(aggressor) && living(aggressor) && !playerp(aggressor))
    {
	if(member(critters, aggressor))
	    critters[aggressor, CR_LAST_HIT] = time();
	else
	{
	    string commander = aggressor->query_commander();
	    if(!commander)
	    {
		// Kein Commander, schauen wir sicherheitshalber mal
		// in den command_stack...
		mixed stack = efun::command_stack();
		if(sizeof(stack) && playerp(stack[0][CMD_PLAYER]))
		    commander = stack[0][CMD_PLAYER]->query_real_cap_name();
	    }
	    m_add(critters, aggressor, time(), commander);
	}
    }

    // So erstmal schauen, was wir haben:
    if(stringp(aggressor))
    {
	name = lower_case(aggressor);
	if(!player_exists(name))
	    return;
	enemy = find_player(name);
    }
    else if(!objectp(aggressor))
	return;
    else if(playerp(aggressor))
    {
	enemy = aggressor;
	name = enemy->query_real_name();
    }
    else
    {
	// Viehzeug.
	name = critters[aggressor, CR_COMMANDER];
	if(!stringp(name))
	    return;
	name = lower_case(name);
	if(!player_exists(name))
	    return;
	enemy = find_player(name);
	if(aggressor->query_animal()<=0)
	    myflags |= SILENT;
    }

    if (enemy == this_object())
	return;

    /* In der Arena ignorieren wir Angriffe. */
    if(environment() && enemy && environment(enemy) &&
       environment()->query_type("arena") &&
       environment(enemy)->query_type("arena"))
        return;

    single_aggression_check(name, enemy);
    
    if(!member(opponents, name) ||
	opponents[name, OPP_TIMEOUT]<0)
    {
	// Wir sind zum ersten Mal Opfer...
	change_aggression_data(name, FULL_TIMEOUT|BECOME_VICTIM|myflags);
	
#ifndef TestMUD
	if(!wizp(this_object()) && !testplayerp(this_object()) &&
	   enemy && !wizp(enemy) && !testplayerp(enemy) &&
	   !this_object()->query_player_flag(PF_NO_UEBERFALL_MSG))
#endif
	    EVENT_MASTER->event("Ueberfall", enemy, 0, this_object());
    }
    else if(opponents[name, OPP_FLAGS]&FIGHT_STOPPED)
    {
	// In einem neuen Raum, also in einem neuen Kampf.
	if(opponents[name, OPP_FLAGS]&TO_IS_AGGRESSOR)
	    // Ich bin auf einmal Opfer
	    change_aggression_data(name, FULL_TIMEOUT|BECOME_VICTIM|SET_TO_REVENGE|myflags);
	else
	    // Der Aggressor fuehrt den Kampf einfach weiter
	    change_aggression_data(name, FULL_TIMEOUT|myflags);
    }
    else if(opponents[name, OPP_FLAGS]&TO_IS_AGGRESSOR)
    {
	// Mein Opfer verteidigt sich.
	change_aggression_data(name, INC_TIMEOUT|myflags);
    }
    else
    {
	// Der Aggressor schlaegt wiederholt zu.
	change_aggression_data(name, FULL_TIMEOUT|myflags);
    }

    if(!objectp(aggressor) || (playerp(aggressor) && aggressor!=this_object()) ||
	aggressor->query_commander())
	AGGLOG(sprintf("become_aggression_victim(%O,%x)-Ende", aggressor, avflags));
}

// Wird vom gegnerischen add_hp aufgerufen...
nomask void check_aggression(object viech)
{
    clean_critters();
    if(playerp(viech) || !living(viech))
	return;

    if(member(critters, viech))
	critters[viech, CR_LAST_HIT] = time();
    else
	m_add(critters, viech, time(), 0); // 0, da wir angegriffen haben.
}


void aggression_invis(string controller, object who, int alt, int neu)
{
    foreach(string name, int timeout, int flags:opponents)
    {
	int cmd;
	if(!(flags&TIMEOUT_STOPPED) &&
	    (!FIGHTER_AVAILABLE(this_object(),flags) ||
	     !FIGHTER_AVAILABLE(find_player(name),flags^TO_IS_AGGRESSOR)))
	    cmd |= STOP_TIMEOUT;
	else if((flags&TIMEOUT_STOPPED) &&
	    FIGHTER_AVAILABLE(this_object(),flags) &&
	    FIGHTER_AVAILABLE(find_player(name),flags^TO_IS_AGGRESSOR))
	    cmd |= CONTINUE_TIMEOUT;
	if(cmd)
	    change_aggression_data(name, cmd);
    }
}

void just_moved()
{
    // Kampf beenden.
    foreach(object enemy:query_hand_enemies())
        if(playerp(enemy))
        {
            delete_enemy(enemy);
            enemy->delete_enemy(this_object());
        }
    ::just_moved();
    
    foreach(string name, int timeout, int flags:opponents)
    {
	int cmd;
	if(!(flags&FIGHT_STOPPED))
	    cmd |= LEFT_ROOM;
	if(!(flags&TIMEOUT_STOPPED) &&
	    (!FIGHTER_AVAILABLE(this_object(),flags) ||
	     !FIGHTER_AVAILABLE(find_player(name),flags^TO_IS_AGGRESSOR)))
	    cmd |= STOP_TIMEOUT;
	else if((flags&TIMEOUT_STOPPED) &&
	    FIGHTER_AVAILABLE(this_object(),flags) &&
	    FIGHTER_AVAILABLE(find_player(name),flags^TO_IS_AGGRESSOR))
	    cmd |= CONTINUE_TIMEOUT;
	if(cmd)
	    change_aggression_data(name, cmd);
    }

    gmcp_send_room_info();
}

/*
FUNKTION: ist_notwehr
DEKLARATION: private int ist_notwehr(mixed gegner)
BESCHREIBUNG:
Diese Funktion wird aufgerufen, wenn die Todesursache bzw. Todesmeldung
ermittelt werden muss. Sie schaut, ob dieser Spieler in Notwehr von gegner
getoetet wurde.

Rueckgabewert:
 0: Keine Notwehr (ob hat angegriffen)
 1: Notwehr (ich habe angegriffen)
 2: Rache (ob hat angegriffen, ich aber davor mal)
 3: Racheversuch (ich habe angegriffen, ob aber davor mal)
VERWEISE: add_hp, die, become_aggression_victim
GRUPPEN: Root:Player:Tod
*/
private int ist_notwehr(mixed ob)
{
    string name;
    if(playerp(ob))
	name = ob->query_real_name();
    else if(stringp(ob))
	name = lower_case(ob);
    else
	return 0;
    
    single_aggression_check(name, find_player(name));

    if(!member(opponents, name) ||
	opponents[name, OPP_TIMEOUT]<0)
	    return 0;
    
    return member(
	({0, TO_IS_AGGRESSOR, REVENGE, TO_IS_AGGRESSOR|REVENGE}),
	opponents[name, OPP_FLAGS]&(TO_IS_AGGRESSOR|REVENGE));
}

// Wird beim Logout (vorm Abspeichern) aufgerufen.
protected void aggression_logout()
{
    aggression_consistency(0);
    foreach(string name, int timeout, int flags: opponents)
    {
	object ob = find_player(name);
	if(!(flags&TIMEOUT_STOPPED))
	    m_add(opponents, name, timeout-=time(),
		    flags|=TIMEOUT_STOPPED);
	if(ob)
	    ob->accept_aggression_data(timeout, flags^TO_IS_AGGRESSOR);
	else if(flags&DIRTY)
	{
	    flags&=~DIRTY;
	    opponents[name, OPP_FLAGS] = flags;
	    PLAYER_MODIFIER->accept_aggression_data(name, timeout, flags^TO_IS_AGGRESSOR);
	    if(timeout<0)
		m_delete(opponents, name);
	}
    }
    
    // Wir speichern die Viecher...
    saved_critters = ([:2]);
    clean_critters();
    foreach(object ob, int last_hit, string comm: critters)
	m_add(saved_critters, object_name(ob), time()-last_hit, comm);
}

// Wird nach dem Laden des Playerfiles / Wiedererwachen einer Statue aufgerufen
protected void aggression_login()
{
    object pl;
    string *eingeloggt=({});

    foreach(string name, int timeout, int flag: opponents)
        if(!player_exists(name))
	    m_delete(opponents, name);
        else if(pl=find_player(name))
        {
	    mixed data = pl->aggression_data(query_real_name());
	    if(!data)
	    {
		m_delete(opponents, name);
		continue;
	    }
	    if(data[OPP_TIMEOUT]<0)
	    {
		m_delete(opponents, name);
		pl->accept_aggression_data(-1,0);
		continue;
	    }
	    
	    if(FIGHTER_AVAILABLE(pl,flag^TO_IS_AGGRESSOR) &&
	       FIGHTER_AVAILABLE(this_object(), flag))
	    {
		if(flag&(TO_IS_AGGRESSOR|REVENGE))
		    data[OPP_TIMEOUT] = time()+AGGRESSION_TIMEOUT;
		else if(data[OPP_FLAGS] & TIMEOUT_STOPPED)
		    data[OPP_TIMEOUT] += time();
		data[OPP_FLAGS] &= ~TIMEOUT_STOPPED;
	    }
	    else if(flag&(TO_IS_AGGRESSOR|REVENGE))
	    {
		data[OPP_TIMEOUT] = AGGRESSION_TIMEOUT;
		data[OPP_FLAGS] |= TIMEOUT_STOPPED;
	    }
	    
	    m_add(opponents, name, data[OPP_TIMEOUT], data[OPP_FLAGS]^TO_IS_AGGRESSOR);
	    pl->accept_aggression_data(data[OPP_TIMEOUT], data[OPP_FLAGS]);
	    
	    if(interactive(pl))
	    {
		// Nachricht an Gegner, falls er sich raechen darf.
        	if(data[OPP_FLAGS]&(TO_IS_AGGRESSOR|REVENGE))
        	    send_message_to(pl,MT_NOTIFY,MA_FIGHT, wrap("Achtung: " +
            		Wer(this_object(),ART_VIS)+" betritt "+MUD_NAME+"."));
	    
		// Nachricht an mich, falls ich mich raechen darf.
		if(!(data[OPP_FLAGS]&TO_IS_AGGRESSOR) ||
		    (data[OPP_FLAGS]&REVENGE))
            		eingeloggt+=({wer(pl,ART_VIS)});
	    }
        }
	else if(flag&(TO_IS_AGGRESSOR|REVENGE))
	{
	    opponents[name,OPP_TIMEOUT] = AGGRESSION_TIMEOUT;
	    opponents[name,OPP_FLAGS] |= TIMEOUT_STOPPED|DIRTY;
	}

    if(sizeof(eingeloggt))
        send_message_to(this_object(),MT_NOTIFY,MA_FIGHT, wrap("Achtung: " +
            capitalize(liste(eingeloggt))+
	    (sizeof(eingeloggt)>1?" befinden sich in ":" befindet sich in ")+
	    MUD_NAME+"."));

    // Wir holen die gespeicherten Viecher zurueck...
    if(saved_critters)
	foreach(string obname, int last_hit, string comm: saved_critters)
	{
	    object ob = find_object(obname);
	    if(ob && !member(critters, ob))
		m_add(critters, ob, time()-last_hit, comm);
	}
}

private string aggression_tarn_string(object pl, string str)
{
    if(member(regexplode(lower_case(str), "\\<|\\>"), pl->query_real_name())<0)
	return pl->query_real_cap_name()+" getarnt als " + str;
    return str;
}

// Gibt die Meldung fuer den Spielstand aus.
void aggression_meldung()
{
    string str="";
    string *personen=({}),*offline_personen=({}),*opfer=({});

    aggression_consistency(1);
    
    // M-loser Kampf als Rachemoeglichkeit anzeigen.
    foreach(string name, int timeout, int flags: opponents)
    {
	object pl = find_player(name);
	if(timeout<0 || (flags&SILENT))
	    continue;
        else if((flags&REVENGE) || !(flags&TO_IS_AGGRESSOR))
        {
	    if(!pl || !interactive(pl))
	    {
        	offline_personen+=({capitalize(name)});
	    }
	    else
	    {
		int vl;
        	if(pl->query_moerder())
            	    continue;

        	vl = ((flags&TIMEOUT_STOPPED)?timeout:(timeout-time()))*TIMEWARP/60;
        	if(vl)
            	    personen+=({ ((vl==1)?"eine Minute an ":(vl+" Minuten an "))+
                	(pl?aggression_tarn_string(pl,wem(pl,ART_EIN|ART_VIS,({})))
			   :capitalize(name)) });
	    }
	    if(flags&REVENGE)
        	opfer+=({ (pl?aggression_tarn_string(pl,wer(pl,ART_EIN|ART_VIS,({})))
			     :capitalize(name)) });
        }
        else
            opfer+=({ (pl?wer(pl,ART_VIS,({})):capitalize(name)) });
    }

    if(sizeof(personen) + sizeof(offline_personen))
    {
        str+="Du darfst Dich noch ";
        if(sizeof(personen))
        {
            str+=liste(sort_array(personen,#'>));
            if(sizeof(offline_personen))
                str+=" und ";
        }
        if(sizeof(offline_personen))
            str+="an "+liste(sort_array(offline_personen,#'>));
        str+=" rächen.";
    }
    if(!query_moerder() && sizeof(opfer))
    {
        if(strlen(str)) str+=" ";
        str+=capitalize(liste(sort_array(opfer,#'>)))+
            (sizeof(opfer)>1?" dürfen":" darf")+" noch zurückschlagen.";
    }
    if(strlen(str))
        send_message_to(this_object(),MT_NOTIFY,MA_UNKNOWN,wrap(str));
}

private int abandon_revenge(string* which)
{
    string* names;
    
    aggression_consistency(1);
    
    if(!sizeof(which))
	names = m_indices(filter(opponents,
	    (: $2[OPP_TIMEOUT] > 0 && !($2[OPP_FLAGS]&SILENT) &&
	       (!($2[OPP_FLAGS]&TO_IS_AGGRESSOR) || $2[OPP_FLAGS]&REVENGE)
	    :)));
    else
    {
	which -= ({"an","am","auf","und",",","den","dem","das","die"});
	names = ({});
	foreach(string str: which)
	    if(!player_exists(str))
		return notify_fail("An wem willst Du Dich nicht mehr rächen?\n",
		    FAIL_NOT_OBJ);
	    else if(member(opponents, str) &&
		opponents[str,OPP_TIMEOUT] > 0 &&
		!(opponents[str, OPP_FLAGS]&SILENT) &&
	        (!(opponents[str, OPP_FLAGS]&TO_IS_AGGRESSOR) ||
	           opponents[str, OPP_FLAGS]&REVENGE))
		    names += ({str});
	    else
		return notify_fail(wrap("An "+capitalize(str)+
		    " darfst Du Dich doch gar nicht rächen."), FAIL_INTERNAL);
    }
    
    if(!sizeof(names))
	return notify_fail("An wem willst Du Dich nicht mehr rächen?\n", FAIL_NOT_OBJ);
	
    foreach(string str: names)
    {
	object p;
	
	if(opponents[str,OPP_FLAGS]&REVENGE)
	    change_aggression_data(str,STOP_REVENGE|BECOME_AGGRESSOR);
	else
	    change_aggression_data(str,REMOVE_OPPONENT);
	
	p = find_player(str);
	if(p)
	    send_message_to(p,MT_NOTIFY, MA_UNKNOWN, wrap(
		Der()+" verzichtet auf Rache an Dir."));
    }
    send_message_to(this_object(), MT_NOTIFY, MA_UNKNOWN, wrap(
	"Du verzichtest auf Rache an "+liste(map(names,#'capitalize))+"."));
    return 1;
}

int player_stoppe(string str)
{
    string *satz = regexplode(lower_case(space(str||"")),"[, ]")-({""," "});
    if(!sizeof(satz))
	return notify_fail("Stoppe was?", FAIL_NOT_CMD);

    if(satz[0]=="rache")
	return abandon_revenge(satz[1..<1]);

    return notify_fail("Stoppe was?", FAIL_NOT_CMD);
}

int player_verzicht(string str)
{
    string *satz = regexplode(lower_case(space(str||"")),"[, ]")-({""," "});

    if(sizeof(satz) && satz[0]=="auf")
	satz = satz[1..<1];

    if(!sizeof(satz) || satz[0]!="rache")
	return notify_fail("Verzichte worauf?\n", FAIL_NOT_CMD);

    return abandon_revenge(satz[1..<1]);
    
}
/* ==================== Ende Moerderermittlung ==================*/

static varargs string determine_erf_tod_message(mapping infos, string idx)
{
    string nam = query_real_cap_name();
    mixed cause, msg;

    if(!infos)
	infos = ([]);

    idx ||= AH_ERF_TOD;
	
    if(infos[idx])
	return infos[idx];

    if(infos[AH_ERF_TOD]) // Konversion notwendig.
    {
	switch(idx)
	{
	    case AH_ERF_TOD_OTHER:
		return STATISTIK->convert_todesursache(nam,
		    infos[AH_ERF_TOD], query_real_gender());
	    case AH_ERF_RETTUNG:
		return STATISTIK->convert_rettungsgrund(nam,
		    infos[AH_ERF_TOD]);
	}
    }
    
    // So, wir haben nix. Machen wir was draus...

    // Erst schauen wir nach Boesewichtern.
    cause = infos[AH_ATTACKER];
    if(!cause)
    {
	cause = infos[AH_ORIGINATOR];
	if(stringp(cause))
	    cause = find_player(lower_case(cause)) || cause;
    }

    if(!cause && this_player()!=this_object())
	cause = this_player();

    if(!cause || cause == this_object() ||
       (stringp(cause) && lower_case(cause) == query_real_name()))
    {
	// Kein Boesewicht gefunden, dann suchen wir andere Ursachen.
	cause = infos[AH_CAUSE];
	
	if(!cause)
	    cause = previous_object(caller_stack_depth()-1);
	    
        if(stringp(msg=cause->query_erf_tod_message(this_object(),infos)))
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
		    return STATISTIK->convert_todesursache(nam, msg,
			query_real_gender());
		case AH_ERF_RETTUNG:
		    return STATISTIK->convert_rettungsgrund(nam, msg);
		default:
        	    return msg;
	    }
	else if(mappingp(msg) && msg[idx])
	    return msg[idx];
	else if(mappingp(msg) && msg[AH_ERF_TOD])
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
		    return STATISTIK->convert_todesursache(nam,
			msg[AH_ERF_TOD], query_real_gender());
		case AH_ERF_RETTUNG:
		    return STATISTIK->convert_rettungsgrund(nam,
			msg[AH_ERF_TOD]);
		default:
		    return msg[AH_ERF_TOD];
	    }
        else if (cause->query_room())
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
		    return "Todesort von "+nam+": " + Name(cause)+".";
		case AH_ERF_RETTUNG:
		    return "Ort der Rettung von "+nam+": " + Name(cause)+".";
		default:
		    return "Todesort: " + Name(cause)+".";
	    }
        else if (cause->query_virus())
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
		    return nam + " ist an "+Name(cause)+" gestorben.";
		case AH_ERF_RETTUNG:
		    return nam + " wäre beinahe an "+Name(cause)+" gestorben.";
		default:
        	    return "Du bist an "+Name(cause)+" gestorben.";
	    }
        else if (cause->query_invis()==V_INVIS)
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
		    return "Todesursache von "+nam+" ist unbekannt.";
		case AH_ERF_RETTUNG:
		    return "Rettungsgrund von "+nam+" ist unbekannt.";
		default:
		    return "Todesursache unbekannt.";
	    }
        else if (cause->query_name() && cause->query_gender())
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
	            return nam+" ist an "+einem(cause)+" gestorben.";
		case AH_ERF_RETTUNG:
	            return nam+" wäre beinahe an "+einem(cause)+" gestorben.";
		default:
	            return "Du bist an "+einem(cause)+" gestorben.";
	    }
        else
	    switch(idx)
	    {
		case AH_ERF_TOD_OTHER:
    		    return "Todesursache von "+nam+": "+Name(cause)+".";
		case AH_ERF_RETTUNG:
    		    return "Rettungsgrund von "+nam+": "+Name(cause)+".";
		default:
    		    return "Todesursache: "+Name(cause)+".";
	    }
    }
    else if (playerp(cause) || stringp(cause))
    {
	string how;
	
        switch(ist_notwehr(cause))
        {
            case 0: how = ""; break;
            case 1: how = " in Notwehr"; break;
            case 2: how = " aus Rache"; break;
            case 3:
		switch(idx)
		{
		    case AH_ERF_TOD_OTHER:
			return nam+" hat den Versuch, sich an "+
                    	    (stringp(cause)?cause:cause->query_real_cap_name())+
                    	    " zu rächen, mit dem Leben bezahlt.";
		    case AH_ERF_RETTUNG:
			return nam+" hätte beinahe  den Versuch, sich an "+
                    	    (stringp(cause)?cause:cause->query_real_cap_name())+
                    	    " zu rächen, mit dem Leben bezahlt.";
		    default:
			return "Du hast den Versuch, Dich an "+
                    	    (stringp(cause)?cause:cause->query_real_cap_name())+
                    	    " zu rächen, mit dem Leben bezahlt.";
		}
    	}
	switch(idx)
	{
	    case AH_ERF_TOD_OTHER:
		 return nam+" wurde von "+
                    (stringp(cause)?cause:cause->query_real_cap_name())+
                    how + " getötet.";
	    case AH_ERF_RETTUNG:
		 return nam+" wurde beinahe von "+
                    (stringp(cause)?cause:cause->query_real_cap_name())+
                    how + " getötet.";
	    default:
		 return "Du wurdest von "+
                    (stringp(cause)?cause:cause->query_real_cap_name())+
                    how + " getötet.";
	}
    }
    else if(!catch(msg=cause->query_erf_tod_message(this_object(), infos); publish) && stringp(msg))
	switch(idx)
	{
	    case AH_ERF_TOD_OTHER:
	        return STATISTIK->convert_todesursache(
		    query_real_cap_name(), msg, query_real_gender());
	    case AH_ERF_RETTUNG:
		return STATISTIK->convert_rettungsgrund(
		    query_real_cap_name(), msg);
	    default:
        	return msg;
	}
    else if(mappingp(msg) && msg[idx])
	return msg[idx];
    else if(mappingp(msg) && msg[AH_ERF_TOD])
	switch(idx)
	{
	    case AH_ERF_TOD_OTHER:
	        return STATISTIK->convert_todesursache(
		    query_real_cap_name(), msg[AH_ERF_TOD],
		    query_real_gender());
	    case AH_ERF_RETTUNG:
		return STATISTIK->convert_rettungsgrund(
		    query_real_cap_name(), msg[AH_ERF_TOD]);
	}
    else if (cause->query_gender() && cause->query_name())
	switch(idx)
	{
	    case AH_ERF_TOD_OTHER:
		return nam+" wurde von "+einem(cause)+" getötet.";
	    case AH_ERF_RETTUNG:
		return nam+" wurde beinahe von "+einem(cause)+" getötet.";
	    default:
		return "Du wurdest von "+einem(cause)+" getötet.";
	}
    else
	switch(idx)
	{
	    case AH_ERF_TOD_OTHER:
		return nam+" wurde von "+Name(cause)+" getötet.";
	    case AH_ERF_RETTUNG:
		return nam+" wurde beinahe von "+Name(cause)+" getötet.";
	    default:
		return "Du wurdest von "+Name(cause)+" getötet.";
	}
}

varargs static void die(mapping infos)
{
    mixed killer;
    string commander, moerdername, gilden_master_ob;
    int notwehr, massenmoerder;
    string erf_tod_other;

#ifdef MASSENMOERDER
    if (sizeof (opfer) >= MASSENMOERDER)
        massenmoerder = 1;
#endif

    if (massenmoerder)
    {
        add_sum_weight(-query_sum_weight());
        add_sum_move(-query_sum_move());
        add_sum_hp  (-query_sum_hp());
        add_sum_sp  (-query_sum_sp());
        add_sum_feel(-query_sum_feel());
        add_sum_comm(-query_sum_comm());
        delete_skill_path (({"skill"}));
        add_skill_points(({"skill","offensiv","haende"}),0);
        add_skill_points(({"skill","defensiv","schild","klein"}),0);
        add_skill_points(({"skill","spiel"}),0);
        add_skill_points(({"skill","raetsel"}),0);
        delete_wissen_skill();
     }
     else
     {
        add_sum_weight(-query_sum_weight()/3);
        add_sum_move(-query_sum_move()/3);
        add_sum_hp  (-query_sum_hp()  /3);
        add_sum_sp  (-query_sum_sp()  /3);
        add_sum_feel(-query_sum_feel()/3);
        add_sum_comm(-query_sum_comm()/3);
    }
    // fp und wp berechnung nach dem Sterben soll richtig funktionieren...
    set_sums_initialized(0);
    set_fp(30);
    set_wp(30);
    set_alc(0);
    set_headache(0);

    /* Erst Stats runtersetzen, und dann neu berechnen,
       (update_stats verringert die Stats nicht) */
    for (int a=0; a<STAT_NUMBER; a++)
	set_one_stat(a,1);
    update_stats();
    update_max_hp();
    update_max_sp();

    if(!infos)
	infos = ([]);

    if(!erf_gestorben)
	erf_gestorben = ({});
    erf_gestorben += ({({vtime(),determine_erf_tod_message(infos)})});
    erf_tod_other = determine_erf_tod_message(infos, AH_ERF_TOD_OTHER);
    
    // Wir ermitteln denjenigen, der das (M) bekommen soll.
    killer = infos[AH_ORIGINATOR] || infos[AH_ATTACKER] || this_player();
    killer = stringp(killer)?find_player(killer)||killer:killer;

    if(objectp(killer))
      commander = critters[killer,CR_COMMANDER];

    /* Moerdederlog */
    if(!killer || killer == this_object() ||
	killer == query_real_name() ||
	(commander && lower_case(commander)==query_real_name()))
    {
	object todesursache = infos[AH_CAUSE] ||
	    previous_object(caller_stack_depth()-1);
	
	sys_log("TOD", sprintf("%s: %s wurde von %s (%s) umgebracht%s\n",
	    shorttimestr(time()), Name(this_object()),
	    object_name(todesursache), Name(todesursache),
	    infos[AH_ERF_TOD] ? ": " + infos[AH_ERF_TOD] : "."));
    }
    else
    {
	int moerder = this_object()->query_moerder();
	notwehr = ist_notwehr(commander || killer);
	 
	// Ein NPC war's.
	if(!playerp(killer) && !stringp(killer) && !commander)
	{
	    // Vielleicht will er's wissen...
	    if(!notwehr && !moerder)
		killer->add_opfer(this_object());
	    
	    sys_log("TOD", sprintf("%s: %s wurde von %s%s getoetet%s\n",
		shorttimestr(time()), Name(this_object()),
		commander?(commander+" durch "):"", Name(killer),
		infos[AH_ERF_TOD] ? ": " + infos[AH_ERF_TOD] : "."));
	}
	else if (notwehr)
	{
	    sys_log("MORD", sprintf("%s: %s wurde von %s%s%s getötet.\n",
		shorttimestr(time()), Name(this_object()),
		commander?(commander+" durch "):"",
		stringp(killer)?killer:Name(killer),
		({""," in Notwehr"," aus Rache"," beim Racheversuch"})[notwehr]));
	}
	else if (moerder)
	{
	    sys_log("MORD", sprintf("%s: %s wurde von %s%s getötet; "
		"das Opfer war selbst ein Mörder.\n",
		shorttimestr(time()), Name(this_object()),
		commander?(commander+" durch "):"", 
		stringp(killer)?killer:Name(killer)));
	}
	else // Gemeiner, kaltbluetiger Mord!
	{
	    if(commander || stringp(killer))
	    {
		object todesursache = infos[AH_CAUSE] ||
		    previous_object(caller_stack_depth()-1);
		string tmp;
		
		if (objectp(killer))
		    tmp = wen(killer, ART_VIS|ART_DER);
		else if (todesursache->query_virus())
            	    tmp = wen(todesursache,ART_VIS|ART_EIN);
		else if (todesursache->query_name() &&
			 todesursache->query_gender())
    		    tmp = wen(todesursache,ART_VIS|ART_EIN);
		
        	PLAYER_MODIFIER->add_opfer(commander || killer, this_object(), tmp);
	    }
	    else
		killer->add_opfer(this_object());
	
	    sys_log("MORD", sprintf("%s: %s wurde von %s%s ermordet.\n",
		shorttimestr(time()), Name(this_object()),
		commander?(commander+" durch "):"",
		stringp(killer)?killer:Name(killer)));
	}
    }

    die::die(infos);
    
    ghost = 1;
    kirche = DOMAIN_INFOS->query_kirche(this_object());
    konto = 0;
    konto_age = 0;
    
    // Alle Aggression-Victims loeschen
    if(stringp(killer))
	moerdername = lower_case(killer);
    else if(playerp(killer))
	moerdername = killer->query_real_name();
    if(moerdername)
	switch(notwehr)
	{
	    // Fall 1: Ich hab den Kampf gestartet
	    // Fall 1.a): Dies war Notwehr: Streitigkeiten sind damit beendet
    	    //            (Eintrag loeschen)
	    case 1:
		change_aggression_data(moerdername, REMOVE_OPPONENT);
		break;

	    // Fall 1.b): Dies war ein Racheversuch (welche somit
	    //            fehlgeschlagen ist): -> Ich darf nochmal
	    case 3:
		change_aggression_data(moerdername,
		    STOP_FIGHT|STOP_REVENGE|BECOME_VICTIM|FULL_TIMEOUT);
		break;
		
	    // Fall 2: Ich wurde angegriffen
	    // Fall 2.a): Das war Mord: Derjenige hat damit einen Moerdereintrag.
	    //      Damit koennen wir die Streitigkeiten fuer beendet erklaeren.
	    case 0:
		change_aggression_data(moerdername, REMOVE_OPPONENT);
		break;

	    // Fall 2.b): Dies war Rache: Ich darf mich jetzt dafuer raechen
	    //	      Nur mein Gegner darf es nimmer.
	    case 2:
		change_aggression_data(moerdername,
		    STOP_FIGHT|STOP_REVENGE|FULL_TIMEOUT); // BECOME_VICTIM ist damit impliziert
		break;
	}

    foreach(string name, int timeout, int flags: opponents)
    {    
	if(timeout<0 || name==moerdername)
	    continue;
	
	// M-los-Kaempfe: Fehlgeschlagener Racheversuch
	//  -> Ich darf nochmal, meine Gegner nicht (sie hatten ja Erfolg)
	// Ansonsten: Falls ich angegriffen habe, so hab ich dafuer bezahlt.
	if(flags&REVENGE)
	    change_aggression_data(name, STOP_FIGHT|STOP_REVENGE|BECOME_VICTIM);
	else if(flags&TO_IS_AGGRESSOR)
	    change_aggression_data(name, REMOVE_OPPONENT);
    }

    // So, wir muessen jetzt schon entscheiden, wohin unser Opfer geht.
    if(massenmoerder)
	which_death = 3;
    else
    {
	which_death = query_gilden_info(GILDEN_TOD);
	if(!which_death && random(100)==12)
	    which_death = 1;
    }

#ifndef TestMUD
    if (!guestp(this_object()) && !testplayerp(this_object()))
#endif
    {
	EVENT_MASTER->event("Tod", me, 0, erf_tod_other);
	call_out ("todesstatistik",2, erf_tod_other, erf_gestorben[<1][1]);
    }
    
    this_object()->send_message(MT_LOOK,MA_UNKNOWN,
	"\nDu siehst einen dunklen Schatten vorbeifliegen... "
	"oder träumst du nur?\n\n");

    if (gilden_master_ob = query_gilden_info(FILE_NAME))
	catch(gilden_master_ob->do_player_died(this_object(), infos); publish);

    this_object()->close_con();
    if(intp(which_death))
	switch(which_death)
	{
	    case 1:
		this_object()->send_message_to(me,MT_NOTIFY,MA_UNKNOWN,
		    "Ein Männchen mit einer Schlafmütze steht neben deinem Körper.\n" +
		    "Es spielt mit seinem blutverschmierten Schnuller und öffnet einen Sandsack.\n"
		    "Plötzlich streut es Dir Sand in Deine Augen...\n\n");
		break;
	    case 0: // Standard - Tod
	    case 3: // Massenmoerder
		this_object()->send_message_to(me,MT_NOTIFY,MA_UNKNOWN,
		    "Ein dunkel gekleideter Mann steht neben deinem Körper.\n" +
		    "Er spielt mit seiner blutverschmierten Sense.\n"+
		    "Plötzlich stoppt er und schaut dich mit seinen leeren...\n"+
		    "nein, nicht leeren aber.... schluck...\n\n");
		break;
	}
}

/*
FUNKTION: query_erf_tod_message
DEKLARATION: varargs mixed query_erf_tod_message(object victim, mapping infos)
BESCHREIBUNG:
Das Ergebnis dieser Funktion in dem als Todesursache ermittelten Objekt
wird statt einer Standardmeldung als Text fuer 'erf tod' genommen, falls
keine explizite Meldung bei add_hp angegeben wurde.

Es kann sowohl ein String zurueckgegeben werden, welcher die Meldung
fuer den Spieler selbst darstellt, oder ein Mapping mit den Eintraegen
AH_ERF_TOD, AH_ERF_TOD_OTHER und/oder AH_ERF_RETTUNG, welche die Meldung
fuer den Spieler, fuer alle anderen bzw. fuer alle anderen bei einer Rettung
darstellen.
VERWEISE: set_erf_tod_message, add_hp
GRUPPEN: spieler, kampf
*/

static void todesstatistik (string tod_andere, string tod)
{
    if(!testplayerp(this_object()) && (player_age > 86400))
	STATISTIK->player_died (tod_andere, tod);
    CONTROL->notify("player_died", this_object(), tod_andere, tod);
}

static void schutzengelstatistik (string rettung, string tod)
{
    if(testplayerp(this_object()))
	this_object()->send_message_to(this_object(), MT_SENSE|MT_FAR,
	    MA_COMM, wrap(sprintf("Dein Schutzengel redet zu Dir: "
	    "Ach ja, Deine Rettungsmeldung ist: %O", rettung)));
    else if (player_age > 86400)
	STATISTIK->player_saved (rettung, tod);
    CONTROL->notify("player_saved", this_object(), rettung, tod);
}

mixed* query_erf_gestorben ()
{
    // Argh, andere nutzen diese undokumentierte Funktion...
    if (extern_call() && previous_object() != this_object())
	return deep_copy(erf_gestorben);
    else
	return erf_gestorben;
}

void move_to_death() {
    if (which_death == 2) {
	// keine Todessequenz
	this_object()->set_ghost(-1);
	clone_object("/room/death/obj/death_shadow")
	  ->init_shadow(this_object(), NO_MULTI_SHADOW);
	return;
    }
    this_object()->open_con(); //Wieder oeffnen fuer die Zeit im Todesraum.
    if (which_death == 1) {
	// Sandmaennchen
	this_object()->send_message_to(me,MT_FEEL,MA_UNKNOWN,
		"Das Sandmännchen nimmt Dich am Händchen.\n");
	this_object()->send_message_to(me,MT_NOISE,MA_COMM,
		"Das Sandmännchen sagt: Komm mit!\n\n");
	move("/room/death/death_room_sand",([MOVE_FLAGS:MOVE_FORCE]));
	return;
    }
    if (stringp(which_death)) 
    {
        catch(which_death = touch(which_death));
        if (objectp(which_death) 
                && (move(which_death,([MOVE_FLAGS:MOVE_FORCE])) == MOVE_OK))
            return;
    }
    // Standard - Tod
    if (query_gender() == "weiblich")
	this_object()->send_message_to(me,MT_NOISE,MA_COMM,
		"Der Tod sagt: FOLGE MIR, TODGEWEIHTE!\n\n");
    else if (query_gender() == "saechlich")
	this_object()->send_message_to(me,MT_NOISE,MA_COMM,
		"Der Tod sagt: FOLGE MIR, TODGEWEIHTES!\n\n");
    else
	this_object()->send_message_to(me,MT_NOISE,MA_COMM,
		"Der Tod sagt: FOLGE MIR, TODGEWEIHTER!\n\n");
    if (which_death == 3)
        move("/room/death/death_room_massenmoerder", 
            ([MOVE_FLAGS:MOVE_FORCE]));
    else
        move("/room/death/death_room",([MOVE_FLAGS:MOVE_FORCE]));
}

static void second_life(object corpse) {
    if(find_call_out("move_to_death")==-1) call_out("move_to_death",3);
}

/*
FUNKTION: query_ghost
DEKLARATION: int query_ghost()
BESCHREIBUNG:
Diese Funktion zeigt an, ob der Spieler ein Geist ist, d.h. ob er gerade
gestorben ist, und noch nicht in der Kirche gebetet hat.
VERWEISE: set_ghost, add_ghost, query_kirche
GRUPPEN: spieler
*/
int query_ghost() { return ghost; }

/*
FUNKTION: query_kirche
DEKLARATION: string query_kirche()
BESCHREIBUNG:
Wenn der Spieler ein Geist in der Todessequenz ist, liefert diese Funktion
die Kirche zurueck, in welcher er danach befoerdert wird.
VERWEISE: set_ghost, add_ghost, query_ghost, set_kirche
GRUPPEN: spieler
*/
string query_kirche()
{
    if(stringp(which_death))
	return which_death->query_kirche(me) || kirche || DEFAULT_ROOM_AFTER_DEATH;
    if(environment()->query_death_room())
	return environment()->query_kirche(me) || kirche || DEFAULT_ROOM_AFTER_DEATH;
    return kirche || DEFAULT_ROOM_AFTER_DEATH;
}

/*
FUNKTION: add_ghost
DEKLARATION: void add_ghost(int i)
BESCHREIBUNG:
Mit dieser Funktion kann man den Zaehler, der fuer die Meldungen beim TOD
zustaendig ist veraendern.
VERWEISE: set_ghost, query_ghost
GRUPPEN: spieler
*/
void add_ghost(int i) { ghost += i; }

/*
FUNKTION: set_ghost
DEKLARATION: void set_ghost(int i)
BESCHREIBUNG:
Mit dieser Funktion kann man den Zaehler, der fuer die Meldungen beim TOD
zustaendig ist setzen.
VERWEISE: add_ghost, query_ghost
GRUPPEN: spieler
*/
void set_ghost(int i)
{
    if(i<=0)
	kirche = 0;
    else if(ghost<=0)
	kirche = DOMAIN_INFOS->query_kirche(me);
    ghost = i;
}

void revive() {
    if (ghost) {
	ghost = 0;
	kirche = 0;
	open_con();
	set_hp(10);
	set_wp(0);
	set_fp(0);
	make_scar();
	}
    else
	if (query_hp()<1)
	    set_hp(10);
}


int toggle_whimpy(string s)
{
    int x;
    if (!s || (s == "")) {
	notify_fail("Ab wieviel Ausdauerpunkten soll der Fluchtmodus "
	    "aktiv werden (0 bedeutet\ndabei nie)?\n");
	return 0;
    }
    if ((s == "0") || (s == "aus")) {
	set_whimpy(0);
	write("Flucht-Modus ausgeschaltet.\n");
	return 1;
    }
    if (x = to_int (s)) {
	if (x < 0) {
	    notify_fail("Bitte keine negativen Zahlen.\n");
	    return 0;
	}
	if (x >= query_max_hp()) {
	    notify_fail("Das ist ja viel zu hoch, das geht nicht.\n");
	    return 0;
	}
	set_whimpy(x);
	write("Flucht-Modus eingeschaltet auf "+x+" Ausdauerpunkte.\n");
	return 1;
    }
    notify_fail("Gib bitte die Zahl an, ab wieviel Ausdauerpunkten Du "
	"die Flucht\nergreifen möchtest.\n");
    return 0;
}

int change_likes_attacks(string s)
{
    if (!s || !strlen (s)) {
        if (query_wants_to_get_attacked_by_monsters()) {
	    set_wants_to_get_attacked_by_monsters(0);
	    write("Aggressive Monster lassen Dich jetzt in Frieden.\n");
	} else {
	    set_wants_to_get_attacked_by_monsters(1);
	    write("Aggressive Monster prügeln jetzt auf Dich ein.\n"
	          "Dies solltest Du nur zu Testzwecken einschalten.\n");
        }
        return 1;
    }
    if ((s == "ein") || (s == "an") || (s == "einschalten")
        || (s == "anschalten")) {
	set_wants_to_get_attacked_by_monsters(1);
	write("Aggressive Monster prügeln jetzt auf Dich ein.\n"
	      "Dies solltest Du nur zu Testzwecken einschalten.\n");
	return 1;
    }
    if ((s == "aus") || (s == "ausschalten")) {
	set_wants_to_get_attacked_by_monsters(0);
	write("Aggressive Monster lassen Dich jetzt in Frieden.\n");
	return 1;
    }
    notify_fail ("Was möchtest Du mit der Angreifbarkeit machen?\n"
        "Einschalten oder ausschalten?\n");
    return 0;
}

int help_english()
{
   cat(HELP_PATH+"/help");
   return 1;
}

int help(string str)
{
    if(!str)
    {
	more(HELP_PATH+"/allgemein", "--Mehr--", 0, M_AUTO_END);
	if(wizp(this_object()))
	    write("Mit  hilfe götter  bekommst Du weitere Hilfe.\n"+
		  copies("-",78)+"\n");
	return 1;
    }
    str = convert_umlaute(lower_case(str));
    if(str == "beschreibe mich")
       str = "beschreibe";
    if(wizp(this_object()))
    {
	if(str == "goetter" &&
	    !more(HELP_PATH+"/goetter/allgemein", "--Mehr--", 0, M_AUTO_END))
	    return 1;
	else
	if(!more(HELP_PATH+"/goetter/"+str, "--Mehr--", 0, M_AUTO_END))
	    return 1;
	else
	if(!more(HELP_PATH+"/"+str+".wiz", "--Mehr--", 0, M_AUTO_END))
	    return 1;
	else
	if(!more(HELP_PATH+"/"+str, "--Mehr--", 0, M_AUTO_END))
	    return 1;
    }
    else if(strstr(str, ".") < 0)
    {
	if(!more(HELP_PATH+"/"+str, "--Mehr--", 0, M_AUTO_END))
	    return 1;
    }
    if(member(({"ich", "mach", "mache",
		query_real_name(), "$der("+query_real_name()+")"}),str)>=0)
    {
	more(HELP_PATH+"/feelings","--Mehr--", 0, M_AUTO_END );
	return 1;
    }
    notify_fail("Hierfür gibt es keine Hilfe.\n", FAIL_NOT_OBJ);
    return 0;
}

nomask int query_own_finger_flags ()
{
    return own_finger_flags;
}

nomask static void set_own_finger_flags (int flags)
{
    own_finger_flags = flags;
}

nomask static int query_other_finger_flags ()
{
    return other_finger_flags;
}

nomask static void set_other_finger_flags (int flags)
{
    other_finger_flags = flags;
}

int finger(string str)
{
    string ret, *opfer;
    int other, i;
    mapping opt;

    if (!str)
        str = "-?";
    if (str == "mich")
        str = query_real_name();
    if (str [<5..] == " mich")
        str = str[0..<5] + query_real_name();
    if (str [0..4] == "mich ")
        str = query_real_name()+str[4..];
    str = regreplace (str," mich "," "+query_real_name()+" ",0);
    str = regreplace (str,"[Oo][Bb][Ee][Rr][Ss][Tt][Ee]([Rr]|) ([Rr][Aa][Tt]|[Rr][Aa][Ee][Tt][Ee])",
	    "admin",0);

    opt = getopt (str, 
      wizp (this_object())
       ? (["o":0,"d":0,"z":0,"g":0,"f":0,"k":0,"p":0,"w":0,"D":0,"G":0,"l":0,"?":0])
       : (["o":0,"d":0,"z":0,"g":0,"f":0,"k":0,"?":0]),
      GO_FAILS);
    if (!opt) return 0;

    if (!(own_finger_flags & FINGER_FLAG_VALID))
        own_finger_flags = FINGER_FLAG_OWN_DEFAULT;
    if (!(other_finger_flags & FINGER_FLAG_VALID))
        other_finger_flags = FINGER_FLAG_OTHER_DEFAULT;

    other = other_finger_flags;
    
    if (opt["o"]) own_finger_flags ^= FINGER_FLAG_OWN_TOWN;
    if (opt["d"]) own_finger_flags ^= FINGER_FLAG_OWN_DATE;
    if (opt["z"]) own_finger_flags ^= FINGER_FLAG_OWN_TIME;
    if (opt["g"]) own_finger_flags ^= FINGER_FLAG_OWN_BIRTHDAY;
    if (opt["f"] || opt["k"])
                  other ^= FINGER_FLAG_OTHER_TEXT;
    if (opt["p"]) other ^= FINGER_FLAG_OTHER_PLAN;
    if (opt["w"]) other ^= FINGER_FLAG_OTHER_APPRECIATIONS;
    if (opt["D"]) other |= FINGER_FLAG_OTHER_APPRECIATIONS_SORT_BY_DATE;
    if (opt["G"]) {
        other |= FINGER_FLAG_OTHER_APPRECIATIONS_SORT_BY_DATE;
        other ^= FINGER_FLAG_OTHER_APPRECIATIONS_SORT_BY_DATE;
    }
    if (opt["l"]) other ^= FINGER_FLAG_OTHER_CURRICULUM_VITAE;
    if (opt["o"] || opt["d"] || opt["z"] || opt["g"])
        write("Finger - Einstellungen geändert.\n");
    if (opt["?"]) {
        write ("Fingereinstellungen, was andere bei Dir sehen können:\n"
               "    Ort, aus welchem Du kommst (-o): "
               +(own_finger_flags & FINGER_FLAG_OWN_TOWN ? "ja" : "nein")+"\n"
               "    Datum, wann Du das letzte mal da warst (-d): "
               +(own_finger_flags & FINGER_FLAG_OWN_DATE ? "ja" : "nein")+"\n"
               "    Uhrzeit, wann Du das letzte mal da warst (-z): "
               +(own_finger_flags & FINGER_FLAG_OWN_TIME ? "ja" : "nein")+"\n"
               "    Dein Geburtsdatum (-g): "
               +(own_finger_flags & FINGER_FLAG_OWN_BIRTHDAY?"ja":"nein")+"\n"
               "Fingereinstellungen, was Du bei anderen sehen möchtest:\n"
               "    selbstgeschriebene Finger - Text (-f): "
               +(other_finger_flags & FINGER_FLAG_OTHER_TEXT?"ja":"nein")+"\n"
               +(wizp(this_object()) ?
              ("    selbstgeschriebene Plan (-p): "
               +(other_finger_flags & FINGER_FLAG_OTHER_PLAN?"ja":"nein")+"\n"
               "    Würdigungen (-w): "
               +(other_finger_flags & FINGER_FLAG_OTHER_APPRECIATIONS ? "ja":"nein")+"\n"
               "    Würdigungen sortieren nach (Datum (-D) / Gebiet (-G)): "
               +(other_finger_flags & FINGER_FLAG_OTHER_APPRECIATIONS_SORT_BY_DATE
                 ? "Datum" : "Gebiet")+"\n"
               "    Lebenslauf anzeigen (-l): "
               +(other_finger_flags & FINGER_FLAG_OTHER_CURRICULUM_VITAE ? "ja":"nein")+"\n"
              ) : "")
	     +"Nähere Infos mit \"hilfe finger\".\n");
    }
    if (opt["args"] && sizeof (opfer = explode(implode(opt["args"]," ")," "))) {
        for (ret = "", i = 0; i < sizeof (opfer); i++, ret += "\n")
            ret += FINGER_OB->do_finger(opfer[i], other);
        if (strlen(ret))
            this_player()->more(explode(ret,"\n")[..<2],"--Mehr--",0,M_AUTO_END);
        else if (!str)
	    write("Keine Informationen verfügbar.\n");
    }
    else {
    if ((!(opt["o"] || opt["d"] || opt["z"] || opt["g"]))
        && (other_finger_flags != other)) {
            write("Finger - Einstellungen geändert.\n");
            other_finger_flags = other;
        }
    }
    return 1;
}

int muds(string str)
{
    "/secure/udp/muds"->print_udp_muds(str && str == "-l");
    return 1;
}

int shout_verweis ()
{
    if (!query_notify_fail())
        notify_fail ("Meinst Du vielleicht 'bruelle'?\n");
    return 0;
}

int untersuche_verweis()
{
    notify_fail ("Du musst schon genauer sagen, was Du tun möchtest.\n"
          "Anschauen, horchen, riechen oder befühlen?\n");
}

int query_no_www_page (string s)
{
    if (no_www_pages && (member(no_www_pages,s) != -1)) return 1;
    return 0;
}

#ifdef UNItopia
string *query_who_header()
{
    return header;
}
#endif

private string _get_idle_string(int idlezeit)
{
    if (idlezeit > 86400)
        // Minuten rauswerfen:
        idlezeit = idlezeit / 3600 * 3600;
    else
        // Sekunden rauswerfen:
        idlezeit = idlezeit / 60 * 60;
    return short_format_seconds (idlezeit);
}

int who(string str)
{
    object *list, kugel;
    int i, anz, leer;
    string name, *out, mud;
    mapping opt;

    if(!str || str=="")
      opt=([]);
    else 
    {
        opt=getopt(
            str,
            (["k":0,"n":0,"e":0,"i":0,"I":0,"l":0]),
            GO_FAILS);
        if(!opt) return 0;

        if(opt["args"])
        {
            // mehr als ein MUD stillschweigend ignorieren
            if(strstr(lower_case(MUD_NAME), lower_case(opt["args"][0])))
            {
                if (mud = INETD->known_mud(lower_case(opt["args"][0])))
                {
                    string options;
                    mud = lower_case (mud);
                    if (opt["k"]) options = "short";
                    else options = (mud != "wunderland") ? "long" : "";
                    // wunderland verkraftet kein "long"
                    if (opt["i"] || opt["I"]) options += " idle";
                    if (!opt["l"]) options += " alpha";
            	    INETD->send_udp(mud,
            	            ([ REQUEST: "who",
            	               DATA:    options,
            		       SENDER : query_real_name() ]), 1);
            	    write("Anfrage abgeschickt.\n");
                }
                else
            	    write(wrap (opt["args"][0]+" gibt es nicht. Hilfe zu "
            	    "'wer' erhältst Du mit 'hilfe wer'."));
                return 1;
            }
        }
    }
    out = ({});
    list = users();
    anz = sizeof(list);
    
    closure sortierclosure = (: to_string($1->query_name()) > to_string($2->query_name()) :);
                                

    if (opt["W"])
        sortierclosure = (: $1->query_experience_promille() > $2->query_experience_promille() :);
    else if (opt["R"])
        sortierclosure = (: $1->query_quest_count() > $2->query_quest_count() :);
    else if (opt["S"])
        sortierclosure = (: $1->query_game_count() > $2->query_game_count() :);
    else if (opt["T"])
        sortierclosure = (: $1->query_kill_count() > $2->query_kill_count() :);

    list = sort_array(filter(list, (: !IS_INVIS($1) &&
                                      !($1->query_no_wer() &&
                                        (wizp($1) || testplayerp($1))) :)),
           sortierclosure); 

    for(i = 0; i < sizeof(list); i++)
    {
       if(opt["k"])
       {
           name = list[i]->query_cap_name();
           if(!wizp(list[i])) {
               if((kugel=present("hlp#tool", list[i])) && 
                  kugel->query_surviving())
                   name+=" (S)";
               if(list[i]->query_moerder())
                   name+=" (M)";
           }
           name+=(((opt["i"])&&query_idle(list[i])>120)?" (I)":
                   ((opt["I"])&&query_idle(list[i])>120)?" (I: "
                     +_get_idle_string(query_idle(list[i]))+")":"");
       }
       else 
       {
           name = list[i]->query_short(this_object());
/* das macht schon das living::query_short()...
           if(!wizp(list[i])) {
               if((kugel=present("hlp#tool", list[i])) && 
                  kugel->query_surviving())
                   name+=" (S)";
               if(list[i]->query_moerder())
                   name+=" (M)";
           }
*/
           int ende = name[<1];
           if ((ende != '.') && (ende != '!') && (ende != '?'))
               name += ".";
           name+=(((opt["i"])&&query_idle(list[i])>120)?" (I)":
                  ((opt["I"])&&query_idle(list[i])>120)?" (Idle: "
                    +_get_idle_string(query_idle(list[i]))+")":"");
       }
       out += ({ name });
    }
    if(opt["k"])
       out = explode(sprintf("%#-78s",implode(out,"\n")),"\n");
    else if (opt["e"]) {
       int max_left, neu_left, neu_length;
       for (i = 0, max_left = -1; i < sizeof (out); i++)
          if (((neu_left =
              ((strstr (lower_case(out[i]),list[i]->query_real_name())+1) ||
               (strstr (lower_case(out[i]),list[i]->query_name())+1)) -1)
              > max_left) && (neu_left < 20))
             max_left = neu_left;
       if (max_left != -1)
          for (i = 0; i < sizeof (out); i++) {
             neu_length = (
                -1 != (neu_left = strstr (lower_case (out[i]),list[i]->query_real_name())))
                ? strlen (list[i]->query_real_name()) : (
                -1 != (neu_left = strstr (lower_case(out[i]),list[i]->query_name())))
                ? strlen (list[i]->query_name()) : neu_left = 0;
             out[i] = copies(" ",max_left-neu_left)+out[i];
             out[i] = sprintf("%s%=-1.*s",
                out[i][0..max_left+neu_length],
                79-max_left-neu_length-1,
                out[i][max_left+neu_length+1..]);
          }
    }
    else {
        for (i = 0; i < sizeof (out); i++)
            if ((leer = strstr (out[i]," ")) > 0)
                out[i] = sprintf("%s%=-1.*s",
                    out[i][0..leer], 78 - leer, out[i][leer+1..]);
    }

    if (opt["R"] || opt["r"] || opt["S"] || opt["s"] || opt["T"] || opt["t"] || opt["w"] || opt["W"]) {
        int maxR = 0, maxS = 0, maxT = 0, maxW = 0;
        for (i = 0; i < sizeof (out); i++) {
            if (list[i]->query_quest_count() > maxR) maxR = list[i]->query_quest_count();
            if (list[i]->query_game_count() > maxS) maxS = list[i]->query_game_count();
            if (list[i]->query_kill_count() > maxT) maxT = list[i]->query_kill_count();
            if (list[i]->query_experience_promille() > maxW) maxW = list[i]->query_experience_promille();
        }
        maxR = strlen(""+maxR);
        maxS = strlen(""+maxS);
        maxT = strlen(""+maxT);
        maxW = strlen(""+maxW)+3;
        for (i = 0; i < sizeof (out); i++) {
           string add = "";
           if (opt["W"] || opt["w"]) {
               string weg = ""+list[i]->query_experience_promille();
               string wega = weg[0..<2]+",";
               if (strlen (wega) == 1) wega = "0,";
               string wegb = weg[<1..]+"% ";
               add += " Weg: "+right(wega+wegb,maxW);
           }
           if (opt["R"] || opt["r"]) add += " Rätsel: "+right(list[i]->query_quest_count(),maxR);
           if (opt["S"] || opt["s"]) add += " Spiele: "+right(list[i]->query_game_count(),maxS);
           if (opt["T"] || opt["t"]) add += " Kills: "+right(list[i]->query_kill_count(),maxT);
           if (strlen (add)) {
               while (out[i][<1] == ' ') out[i] = out[i][0..<2];
               if (strlen (out[i]) + strlen (add) >= 78) {
                   while (strlen (add) < 78) add = " "+add;
                   out[i] = out[i] + "\n" + add;
               } else {
                   while (strlen (out[i]) + strlen (add) < 78) out[i] += " ";
                   out[i] += add;
               }
           }
        }
    }
       
#ifdef UNItopia
    out = ((opt["k"] || no_ascii_art) ? ({"In "+MUD_NAME+" befinden sich:"}) +
                (opt["k"] ? ({}) : ({" ",}))
		: "/obj/player"->query_who_header()) +
#else
    out = ({"In "+MUD_NAME+" befinden sich:"}) +
#endif
	  out + ({
#ifdef UNItopia
	  " ",
#endif
	  "Insgesamt "+anz+" Spielende"+
          (anz-i?", "+(anz-i)+" davon unsichtbar.":".") });
    if (!opt["k"])
    {
	out += ({ "Heute waren bisher "
	    +STATISTIK->query_sum_users()+
	    " Leute in " MUD_NAME ",\n"
	    "maximal "
	    +STATISTIK->query_max_users()
	    +" gleichzeitig, das war um "
	    +(explode(space(ctime(STATISTIK->query_max_users_time()))," ")[3])+" Uhr.",
	    "Am "
	    +timestr(STATISTIK->query_max_users_ever_time())
	    +" waren "
	    +STATISTIK->query_max_users_ever()+
	    " Spielende gleichzeitig da."});
    }
    if (opt["n"])
	write(implode(out, "\n")+"\n");
    else
	this_object()->more(out, "--Mehr--", 0, M_AUTO_END);
    return 1;
}

int describe_me (string s)
{
    object seele;

    if (seele = present ("seele"))
       notify_fail ("Beschreibe was, beschreibe was wie?\n"
	   "Vielleicht beschreibe \"mich\" oder beschreibe "
	   +seele->query_cap_name()+" wie?\n");
    else
       notify_fail ("Beschreibe was? Vielleicht \"mich\"?\n");
    if (s != "mich") return 0;
    if (query_input_pending (this_object()) || query_editing (this_object())) {
	write ("Jetzt geht das nicht. Eines nach dem anderen.\n");
	return 1;
    }
    if (IS_HIDDEN(this_object())) {
	write ("Du bist gerade versteckt oder unsichtbar.\nSolang Du Dich "
	 "selbst nicht sehen kannst, kannst Du Dich auch nicht beschreiben.\n");
	return 1;
    }
    if ((lower_case(this_object()->query_cap_name()) != query_real_name() &&
         lower_case(this_object()->query_cap_name()) != this_object()->get_intermud_src_name()) ||
        this_object()->query_gender()!=this_object()->query_real_gender())
       {
	write ("Du bist gerade verkleidet oder getarnt.\nSolang Du Dich "
	 "selbst nicht richtig sehen kannst, kannst Du Dich auch nicht\nrichtig beschreiben.\n");
	return 1;
    }
    "/apps/description"->describe_me ();
    return 1;
}

/*
FUNKTION: query_konto
DEKLARATION: int query_konto()
BESCHREIBUNG:
Diese Funktion liefert den Kontostand des Spielers zurueck.
VERWEISE: set_konto, add_konto, query_konto_age, set_konto_age
GRUPPEN: spieler, handel
*/
int query_konto() { return konto; }

#define LOGK if(query_once_interactive(this_object()) && this_interactive() &&\
   this_interactive()!=this_object() && !wizp(this_object()) && \
   !testplayerp(this_object()) && wizp(this_interactive()))\
   "/secure/log_adjektiv"->log_konto(temp,konto)
/*
FUNKTION: set_konto
DEKLARATION: void set_konto(int a)
BESCHREIBUNG:
Mit dieser Funktion kann man den Kontostand des Spielers setzten.
VERWEISE: query_konto, add_konto, query_konto_age, set_konto_age
GRUPPEN: spieler, handel
*/
void set_konto(int a)
{
   int temp;
   temp = konto;
   if(intp(a))
   {
      konto = a;
      LOGK;

      if(konto > temp && PLAYER_ANNOYER->query("Konto", query_real_name()))
      {
          konto = temp;
      }
   }
}

/*
FUNKTION: add_konto
DEKLARATION: void add_konto(int a)
BESCHREIBUNG:
Mit dieser Funktion kann man den Kontostand des Spielers veraendern.
VERWEISE: query_konto, set_konto, query_konto_age, set_konto_age
GRUPPEN: spieler, handel
*/
void add_konto(int a)
{
   int temp;
   temp = konto;
   if (intp(a))
   {
      konto += a;
      LOGK;

      if(konto > temp && PLAYER_ANNOYER->query("Konto", query_real_name()))
      {
          konto = temp;
      }
   }
}

/*
FUNKTION: query_konto_age
DEKLARATION: int query_konto_age()
BESCHREIBUNG:
Mit dieser Funktion kann man das Alter des Spielers in Sekunden abfragen,
zu dem Zeitpunkt, als der Spieler das letzte Mal etwas vom Konto abgehoben
oder darauf eingezahlt hat.
VERWEISE: set_konto_age
GRUPPEN: spieler, handel
*/
int query_konto_age() { return konto_age; }

/*
FUNKTION: set_konto_age
DEKLARATION: void set_konto_age(int alter)
BESCHREIBUNG:
Mit dieser Funktion setzt man das Alter des Spielers zu dem Zeitpunkt, als
der Spieler zuletzt etwas auf seinem Konto macht.
(Alter in Sekunden, wird von /i/money/banking verwendet).
VERWEISE: query_konto_age
GRUPPEN: spieler, handel
*/
void set_konto_age(int a) { konto_age = a; }

int query_enable_cleanup() { return 0; }

string look_m_v_item ()
{
    string tmp, *tmpa;
    int i, count;
    for (tmpa = ({}), i = 0; i < sizeof (opfer); i++) {
        tmp = capitalize (opfer[i]);
        count = 0;
        while ((i+1 < sizeof (opfer)) && (opfer[i] == opfer[i+1])) {
            count++;
            i++;
        }
        if (count > 4)
           tmp = "mehrmals "+tmp;
        else if (count > 3)
            tmp = "fünfmal "+tmp;
        else if (count > 2)
            tmp = "viermal "+tmp;
        else if (count > 1)
            tmp = "dreimal "+tmp;
        else if (count > 0)
            tmp = "zweimal "+tmp;
        tmpa = ({tmp}) + tmpa;
    }
    tmp = liste (tmpa," und ");
    if (previous_object() && (previous_object() == this_object()))
	return wrap ("Ein Mal der Götter schwebt etwa einen Meter über "
	    "Deinem Kopf, um anzuzeigen, dass Du"
	    +(query_gender() == "weiblich"?" die Mörderin":
		" der Mörder")+
	    " von "+tmp+" bist.");
    return wrap (
	"Ein Mal der Götter schwebt etwa einen Meter über dem "
        "Kopf von "+dem()+", um anzuzeigen, dass "
	+er()+(query_gender() == "weiblich"?" die Mörderin":
		" der Mörder")+
	" von "+tmp+" ist.");
}

private void handle_m_v_item ()
{
    delete_v_item (({"player # em # v # item"}));
    if (!opfer || !sizeof (opfer) || wizp (this_object())) return;
    add_v_item (([
        "name":"M", "gender":"saechlich",
	"id":({"m","em","mördermal","mal",
	    "player # em # v # item"}),
	"long":#'look_m_v_item,
	"far":"Das M schwebt viel zu weit oben herum."
    ]));
}

nomask void add_opfer(object ob)
{
    string name, gilden_master_ob;

    if (!playerp(ob))
	return;

    if (!playerp(previous_object()) &&
	strstr(object_name(previous_object()),"/secure/"))
	    return;
    
#ifndef TestMUD
    // Bei Nicht-Admintesties nicht eintragen.
    if (!adminp(this_object()) &&
	member(ADMINS, testplayerp(this_object()))<0 &&
	member(ADMINS, testplayerp(ob))<0 &&
	(testplayerp(this_object()) || testplayerp(ob)))
	return;
#endif
    	
    name = ob->query_real_name();
    if (!name || name =="")
	return;

    /* Fuer Leute die sich selber umbringen , tststs */
    if (name == query_real_name())
	return;

    if (!opfer)
	opfer = ({});
//  zweifache Moerder eines Opfers werden jetzt zweifache Moerder
//  eines Opfers
//    if (member(opfer,name) < 0)
    opfer = sort_array (opfer + ({ name }),#'>);
    konto = 0;
    handle_m_v_item ();
    if (gilden_master_ob = query_gilden_info(FILE_NAME))
    {
	catch(gilden_master_ob->do_player_murdered(this_object(),ob); publish);
    }
}

nomask void add_opfer_namen(string *namen)
{
    if(load_name(previous_object())!=LOGIN_OB) return;
    if(!adminp(this_object()) && member(ADMINS, testplayerp(this_object()))<0)
    {
	if (testplayerp(this_object())) return;
	namen = filter(namen, (: !testplayerp($1) :));
	if(!sizeof(namen)) return;
    }
    opfer = sort_array((opfer||({}))+namen,#'>);
    konto = 0;
    handle_m_v_item ();
}

nomask void delete_opfer(string name) {
	int a;

    if (object_name(previous_object()) != "/room/rathaus/div/richter" &&
	    !adminp(this_interactive()) )
	return;
    if (!name || name == "")
	return;
    if (!opfer || sizeof(opfer) <= 0)
	return;
    a = member(opfer,lower_case(name));
    if (a < 0)
	return;
    opfer -= ({ opfer[a] });
    handle_m_v_item ();
}

#ifdef UNItopia
nomask void delete_ein_opfer(string name)
{
    int a;

    if (object_name(previous_object()) != "/d/Vaniorh/Tadmor/Gericht/apps/master" &&
	    !adminp(this_interactive()) )
	return;
    if (!name || name == "")
	return;
    if (!opfer || sizeof(opfer) <= 0)
	return;
    a = member(opfer,lower_case(name));
    if (a < 0)
	return;

    opfer = arr_delete(opfer, a);
    handle_m_v_item ();
}
#endif

/*
FUNKTION: query_opfer
DEKLARATION: nomask string *query_opfer()
BESCHREIBUNG:
Diese Funktion liefert ein Feld mit den Namen der Spieler, die der Spieler
ermordet hat.
VERWEISE: query_one_opfer, query_moerder
GRUPPEN: spieler, kampf
*/
nomask string *query_opfer()
{
    if(pointerp(opfer))
       return ({}) + opfer;
    else
       return ({});
}

/*
FUNKTION: query_one_opfer
DEKLARATION: nomask int query_one_opfer(string name)
BESCHREIBUNG:
Mit dieser Funktion kann man abfragen, ob der Spieler den Spieler <name>
ermordet hat.
VERWEISE: query_opfer, query_moerder
GRUPPEN: spieler, kampf
*/
nomask int query_one_opfer(string name) {
    if (!name || name == "")
	return 0;
    if (member(opfer,lower_case(name)) >= 0)
	return 1;
    return 0;
}

/*
FUNKTION: query_moerder
DEKLARATION: nomask int query_moerder()
BESCHREIBUNG:
Mit dieser Funktion kann man abfragen, ob der Spieler ein Moerder ist.
1 == Moerder
0 == keiner (oder Gott, da kommt immer 0 ;-)
VERWEISE: query_opfer, query_one_opfer
GRUPPEN: spieler, kampf
*/
nomask int query_moerder()
{
    if (opfer && sizeof(opfer) > 0 && query_level() < LVL_WIZ)
	return 1;
    return 0;
}


void set_read_artikel(mixed struc)
{
    artikel = struc;
    call_save();
}

mixed query_read_artikel() { return artikel; }

void update_artikel_struktur()
{
    if (wizp (this_object()))
    {
	artikel = NEWSD->query_read_artikel(this_object()); // Konversion alter Daten
	if(!artikel)
	    return;
	if(!artikel["Bereiche"])
	{
            artikel["Bereiche"] = artikel["Domains"];
            artikel["Bereiche",1] = (artikel["Domains",1] || m_allocate(0,5))
                + (artikel["Programmierung",1] || m_allocate(0,5));
	}
    }
}

void set_newsreader_settings(mapping nrset)
{
    if(object_name(previous_object())[0..14]=="/obj/newsreader")
        newsreader_settings = nrset;
}

mapping query_newsreader_settings()
{
    if(object_name(previous_object())[0..14]=="/obj/newsreader")
        return newsreader_settings;
}

/*
FUNKTION: set_home_msg
DEKLARATION: void set_home_msg(string home_msg)
BESCHREIBUNG:
Setzt die Meldung, die die anderen im Raum bekommen, wenn ein Gott heimgeht.
Dieser Befehl ist nur bei Goettern interessant und laesst sich auch mit
dem Befehl 'zet home_msg <string>' erreichen....
Psuedoclosures (das sind die Dinger mit dem $, zb $der() ) sind erlaubt.
VERWEISE: query_home_msg, set_clone_msg, set_destruct_msg
GRUPPEN: spieler
*/
void set_home_msg(string str) { home_msg = add_dot_to_msg(str); }

/*
FUNKTION: query_home_msg
DEKLARATION: string query_home_msg()
BESCHREIBUNG:
Liefert die mit set_home_msg() gesetzte Meldung zurueck.
VERWEISE: set_home_msg, set_clone_msg, set_destruct_msg
GRUPPEN: spieler
*/
string query_home_msg() { return home_msg; }

/*
FUNKTION: set_clone_msg
DEKLARATION: void set_clone_msg(string clone_msg)
BESCHREIBUNG:
Setzt die Meldung, die die anderen im Raum bekommen, wenn ein Gott ein
Objekt erschafft. Dieser Befehl ist nur bei Goettern interessant und laesst
sich auch mit dem Befehl 'zet clone_msg <string>' erreichen...
Psuedoclosures (das sind die Dinger mit dem $, zb $der() ) sind erlaubt.
VERWEISE: set_home_msg, query_clone_msg, set_destruct_msg
GRUPPEN: spieler
*/
void set_clone_msg(string str) { clone_msg = add_dot_to_msg(str); }

/*
FUNKTION: query_clone_msg
DEKLARATION: string query_clone_msg()
BESCHREIBUNG:
Liefert die mit set_clone_msg() gesetzte Meldung zurueck.
VERWEISE: set_home_msg, set_clone_msg, set_destruct_msg
GRUPPEN: spieler
*/
string query_clone_msg() { return clone_msg; }

/*
FUNKTION: set_destruct_msg
DEKLARATION: void set_destruct_msg(string destruct_msg)
BESCHREIBUNG:
Setzt die Meldung, die die anderen im Raum bekommen, wenn ein Gott ein
Objekt zerstoert. Die Meldung wird nur abgesetzt, wenn das zu zerstoerende
Objekt im Gott oder im selben Raum ist, sonst wird gar keine Meldung
erzeugt. Dieser Befehl ist nur bei Goettern interessant und laesst
sich auch mit dem Befehl 'zet destruct_msg <string>' erreichen...
Psuedoclosures (das sind die Dinger mit dem $, zb $der() ) sind erlaubt.
VERWEISE: set_home_msg, set_clone_msg, query_destruct_msg
GRUPPEN: spieler
*/
void set_destruct_msg(string str) { destruct_msg = add_dot_to_msg(str); }

/*
FUNKTION: query_destruct_msg
DEKLARATION: string query_destruct_msg()
BESCHREIBUNG:
Liefert die mit set_destruct_msg() gesetzte Meldung zurueck.
VERWEISE: set_home_msg, set_clone_msg, set_destruct_msg
GRUPPEN: spieler
*/
string query_destruct_msg() { return destruct_msg; }

int verweise(string str) {
    write("Probier's doch mal mit 'ende'.\n");
    return 1;
}

// Wichtig ist nur das  nomask  im Spieler
nomask int exec_command(varargs mixed command)
{
    if (sizeof(command) == 1 && pointerp(command[0]))
        return ::exec_command(command[0]);
    else
        return ::exec_command(command);
}

nomask int do_command(string str)
{
    int owner_level, commander_level;

    if (owner_level = query_wiz_level())
    {
	if (this_interactive() != this_player() || !this_interactive())
	    return 0;
	commander_level = query_real_player_level(this_player());
	if (commander_level <= owner_level && this_player() != this_object())
	    return 0;
	if (geteuid(previous_object()) != geteuid())
       	{
	    this_object()->send_message_to(this_object(),MT_NOTIFY,MA_UNKNOWN,
		"\ado_command: " + str + " (refused)\n");
	    return 0;
	}
	this_object()->send_message_to(this_object(),MT_NOTIFY,MA_UNKNOWN,
		"do_command: " + str + " (accepted)\n");
    }
    if (!interactive() && !is_intermud_guest()) return 0;
    return efun::command(str);
}

int set_hb(int i) {
    return set_heart_beat(i);
}

string query_last_room() { return last_room; }

int query_last_login() { return last_login; }

// Wird von login.c benoetigt.
protected void set_last_login() { last_login = time(); }

/*
FUNKTION: query_no_wer
DEKLARATION: int query_no_wer()
BESCHREIBUNG:
Liefert 1, wenn der Spieler nicht in der Wer-Liste auftauchen soll, sonst 0.
VERWEISE: set_no_wer
GRUPPEN: spieler
*/
int query_no_wer()
{
    if (testplayerp (this_object()))
        return 1;
    if (!wizp(this_object()))
	return 0;
    return no_wer;
}

/*
FUNKTION: set_no_wer
DEKLARATION: int set_no_wer(int no_wer)
BESCHREIBUNG:
Setzt bei einem Gott, ob er in der Wer-Liste auftauchen soll:
    1 : Der Gott soll nicht auftauchen
    0 : der Gott soll in der Wer-Liste auftauchen.
Bei Erfolg wird 1 returnt.
Man darf die Funktion nur bei sich selbst aufrufen, angewandt auf einen anderen
Spieler bleibt diese Funktion erfolglos.
VERWEISE: query_no_wer
GRUPPEN: spieler
*/
int set_no_wer(int flag)
{
    if ((this_player()!=this_object() || query_level() < LVL_WIZ) &&
	!adminp(this_player()) && object_name(this_player())!=
	"/room/rathaus/div/leo")
	return 0;
    no_wer = flag ? 1 : 0;
    return 1;
}

int stop_da_command(string str)
{
    if (!str)
    {
	if (stop_delayed_action() == DA_NO_ACTION)
	    return notify_fail("Es läuft gerade keine Aktion.\n");
	write("Ok.\n");
	return 1;
    }
}

nomask void set_finger_info(string s)
{
    if (this_interactive() == this_object())
	finger_info = s;
}

nomask string query_finger_info(string s)
{
    return finger_info;
}

nomask void delete_description(int player_desc) // 1: Desc neu berechnen
{
    if (this_interactive() && previous_object() && adminp(this_interactive())
	    && geteuid(previous_object()) == geteuid(this_interactive()))
    {
        if(player_desc)
        {
            descr = "/apps/description"->query_merkmal_string(this_object());
        }
        else
        {
	    descr = 0;
	    descr_source = 0;
        }
    }
}

nomask void set_description(string s)
{
    if ((object_name (previous_object()) == "/apps/description")
	    || (!strstr (object_name (previous_object()),"/obj/hlptool"))
            || (wizp(this_player()) &&
                ((query_real_name()==geteuid(previous_object()))||
                (testplayerp(this_object())==geteuid(previous_object())))))
    {
        descr = s;
    }
}

/*
FUNKTION: query_description
DEKLARATION: string query_description()
BESCHREIBUNG:
Mit dieser Funktion kann man das Aussehen eines Spielers als Ganzes abfragen.
VERWEISE: query_one_description
GRUPPEN: spieler
*/
string query_description()
{
    return descr;
}

/*
FUNKTION: query_one_description
DEKLARATION: string query_one_description(int merkmalsnummer)
BESCHREIBUNG:
Mit dieser Funktion kann ein einzelnes Merkmal des Aussehens eines Spielers
abgefragt werden. Die int - Konstanten hierfuer sind in 
/sys/player_description.h zu finden. 
Das Ueberlagern per Shadow ist priviligiert.
BEISPIEL:
    tell_object (opfer,wrap (Der(this_player())+" mustert Dich mit "
	+seinem((["name":"augen","gender":"saechlich","plural":1]),
	    this_player()->query_one_description (D_AUGENFARBE),
	    this_player())
	+" von oben bis unten."));
VERWEISE: query_description
GRUPPEN: spieler
*/
string query_one_description(int mn)
{
    if (descr_source && (mn <= sizeof (descr_source)) && (mn > 0))
	return "/apps/description"->query_one_description(mn,
		descr_source[mn - 1]);
    return 0;
}

/*
FUNKTION: set_one_description_source
DEKLARATION: nomask void set_one_description_source(int merkmalsnummer, int wert)
BESCHREIBUNG:
Mit dieser Funktion kann ein einzelnes Merkmal des Aussehens eines Spielers
gesetzt werden. Die Konstanten fuer merkmalsnummer sind in 
/sys/player_description.h zu finden.

Diese Funktion ist durch ein Mudlib-Privileg geschuetzt. Sie darf also nur
von ganz bestimmten Objekten aufgerufen werden.
VERWEISE: query_one_description
GRUPPEN: spieler
*/

nomask void set_one_description_source(int nr, int wert)
{
    if(MASTER_OB->mudlib_privilege_violation("set_one_description_source",
                      previous_object(), nr, wert))
    {
	if (!descr_source) descr_source = ({0});
	while (sizeof (descr_source) <= nr)
	    descr_source += ({0});
	descr_source [nr] = wert;

        descr = "/apps/description"->query_merkmal_string(this_object());
    }
}

nomask int *query_description_source()
{
    return copy(descr_source);
}

/*
FUNKTION: set_no_airport
DEKLARATION: int set_no_airport(int i)
BESCHREIBUNG:
Wird hiermit das no_airport Flag des Players auf 1 gesetzt, so kann
er nicht mehr von HLPs angeflogen werden.
VERWEISE: query_no_airport
GRUPPEN: spieler
*/
int set_no_airport(int i)
{
   return no_airport = i ? 1 : 0;
}

/*
FUNKTION: query_no_airport
DEKLARATION: int query_no_airport()
BESCHREIBUNG:
Hiermit kann abgefragt werden, ob ein Spieler von HLPs angeflogen
werden kann.
VERWEISE: set_no_airport
GRUPPEN: spieler
*/
int query_no_airport()
{
   if (level < LVL_HLP)
       return no_airport = 0;
   return no_airport;
}

/*
FUNKTION: add_init_ob
DEKLARATION: void add_init_ob(object ob)
BESCHREIBUNG:
Wenn einem Spieler oder einem Monster mit dieser Funktion ein Objekt
uebergeben wurde, so wird in diesem Objekt die Funktion "player_init"
bei Spielern und "monster_init" bei Monstern aufgerufen, wenn ein
Lebewesen den gleichen Raum betritt. Es wird ein Objekt - Zeiger auf
das den Raum betretende Lebewesen uebergeben, der Spieler bzw. das
Monster selbst kann mit previous_object() ermittelt werden.
VERWEISE: delete_init_ob, player_init, monster_init, set_init_ob (veraltet).
GRUPPEN: spieler, monster
*/
void add_init_ob(object was)
{
    if (!objectp(was))
	return;
    if (!to_notify_on_init)
	to_notify_on_init = ({was});
    else if (member(to_notify_on_init,was) == -1)
	to_notify_on_init += ({was});
}

/*
FUNKTION: delete_init_ob
DEKLARATION: void delete_init_ob(object ob)
BESCHREIBUNG:
    Mit dieser Funktion kann bei einem Spieler oder einem Monster ein Objekt
    aus der Liste der Objekte herausgeloescht werden, welche aufgerufen
    werden, wenn ein Lebewesen sich dem Spieler bzw. Monster naehert.
VERWEISE: add_init_ob, player_init, monster_init, set_init_ob (veraltet).
GRUPPEN: spieler, monster
*/
void delete_init_ob(object was)
{
    if (!objectp(was) || !to_notify_on_init)
	return;
    to_notify_on_init -= ({was});
}


void init()
{
    int i;

    ::init();
    if (to_notify_on_init)
    {
	to_notify_on_init -= ({0});
	for (i = sizeof(to_notify_on_init); i--; )
	    to_notify_on_init[i]->player_init(this_object(),this_player());
    }
}

void moved_in(mapping mv_infos)
{
   mv_infos[MOVE_OBJECT]->set_first_player();
   ::moved_in(mv_infos);
}

/*
FUNKTION: player_init
DEKLARATION: void player_init(object ob, object annaeherung)
BESCHREIBUNG:
Diese Funktion wird in einem Objekt aufgerufen, wenn dieses Objekt
bei einem Spieler mittels add_init_ob eingetragen worden ist und
sich dem Spieler ein Lebewesen naehert. Die uebergebenen Parameter
sind der Spieler selbst sowie das sich dem Spieler naehernde
Lebewesen.
VORSICHT:
    Bei dieser Funktion bitte beim Programmieren acht geben.
VERWEISE: add_init_ob, delete_init_ob, set_init_ob bei Monstern.
GRUPPEN: spieler
*/

/*
FUNKTION: monster_init
DEKLARATION: void monster_init(object ob, object annaeherung)
BESCHREIBUNG:
Diese Funktion wird in einem Objekt aufgerufen, wenn dieses Objekt
bei einem Monster mittels add_init_ob eingetragen worden ist und
sich dem Spieler ein Lebewesen naehert. Der erste Parameter ist das
Monster selber, der zweite uebergebene Parameter ist das sich dem
Monster naehernde Lebewesen.
VERWEISE: add_init_ob, delete_init_ob, player_init, set_init_ob (veraltet).
GRUPPEN: monster
*/

nomask int query_version()
{
    return version;
}

#if 1
//
// Kleidungs-Handling
//
// Kleidungen und Ruestungen, die man angezogen hat, 'wiegen' eins
// weniger, so dass man etwas mehr tragen kann. Das ganze wird daruch
// realisiert, dass in 'num_worn_objects' gemerkt wird, wieviele Kleidungen
// man an hat und man dieses Gewicht ueber die Maximalgrenze hinaus tragen
// kann.
//
static private int num_worn_objects;
static private object *worn_objects = ({});

int query_num_worn_objects()
{
    return num_worn_objects;
}

object *query_worn_objects(int flag)
{
    if (flag && adminp(this_interactive()))
	worn_objects -= ({0});
    return ({}) + worn_objects;
}

void notify(string message, varargs mixed data)
{
    data = expand(data);
    switch(message)
    {
	case "wear":
	    if (data[0]->query_weight())
	    {
		if (member(worn_objects,data[0]) >= 0)
		{
		    sys_log("KLEIDUNG",sprintf("Kleidung ist schon eingetragen: %-10s %O\n",query_real_name(),data[0]));
		}
		else if (!present(data[0]))
		{
		    sys_log("KLEIDUNG",sprintf("Kleidung - nicht present: %-10s %O\n",query_real_name(),data[0]));
		}
		else
		{
		    num_worn_objects++;
		    worn_objects = worn_objects + ({data[0]});
		}
	    }
	    break;
	case "undress":
	    if (data[0]->query_weight())
	    {
		if (member(worn_objects,data[0]) < 0)
		{
		    sys_log("KLEIDUNG",sprintf("Kleidung ist NICHT eingetragen: %-10s %O\n",query_real_name(),data[0]));
		}
		else if (num_worn_objects <= 0)
		{
		    sys_log("KLEIDUNG",sprintf("num_worn_objects wird negativ: %-10s %O\n",query_real_name(),data[0]));
		}
	    	else if (!present(data[0]))
		{
		    sys_log("KLEIDUNG",sprintf("Kleidung - nicht present: %-10s %O\n",query_real_name(),data[0]));
		}
		else
		{
		    num_worn_objects--;
		    worn_objects = worn_objects - ({data[0]});
		}
	    }
	    break;
    }
    ::notify(message,data);
}

mixed forbidden(string message, varargs mixed data)
{
    int weight, max_enc;

    data = expand(data);
    switch(message)
    {
	case "undress":
	    weight = data[0]->query_weight();
	    if (weight > 0)
	    {
		max_enc = query_max_internal_encumbrance();
		if (max_enc && query_internal_encumbrance() >= max_enc + num_worn_objects)
		{
		    notify_message(wrap("Du kannst nicht genug tragen, um " +
			    den(data[0]) + (data[0]->aufsetzbar() ?
				" abzusetzen." : " auszuziehen.")));
		    return 1;
		}
	    }
    }
    return ::forbidden(message,data);
}

int add_encumbrance(object ob, int enc_type, int enc_diff)
{
    int max_enc, ret;

    if (max_enc = query_max_internal_encumbrance())
	set_max_internal_encumbrance(max_enc + num_worn_objects);
    ret = ::add_encumbrance(ob,enc_type,enc_diff);
    set_max_internal_encumbrance(max_enc);
    return ret;
}
// End of Kleidungs-Handling
#endif

/*
FUNKTION: add_temporal_adjektiv
DEKLARATION: nomask varargs void add_temporal_adjektiv(mixed adj, int duration, int front)
BESCHREIBUNG:
Mit dieser Methode kann bei Spielern eines oder mehrere temporaere Adjektive
hinzugefuegt werden, welche spaetestens beim naechsten Einloggen weg sind.
adj kann ein String oder ein Stringarray sein.
Ist duration > 0, so wird das Adjektiv in duration Sekunden wieder entfernt.
Ist front == 1, so wird das Adjektiv am Anfang der Adjektive eingefuegt.

Hinweis: Es gibt keine Methode delete_temporal_adjektiv, soll ein temporaeres
Adjektiv wieder entfernt werden, so soll dafuer delete_adjektiv verwendet
werden.
VERWEISE: add_adjektiv, delete_adjektiv, set_adjektiv, query_adjektiv
GRUPPEN: spieler, grammatik
*/


nomask varargs void add_temporal_adjektiv(mixed adj, int duration, int front)
{
     if (stringp (adj)) {
         if (!temporal_adjektives)
             temporal_adjektives = ({adj});
         else
             temporal_adjektives += ({adj});
     } else if (pointerp (adj)) {
         if (!temporal_adjektives)
             temporal_adjektives = adj;
         else
             temporal_adjektives += adj;
     }
     else return;
     delete_adjektiv (adj);
     add_adjektiv (adj, front);
     if (duration > 0)
         call_out ("delete_adjektiv", duration, adj);
}


void get_tip ()
{
    string tip;
    if (this_player() != this_object()) return;
    if (tip = TIPS_MASTER->get_suiting_tip_for (this_object()))
        write (wrap_say ("Tip:", tip));
}

void msg_wiedereinstieg()
{
    if (this_player() != this_object()) return;
    string txt = "Herzlich willkommen zurück im Pantheon. "
        "Für Wiedereinsteiger gibt es ein Buch mit"
        "\nzerschaffe /room/rathaus/obj/wiedereinstieg.c";
    this_object()->send_message_to(this_object(),
                MT_SENSE|MT_FAR, MA_COMM,
                wrap_say("Leo redet zu Dir:", txt));
    this_object()->add_to_rede_puffer(
                wrap_say("Leo redete zu Dir:",txt));
}

nomask static void set_no_tips(int t)
{
    no_tips = t;
}

public nomask int query_no_tips()
{
    return no_tips;
}

/*
FUNKTION: query_no_ascii_art
DEKLARATION: nomask int query_no_ascii_art()
BESCHREIBUNG:
Diese Funktion liefert, ob man statt ASCII-Graphiken lieber eine textuelle
Anzeige haben moechte. Eine solche textuelle Anzeige sollte zur Sprachausgabe
geeignet sein (also moeglichst wenig signifikante Sonderzeichen enthalten)
und nicht besonders scrollen.
VERWEISE: set_no_ascii_art
GRUPPEN: spieler
*/
nomask int query_no_ascii_art()
{
    return no_ascii_art;
}

/*
FUNKTION: set_no_ascii_art
DEKLARATION: nomask int set_no_ascii_art(int no_ascii_art)
BESCHREIBUNG:
Mit dieser Funktion kann man setzen, ob man statt ASCII-Graphiken lieber
eine textuelle Anzeige haben moechte. Diese Option dient zur Unterstuetzung
sehbehinderter Spieler und nicht fuer irgendwelche spielerischen Effekte!
VERWEISE: query_no_ascii_art
GRUPPEN: spieler
*/
nomask void set_no_ascii_art(int a)
{
    no_ascii_art = a;
}

// Wird nur intern verwendet.
nomask static void set_filter_spam(int fs)
{
    filter_spam = fs;
}

nomask static int query_filter_spam()
{
    return filter_spam;
}

static void srurne_info()
{
    string *themen = "/room/wahlen/srurne"->query_vote_list(this_object());
    if(!sizeof(themen)) return;
    write("\n----- Neue Themen an der Spielerratsurne: -------------------------------------\n "
         + implode(themen,"\n ") +
          "\n----- (Mit dem Befehl 'srurne' kannst Du dort abstimmen.) ---------------------\n");
}

static int srurne(string str)
{
    string err="/room/wahlen/srurne"->read_list();
    if(!strlen(err)) return 1;
    notify_fail(err);
    return 0;
}

// Ein paar SIcherheitsueberlagerungen:
nomask static void set_hp_view(int hp_view) {::set_hp_view(hp_view);}

// Player ID
nomask int query_pid()
{
    // Sicherheitsabfrage.
    if(object_name(previous_object()) != PLAYER_SECOND)
    {
        return 0;
    }

    if(pid < 0)
    {
        // PID ist kleiner 0, d.h. wir muessen erst die Gueltigkeit pruefen.
        if(PLAYER_SECOND->is_second(-pid, query_real_name()))
	{
	    // PID ist gueltig. Negatives Vorzeichen entfernen.
	    pid = -pid;
	}

	else
	{
	    // PID ist ungueltig. Nullen.
	    pid = 0;
	}
    }

    return pid;
}

nomask void set_pid(int id)
{
    // Sicherheitsabfrage.
    if(object_name(previous_object()) != PLAYER_SECOND)
    {
        return 0;
    }
    
    pid = id;
}

nomask static void update_points_display()
{
    "*"::update_points_display();
}

void announce_achievement(int type, mapping info)
{
    "*"::announce_achievement(type, info);
}
