// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/i/value.c
// Description:

#pragma save_types

private int value;
private int no_store;

/*
FUNKTION: set_value
DEKLARATION: void set_value(int val)
BESCHREIBUNG:
Mit dieser Funktion setzt man den Wert eines Objektes in Talern.
Siehe /doc/richtlinien/geschaefte.
VERWEISE: query_value
GRUPPEN: handel
*/
void set_value(int val)
{
    value = val;
    this_object()->add_setter_conservation("set_value",({value}));
}

/*
FUNKTION: query_value
DEKLARATION: int query_value()
BESCHREIBUNG:
Mit dieser Funktion kann man den Wert eines Objektes in Talern abfragen.
VERWEISE: set_value
GRUPPEN: handel
*/
int query_value() { return value; }

/*
FUNKTION: set_no_store
DEKLARATION: void set_no_store(int flag)
BESCHREIBUNG:
Mit dieser Funktion kann man setzen, ob das Objekt nach dem Verkaufen
zerstoert werden soll. Das ist z.B. fuer Raetsel-Objekte wichtig.
VERWEISE: query_no_store
GRUPPEN: handel
*/
void set_no_store(int a)
{
    no_store = a != 0;
    this_object()->add_setter_conservation("set_no_store",({no_store}));
}

/*
FUNKTION: query_no_store
DEKLARATION: int query_no_store()
BESCHREIBUNG:
Mit dieser Funktion kann man abfragen, ob das Objekt nach dem Verkaufen
zerstoert werden soll. Das ist z.B. fuer Raetsel-Objekte wichtig.
VERWEISE: set_no_store
GRUPPEN: handel
*/
int query_no_store() { return no_store; }

/*
FUNKTION: just_sold
DEKLARATION: void just_sold()
BESCHREIBUNG:
Diese Funktion sollte aufgerufen werden, wenn das Objekt verkauft wurde.
Falls 'no_store' gesetzt ist, wird das Objekt zerstoert.
VERWEISE: set_no_store, query_no_store
GRUPPEN: handel
*/
void just_sold()
{
    if (no_store)
	this_object()->remove();
}

/*
FUNKTION: query_sellable
DEKLARATION: int query_sellable()
BESCHREIBUNG:
Wenn diese Funktion 1 zurueckgibt, dann kann man das Objekt verkaufen.
GRUPPEN: handel
*/
int query_sellable() { return 1; }
