// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:        /map/obj/pottwal.c
// Description: Ein Pottwal fuer die Ozean-Map
// Author:      Pif (20.08.97)
// Modified by: Pif (31.03.98) Endlich wird nach einem move der Raumtyp
//                             abgefragt (siehe das stranden-inherit).


inherit "/map/i/stranden";

#include <invis.h>
#include <stats.h>
#include <description.h>

void abtauchen()
{
  if (query_invis() || !player_present(environment()) ||
      query_in_fight() || find_call_out("raumtyp_test") != -1) {
      return;
      }
  tell_room(environment(),
            wrap(Der()+" taucht in die Tiefe."));
  set_invis(V_HIDDEN);
  if (find_call_out("auftauchen") == -1) {
      call_out("auftauchen",random(300));
      }
}

void auftauchen()
{
  if (!player_present(environment()) ||
       find_call_out("raumtyp_test") != -1) {
       return;
       }
  set_invis(V_VIS);
  tell_room(environment(),
            wrap(Ein(this_object(),"riesig")+" taucht ganz in Deiner "
                 "Nähe langsam aus dem Meer auf."));
  tell_room(environment(),
            wrap("Beim Ausatmen schleudert "+der()+" mit hohem Druck "
                 "Wasser aus seinem Blasloch, welches sich sogleich "
                 "zu einer weithin sichtbaren Wolke formt."));
}

void heart_beat()
{
  ::heart_beat();
  if (!player_present(environment())) {
      return;
      }
  if (find_call_out("abtauchen") == -1 &&
      find_call_out("auftauchen") == -1 &&
      find_call_out("raumtyp_test") == -1) {
      call_out("abtauchen",random(300));
      }
}

int no_attack(object angreifer, object waffe)
{
  if (query_invis()) {
      write(wrap("Du kommst nicht nah genug an "+den()+
                 " unter Dir im Wasser heran, um ihn "
                 " angreifen zu können."));
      say(wrap(Der(angreifer)+" versucht, an "+den()+" unter "
               "sich heranzukommen, indem "+er(angreifer)+
               " krampfhaft im Wasser herumfuchtelt "),
               angreifer);
      return 1;
      }
  return 0;
}

string query_far()
{
  return wrap("Dazu kommst Du nicht nah genug an "
    +den(this_object(),"riesig")+" heran.");
}

int query_start_random()
{
  return !query_invis();
}

string query_long (object betrachter)
{
    betrachter->set_gesehen();
    return ::query_long (betrachter);        
}
     
string query_hp_string()
{
  return query_invis() ? "" : ::query_hp_string();
}  

varargs mapping query_v_item(mixed *pfad, int flag)
{
  mapping v_items;
  v_items = ::query_v_item(pfad, flag);
  if (!(query_invis() && clonep() && mappingp(v_items))) {
      return v_items;
      }    
  return v_items +
    ((["long":"Der Wal ist zu tief abgetaucht, als dass "
              "Du genauere Details erkennen könntest.\n",
       "look_msg":(:wrap(Der(this_player())+" schaut angestrengt nach "
                  "dem Wal in der Tiefe.") :)]));
}

// Falls ein Wal mal an Land geraet:

string query_agonie()
{
  return Der()+" schlägt panisch mit seiner Fluke auf den Boden.";
  // smothered hope
}

string query_sterben()
{
  return "Die verzweifelten Bewegungen "+des()+" gehen allmählich "
         "in ein Zucken über, bis er schließlich regungslos liegen bleibt.";
}

string query_leiche_kurz()
{
  return "Die Leiche eines Pottwales";
}

string query_leiche_lang()
{
  return "Die Leiche eines Pottwales, der - wie auch immer - aufs Land "
         "geraten ist und dort von seinem eigenen Gewicht erdrückt wurde.";
}

void reset()
{
  set_invis(V_HIDDEN);
}  

void create()
{
    ::create();
    initialize("pottwal");
    set_id(({"wal","pottwal","physeter","zahnwal", "map fish"}));
    set_gender("maennlich");

    set_long(({
	T_FUNC("query_invis"),
	({
    	    // Eigentlich auch unrealistisch, weil ein Pottwal so tief
    	    // taucht, dass man ihn gar nicht mehr sehen wuerde. Fuers
	    // mud ist es so aber schoener.
	    "Ein großer, dunkler Schatten bewegt sich unter "
            "Dir durchs Wasser.",
	}),
	T_ELSE,
	({
	    "Der Pottwal scheint ausgesprochen groß zu sein, "
            "wenn auch meistens nur ein kleiner Teil seiner "
            "massigen Gestalt aus dem Meer ragt. Ist er an der "
            "Wasseroberfläche angelangt, kann man die Größe "
            "seines mächtigen Körpers zumindest erahnen.",
	}),
    }));

    set_align(100);
    set_smell("Der Wal riecht ein wenig tranig.");

    add_random_activities(([
    "!echo $Der() bewegt sich bedächtig durchs Wasser." : 0,
    "!echo Die Schwanzfluke $des() klatscht laut auf "
    "die Wasseroberfläche." : 0,
    "!echo $Der() taucht gemächlich ins Wasser ein um nach kurzer "
    "Zeit wieder an der Wasseroberfläche zu erscheinen." : 0,
    "!echo Bei einer ausladenden Bewegung $des() schwappt "
    "Dir etwas Wasser entgegen." : 0,
    "!echo $Der() stößt eine meterhohe Blaswolke "
    "aus seinem Blasloch." : 0
    ]));
    set_activity(4);
#include "w_detail.h"
    reset();
}

void init()
{
  ::init();
  if (find_call_out("auftauchen") == -1 && query_invis()) {
      call_out("auftauchen",5);
      }
}
