// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/obj/hlptool.c
// Description:	high level player tool - hlptool
// Author:	Garthan   (1994)
// Modified by:	Garthan   (15.05.96) - neues autoload format, flight delay autol.
//              Sissi     (24.05.96) - "Gabenpunkte"
//              Sissi     (26.06.96) - Bewegungsmeldungen muessen Namen enthalten,
//                                     werden auch beim login getestet
//              Sissi     (19.12.96) - Fliegen dauert...
//              Sissi     (30.04.97) - Finsterlinge kriegen einige Gaben nicht
//		Sissi	  (15.11.97) - Gabenpreise veraendert, ein Gabenpunkt wird
//				       nicht mehr als EPs in Promille - 1000
//				       berechnet sondern in
//					  (EPs - TOTAL_EXPERIENCE) / 100
//				       Funktion: query_gabenpunkte().
//				     - Die Gabe "Weisheit" ausgebaut
//			 	     - "Heilung" heilt nur noch APs
//              Sissi     (18.11.98) - fliegen_erlaubt, flugstart_meldung,
//                                     lande_meldung
//              Parsec    (27.11.98) - /i/tools/room_types fuer Innenraum-Test
//                                   - Andere sehen beim Betrachten der Fluegel
//                                     wem diese gehoeren
//              Jesaia    (27.03.00) - GP un angepasst
//              Sissi     (01.04.00) - emoten auf dem Engelskanal
//              Parsec    (02.07.00) - kein Sehe ins Pantheon
//              Adanedhel (19.10.00) - vitem - Gabe
//              Sissi     (22.10.00) - eben jene ueberarbeitet
//              Sissi (26.-28.11.00) - endlich damit weitergemacht

inherit "/i/item";
inherit "/i/install";
inherit "/i/money/bank";
inherit "/i/tools/room_types";

#include <add_hp.h>
#include <apps.h>
#include <config.h>
#include <deklin.h>
#include <error.h>
#include <eyes.h>
#include <invis.h>
#include <landschaft.h>
#include <level.h>
#include <message.h>
#include <more.h>
#include <move.h>
#include <notify_fail.h>
#include <stats.h>
#include <time.h>
#include <touch.h>
#include <input_to.h>

#define HELP (HELP_PATH+"/hlp.help")

#define FAIL(x) return notify_fail(x)
#define TEST(x) if(fail_gabe(x)) return 0
#define MORD(x) if(sizeof(environment()->query_opfer()) >= x) \
		    FAIL("Als Moerder darfst du das nicht!\n")

#define E_GABE 0
#define E_DESC 1
#define E_COST 2
#define E_MORD 3

#define AL_GABEN 1
#define AL_ORTE 2
#define AL_EXTRA_LOOK 3
#define AL_FLIGHT_DELAY 4
#define AL_ALIGN_STRING 5
#define AL_TIME_OF_NEXT_FLIGHT 6
#define AL_VITEM 7
#define AL_FLAGS 8
#define AL_EIGENE_FLUGZIELE 9
#define AL_SURVIVAL 10
#define AL_FLUEGEL 11

// Bitflags fuer AL_FLAGS:
#define ALF_VOLLERBAUCH 1

#define V_ITEM_MAX 5

#define VLOG "/sys/log/vlog"
#define V_NAME "name"
#define V_GENDER "gender"
#define V_IDS "id"
#define V_LONG "long"
#define V_ADJ "adjektiv"
#define V_PLURAL "plural"
#define V_NOISE "noise"
#define V_FEEL "feel"
#define V_READ "read"
#define V_SMELL "smell"

// Brauchen ein eigens definierten Mappingeintrag
// fuer das Aussehen der Fluegel, "long" wuerde
// die Closure #'fluegellook ueberschreiben
#define V_FL_LONG "x_long"


string orte = "";
string *gaben = ({});
string align_string = 0;
mapping* vitems = ({});
mapping new_vitem;
mapping fluegel;
int flags=0;

string flugziel = 0;
string notlandeziel, rueckflugziel, rueckflugnotlandeziel, flugzielname;
int flugziel_ist_spieler, zeitpunkt_des_naechsten_fluges, flugsperre;
string* eigene_flugziele;
object flugraum;

static int follow;
static object followed_ob;

// Prototypen fuer FL, sonst muss ich die halbe Kugel umgraben
string fluegellook(mapping m, object who); 
string convertstr(string str);

static mapping base =
([
   "ev" : "eVolk";	"Anzeige aller Spieler mit Aufenthaltsgegend";	1000; 0,
   "er" : "eRede";	"Rede unter Engeln";				  50; 0,
   "eb" : "eBruelle";	"Brülle unter Engeln"; 				 100; 0,
   "mn" : "Mail/News";	"Eigener Mail- und Newsreader"; 		2000; 0,

   "ad" : "Adjektiv";	"Eigenes Adjektiv setzen"; 			 300; 0,
   "ge" : "Geruch";	"Eigenen Geruch setzen";			 300; 0,
   "gr" : "Geräusch";	"Eigenes Geräusch setzen";			 300; 0,
   "gf" : "Anfühlen";	"Eigenes Anfühlen setzen (betaste Xyz)";	 300; 0,
   "au" : "Aussehen";	"Eigenes Aussehen beschreiben";			 600; 0,
   "an" : "Ansicht";	"Bewegungsmeldungen ansehen";                      0; 0,
   "me" : "Meldungen";  "Bewegungsmeldungen setzen";			1500; 0,
   "ti" : "Titel";	"Eigenen Titel wählen";			 	 600; 0,
   "pt" : "Persönlicher Titel"; "Eigenen persönlichen Titel wählen"; 1000; 0,
   "in" : "Inhalt";	"Inhaltsmeldung setzen";			 200; 0,
   "et" : "Eigentümlichkeit";"Eigentümlichkeit";                      1000; 0,

   "he" : "Heilung";	"Eigene Sofort-Heilung";		       20000; 1,
   "un" : "Unsichtbarkeit";	"Unsichtbarkeit für Engel";		4000; 1,
   "us" : "Unsterblichkeit"; "Keine Bedrohung mehr durch übles Pack"; 20000; 1,
   "st" : "Sterblichkeit"; "Wieder sterblich sein (Gabe \"us\" loswerden)";5000; 0,
   "pf" : "Pfadfinder"; "Fähigkeit, Dir Flugziele zu merken";		1000; 0,
   "ef" : "EigenesFlugziel"; "Merken eines einzigen, eigenen Flugziels";10000; 1,
   "fo" : "Flug/Ort";	"Fliegen zu bestimmten Orten";			7000; 2,
   "fs" : "Flug/Spieler";	"Fliegen zu anderen Spielern";	       10000; 2,
   "fg" : "Flug/Gepaeck";	"Fliegen mit Gepaecklast";	       20000; 2,
   "fgh": "Flug/Handgepaeck";	"Fliegen mit Handgepaecklast";	       8000; 2,
   "fgn": "Flug/normalem Gepäck";	"Fliegen mit normaler Gepaecklast";	       8000; 2,
   "fgl": "Flug/Lasttiergepaeck";	"Fliegen mit Lasttiergepaecklast";	       8000; 2,
   "ff" : "Flug/Schiff"; "Eigenes Schiff als Flugziel";                 2500; 2,
   "fh" : "Flughafen";		"Selbst Anflugziel sein oder nicht";    1000; 2,
   "hi" : "Himmel"; "Flug in den Himmel";				1500; 2,
   "tf" : "TurboFlug"; "Schneller Flug";                               10000; 2,
   "te" : "TurboFluegelerholung";"Turbo Erholung der Flügel nach einem Flug";    10000; 2,
   "ve" : "Verfolgung"; "Verfolgung eines Spielers";			1200; 2,
   "li" : "Licht";	"Ein Licht in alle Dunkelheit";			2000; 3,
   "sb" : "Schwatzbase"; "Kostenloses Reden";                           1500; 3,
   "sr" : "Schreihals"; "Brüllen kostet nur noch die Hälfte ZPs";	1500; 2,
   "sg" : "Schnelle Genesung";	"Schnellere Heilung als Spieler";	5000; 2,
   "vb" : "Voller Bauch"; "Nie wieder Hunger oder Durst";		2000; 2,
   "se" : "Seher"; "Aufenthaltsorte von anderen sehen";			2000; 3,
   "ba" : "Bankier"; "Ein- und Auszahlungen ohne zur Bank zu gehen";	2000; 3,
   "la" : "Lasttier"; "Tragkrafterhoehung";				3000; 3,
   "fi" : "Fingertext"; "Zusatztext setzen für den Finger - Befehl";    700; 0,
   "fi2": "Doppelter Fingertext"; "Doppelt so langer Fingertext";       1400; 0,
   "de" : "Details"; "Eigene Details erschaffen und beschreiben";	1700; 0,
   "de2": "Doppelte Details"; "Doppelt so viele Details";               3400; 0,
   "su" : "Survival";"Erlaubt Dir einen Survival-Urlaub";                100; 0,
   "fl" : "Flügel";"Eigene Flügel beschreiben"; 1000; 0,                                                          
]);

// Im Blueprint: (["name":({ gaben, ...}) ])
// Im Clone: ([gaben, ... ])
static mapping verbote=([]);

static mapping abflug_meldung =
([
   "map":"Du fliegst immer höher und lässt den Ozean tief unter dir zurück.",
   "Vaniorh":"Du lässt die Insel Vaniorh mit ihren großen Sandstränden, "
	     "hohen Klippen, dem vielen Wald und ihren Siedlungen hinter dir "
	     "im Meer verschwinden.",
   "Maerchenland":"Leider verlässt du diese gastliche Insel. Es "
		  "scheint so, als hätte dein Herz Heimweh nach der "
		  "Beschaulichkeit der zurückbleibenden Insel.",
   "Gallien":"Hinter dir entschwindet das weite Gallien mit all seinen "
	     "Wäldern und den hohen Alpen am Horizont. Die Loire schickt "
	     "noch einen verirrten Sonnenstrahl zum Abschied durch eine "
	     "Wolkenluecke, dann ist auch sie unter den ewigen Wolken "
	     "verschwunden und du bist Taranis und seinen berüchtigten "
	     "gallischen Gewittern entkommen.",
   "Arktis":"Du lässt die Insel aus Eis und Schnee zusammen mit der Kälte "
	    "langsam aber sicher hinter dir am Horizont verschwinden.",
   "Doerrland":"Du entfernst dich immer mehr von Dörrland, von der kargen, "
	       "sandigen, öden Wüstenlandschaft. Die Felsen wirken von hier "
	       "oben ganz klein, die Kakteen und Sträucher sind nur noch "
	       "kleine Punkte. Zum Glück lässt endlich auch die Hitze "
	       "wieder nach.",
   "Kokosinsel":"Du lässt die Inselgruppe der Kokosinseln mit ihren Palmen, "
		"Sümpfen, Hügeln, Löwen und Stieren von Phrygia und "
		"Kreta, den beiden riesigen Vulkanen von Vulkanien und "
		"den Wäldern und Felsen von Nublar hinter dir zurück.",
   "Midgard":"Du lässt Midgard mit seiner vielfältigen Landschaft "
		"hinter dir im Meer zurück, das Eis der Eisregion "
		"glitzert im Sonnenlicht, die hohen Berge sind selbst von "
		"hier aus noch beeindruckend.",
   "Ebenen":"Auf einmal dreht sich alles, du kippst zur Seite ab, du "
	    "flippst herüber in eine andere Welt; von der Welt der tausend "
	    "Ebenen, die du hinter dir zurückgelassen hast, ist nichts "
	    "mehr zu sehen.",
   "Campus":"Die Zeit scheint still zu stehen. Nein, sie läuft rückwärts. "
	    "Nein, sie läuft nicht rückwärts, sie rast rückwärts; alles "
	    "um dich herum beginnt zu flimmern, sich aufzulösen. Du findest "
	    "dich in einer anderen Welt, in einer anderen Zeit wieder. "
	    "Du beginnst, dich zu orientieren..."
]);

static mapping ankunft_meldung =
([
   "map":"Du fliegst immer tiefer dem Ozean entgegen.",
   "Vaniorh":"Du näherst dich einer Insel mit hohen Klippen, großen "
	     "Sandstränden und viel Wald. Du kannst auch eine größere "
	     "Siedlung auf ihr erkennen.",
   "Maerchenland":"Du näherst dich einer kleinen Insel, die etwas ganz "
		  "harmonisches auszustrahlen scheint. Es kommt dir vor, "
		  "als würde dein Herz einen kleinen Hüpfer vor Freude "
		  "machen.",
   "Gallien":"In der Ferne erblickst du bereits das schöne waldreiche "
	     "Gallien. Du erkennst viele Flüsse, dichte Wälder und im "
	     "Süden und Südosten auch hohe, schneebedeckte Berge. Beim "
	     "Näherkommen bemerkst du mehrere Häfen rund um den Kontinent "
	     "und mehrere Ansiedlungen mit pulsierendem Leben. Eine Stadt "
	     "fällt dir besonders auf - ja, es ist die Hauptstadt Lutetia, "
	     "immer eine Reise wert!",
   "Arktis":"Es wird immer kälter, du beginnst zu frösteln. In der Ferne "
	    "erblickst du eine Insel aus Schnee und Eis, der du dich "
	    "näherst.",
   "Doerrland":"Du näherst dich einer großen Insel, die nur aus einem "
	       "einzigen, riesigen Sandstrand zu bestehen scheint. Sand, "
	       "wohin das Auge blickt, nur unterbrochen von einigen "
	       "Felsformationen. Mit viel Mühe kannst du bereits Kakteen "
	       "und Sträucher erahnen.",
   "Kokosinsel":"Du näherst dich einer kleinen Inselgruppe, auf den beiden "
		"größten Inseln wachsen Palmen, du erkennst dort Sümpfe. "
		"Die nächste Insel fällt durch ihre hohen Felsen auf, "
		"sie ist bewaldet. Die vierte Insel wird von zwei hohen "
		"Vulkanen dominiert, die die Insel überragen.",
   "Midgard":"Du näherst dich Midgard, was du an den riesigen "
		"Gebirgen, der Schneeregion, den vielen Flüssen und "
		"Wäldern erkennst.",
   "Ebenen":"Die Welt um dich herum löst sich auf, die Dimensionen krümmen "
	    "sich, du verlierst jegliche Orientierung und weißt für einen "
	    "Moment nicht mehr, wo oben und unten ist, aus einem anfänglichen "
	    "Flimmern und Schimmern wird auf einmal die Welt der tausend "
	    "Ebenen, welche hoch unter dir, oder etwa tief über dir, "
	    "Gestalt annimmt. Du fliegst auf sie zu.",
   "Campus":"Die Zeit beginnt zu rasen, wie verrückt; alles um dich herum "
	    "beginnt zunächst, zu flimmern, um sich dann aufzulösen. "
	    "Da beruhigt sich alles wieder, du bist in einer anderen Welt "
	    "herausgekommen, in einer anderen Zeit. Du beginnst, dich "
	    "zu orientieren..."
]);

/*
string query_align_string()
{
   return align_string;
}

string set_align_string(string str)
{
   return align_string = str;
}
*/

int gesperrt(string str)
{
   int grenze, opfer;

   grenze = base[str,E_MORD];
   opfer = sizeof(environment()->query_opfer());
   if(grenze && opfer >= grenze)
      return opfer;
}
/*
FUNKTION: forbidden_hlp_gabe
DEKLARATION: string forbidden_hlp_gabe(object player, string gabe, object kugel)
BESCHREIBUNG:
Bevor eine Gabe vom Engel player genutzt wird, wird in allen mit
player->add_controller("forbidden_hlp_gabe",ob) angemeldeten Objekten
ob->forbidden_hlp_gabe(player, gabe, kugel) aufgerufen. Liefert dieser
Aufruf einen String zurueck, so wird die Gabe nicht genutzt und sofern die
Ausgabe einer Fehlermeldung nicht unterdrueckt werden sollte, dieser String
ausgegeben. (Er wird dabei korrekt umgebrochen.)

Diese Moeglichkeit sollte nur sehr selten genutzt werden und mit den
Admins abgesprochen werden.
VERWEISE: GABE, forbidden_hlp_gabe_here
GRUPPEN: level
*/


/*
FUNKTION: forbidden_hlp_gabe_here
DEKLARATION: string forbidden_hlp_gabe_here(object player, string gabe, object kugel)
BESCHREIBUNG:
Bevor eine Gabe vom Engel player genutzt wird, wird in allen beim umgebenden
Raum room mit room->add_controller("forbidden_hlp_gabe_here",ob) angemeldeten
Objekten ob->forbidden_hlp_gabe_here(player, gabe, kugel) aufgerufen.
Liefert dieser Aufruf einen String zurueck, so wird die Gabe nicht genutzt
und sofern die Ausgabe einer Fehlermeldung nicht unterdrueckt werden sollte,
dieser String ausgegeben. (Er wird dabei korrekt umgebrochen.)

Diese Moeglichkeit sollte nur sehr selten genutzt werden und mit den
Admins abgesprochen werden.
VERWEISE: GABE, forbidden_hlp_gabe
GRUPPEN: level
*/

nomask int query_surviving ();

varargs int gabe(string str, int no_output)
{
   int res;

   if (query_surviving()) {
      if (!no_output)
         notify_fail ("Du befindest Dich doch auf einem Survival-Urlaub.\n"
             "Erhol Dich erstmal richtig vom stressigen Engelsleben.\n");
      return 0;
   }
   if(verbote && member(verbote,str))
   {
      if(!no_output)
         notify_fail("Diese Gabe haben Dir die Götter wieder genommen!\n");
      return 0;
   }
   if(wizp(environment()) && (str != "tf") && (str != "st"))
      res = 1;
   else if((res = (member(gaben, str) >= 0)) && gesperrt(str))
   {
      res = 0;
      if(!no_output)
	 notify_fail("Als Mörder kannst du diese Gabe nicht mehr benutzen.\n");
   }
   if(res)
   {
      string err;
      object ob = environment();
      err = ob->forbidden("hlp_gabe", ob, str, this_object());
      if(!err && (ob=environment(ob)))
         err = ob->forbidden("hlp_gabe_here",environment(), str, this_object());
      if(!no_output)
      {
         string tmp;
         if(stringp(err))
	    notify_fail(wrap(err));
	 else if(tmp = base[str,E_GABE])
	    notify_fail(wrap("Deine Gabe '"+tmp+"' versagt!"), FAIL_NOT_CMD);
	 else
	    notify_fail("Deine Gabe versagt.\n", FAIL_NOT_CMD);
      }
      res = !err;
   }
   return res;
}

varargs int fail_gabe(string str, int no)
{
   string tmp;

   if(!no && (tmp = base[str,E_GABE]))
      notify_fail(wrap("Du besitzt die Gabe '"+tmp+"' gar nicht!"), FAIL_NOT_CMD);
   if(!gabe(str,no))
      return 1;
}


mixed query_auto_load()
{
    int flight_delay, sui;
    mapping ret;

    ret = ([]);

    if(fluegel)
        ret[AL_FLUEGEL] = fluegel;
    if(gaben)
        ret[AL_GABEN] = gaben;
    if(orte)
        ret[AL_ORTE]  = orte;
    if((flight_delay = find_call_out("fly_again")) > 0)
        ret[AL_FLIGHT_DELAY] = flight_delay;
    if(align_string)
        ret[AL_ALIGN_STRING] = align_string;
    if(zeitpunkt_des_naechsten_fluges
       && (time()<zeitpunkt_des_naechsten_fluges))
       if (flugsperre)
            ret[AL_TIME_OF_NEXT_FLIGHT] = -zeitpunkt_des_naechsten_fluges;
        else
            ret[AL_TIME_OF_NEXT_FLIGHT] = zeitpunkt_des_naechsten_fluges;
    ret[AL_VITEM] = vitems;
    if(flags)
        ret[AL_FLAGS] = flags;
    if (eigene_flugziele && sizeof (eigene_flugziele))
        ret[AL_EIGENE_FLUGZIELE] = eigene_flugziele;
    if (sui = query_surviving())
        ret[AL_SURVIVAL] = sui;
    return ret;
}

void fluegel_montieren() 
{
  
	  environment()->delete_v_item (({"flügel"}));
	  
	  if(gabe("fl",1)&&fluegel) 
	  {
	    environment()->add_v_item (([
	      "name" : "flügel",
	        "id" : "flügel",
	    "plural" : 1,
	    "gender" : "maennlich",
	      "long" : #'fluegellook,
	     "smell" : fluegel["smell"],
	     "noise" : fluegel["noise"],
	      "feel" : fluegel["feel"],
	    ]));
	  }
	  else {
	    environment()->add_v_item (([
	      "name" : "flügel",
	        "id" : "flügel",
	    "plural" : 1,
	    "gender" : "maennlich",
	      "long" : #'fluegellook,
	    ]));
	  }
}

void init_arg(mixed str)
{
   int flight_delay, sui;
   string extra_look;
   
   if (!playerp (previous_object())
       && ((object_name(previous_object())[0..14] != "/obj/zauberstab") 
           || (query_verb()[0..3] != "zern"))) return;

   if(pointerp(str)) /* ALT: vor 15.5.96 */
   {
      extra_look = str[<2];
      orte = str[<1];
      gaben = str[0..<3];
   }
   else if(mappingp(str)) /* NEU */
   {
      fluegel    = str[AL_FLUEGEL];
      gaben      = str[AL_GABEN];
      if (member (gaben,"d2") != -1)
          gaben = (gaben - ({"d2"})) + ({"de2"});
      if (member (gaben,"f2") != -1)
          gaben = (gaben - ({"f2"})) + ({"fi2"});
      orte       = str[AL_ORTE];
      extra_look = str[AL_EXTRA_LOOK];
      align_string = str[AL_ALIGN_STRING];
      vitems = str[AL_VITEM];
      flags = str[AL_FLAGS];
      eigene_flugziele = str[AL_EIGENE_FLUGZIELE];
      if((flight_delay = str[AL_FLIGHT_DELAY]) > 0)
	 call_out("fly_again", flight_delay);
      zeitpunkt_des_naechsten_fluges
	 = str[AL_TIME_OF_NEXT_FLIGHT];
      if (zeitpunkt_des_naechsten_fluges < 0) {
	 zeitpunkt_des_naechsten_fluges = -zeitpunkt_des_naechsten_fluges;
	 flugsperre = 1;
      }
      if (zeitpunkt_des_naechsten_fluges > time())
          call_out ("zeitpunkt_des_naechsten_fluges_erreicht",
              zeitpunkt_des_naechsten_fluges - time());
      if (vitems && environment())
         for (int i = 0; i < sizeof (vitems); i++)
            environment()->add_v_item(vitems[i]);
      sui = str[AL_SURVIVAL];
   }
   // Konversion: extra_look in player verlagert.
   if(environment() && extra_look)
      environment()->set_description(wrap(extra_look));

   // Wenn er die Unsichtbarkeitsgabe nicht mehr hat, dann hier sichtbar machen
   if(environment() && gesperrt("un"))
      environment()->set_invis(V_VIS);
   // Schreihalsgabe gibts nicht mehr
   if(pointerp(gaben) && member(gaben, "sh") >= 0)
      gaben -= ({ "sh" });
   // kein_verbrauch wird anders geregelt:
   if(environment() && environment()->query_kein_verbrauch())
   {
      if(!wizp(environment()))
         environment()->set_kein_verbrauch(0);
      if(member(gaben, "vb") >= 0)
      {
         environment()->set_fp(max(environment()->query_fp(),0));
	 environment()->set_wp(max(environment()->query_wp(),0));
	 flags |= ALF_VOLLERBAUCH;
      }
   }
   if(environment() && !environment()->query_personal())
      if(!wizp(environment()) && member(gaben, "et") == -1)
         environment()->set_personal (1);
   if (environment() && environment ()->query_personal())
        set_personal (0);
   else
        set_personal (1);
   if (sui > 0) {
       call_out ("survival",sui);
       call_out ("set_adj_long",0);
   }

        if(playerp(environment())) 
        {
            fluegel_montieren();
        }
}

void set_adj_long ()
{
   if (!query_surviving()) {
       set_adjektiv(({({"edel","edl"})}));
       set_long("Eine schimmernde Kristallkugel. Sie besteht aus einem "
	    "recht großen Edelstein, dessen Facetten in 1000 Farben "
	    "schimmern, wenn man ihn ans Licht hält. Dieser ist von einer "
	    "eleganten, goldenen Rahmung gefasst, die das ganze zu einem "
	    "würdigen Werkzeug für einen Engel macht.\n"
	    "Apropos Werkzeug: Versuch doch mal 'hilfe kugel'!");
   } else {
       set_adjektiv(({"trüb"}));
       set_long("Eine trübe Kristallkugel. Sie besteht aus einem "
	    "recht großen Edelstein, dessen Facetten allerdings zur Zeit "
	    "nur ganz trübe aussehen. Er ist von einer "
	    "eleganten, goldenen Rahmung gefasst, die das ganze zu einem "
	    "würdigen Werkzeug für einen Engel macht. Allerdings befindet "
	    "sich dieses Exemplar hier wohl zur Zeit im Schlummerzustand.");
   }
}


void create()
{
   set_name("kristallkugel");
   set_gender("weiblich");
   set_id(({"kristallkugel", "kugel", "hlp#tool", "hlptool"}));
   set_adj_long ();
   // Was man als Bank so alles braucht:
   set_sorten();
   set_kosten();
   set_no_move_reason(Dein()+" gibst du besser nicht aus der Hand.");
   if(!clonep())
   {
	string vf;
	vf = read_file("/static/adm/KEINE_GABEN");
	if(vf)
	    foreach(string str:explode(vf,"\n"))
    	    {
		int i;
    		str -=" \t\r";
		if(!strlen(str) || str[0]=='#')
		    continue;
		i = strstr(str,":");
		if(i>=0)
		    verbote[lower_case(str[0..i-1])] = explode(str[i+1..<1],",");
    	    }
   }
}

int remove ()
{
   if (environment())
      environment()->delete_v_item (({"flügel"}));
   if (flugraum && environment() && environment(environment())
       && (environment(environment()) == flugraum))
      flugraum->remove_flugraum ();
   if (vitems && environment())
      for (int i = 0; i < sizeof (vitems); i++)
         environment()->delete_v_item( ({vitems[i]["name"]}) );
   return ::remove ();
}

string query_long(object who)
{
   int light;
   string light_string;

   if((light = query_own_light()) > 0)
      light_string = "Die Kugel schimmert in einem warmen Licht.\n";
   else if(light < 0)
      light_string = "Die Kugel ist pechschwarz und schluckt alles "
		     "Licht aus der Umgebung.\n";
   else
      light_string = "";
   return ::query_long(who)+light_string;
}

string fluegellook(mapping m, object who)
{
    string zustand, groesse, desc, zusatz, kraft, text;
    int f;
    mixed adj;

    // Zustand:
    if(all_environment()[<1]->query_flugraum())
    {
        // Ui, wir fliegen grad.
        zustand  = "\nWährend Du Deine Flügel so im Flug begutachtest, "
               "überschlägst Du Dich ein paarmal in mehr oder weniger "
               "formschönen Loopings.";
    }

    else if(zeitpunkt_des_naechsten_fluges > time())
    {
        zustand = "\nSie sehen erholungsbedürftig aus.";
    }

    else
    {
        zustand = "\nSie sehen recht frisch und fit für neue Flüge aus.";
    }

#define FS 0b0001
#define FO 0b0010
#define FF 0b0100
#define EF 0b1000

    if(gabe("fs", 1)) f |= FS;
    if(gabe("fo", 1)) f |= FO;
    if(gabe("ff", 1)) f |= FF;
    if(gabe("ef", 1)) f |= EF;

    // Groesse & Desc1:
    switch(f)
    {
        // Fuer die genialere Loesung war ich zu faul. (Menaures)

        case EF:
            groesse = "kleine";
            desc = "Sie tragen dich zu deinem eigenen Flugziel.";
            break;
        case FF:
            groesse = "kleine";
            desc = "Sie tragen dich zu deinem eigenen Schiff.";
            break;
        case FF | EF:
            groesse = "";
            desc = "Sie tragen dich zu deinem eigenen Flugziel und zum Schiff.";
            break;
        case FO:
            groesse = "";
            desc = "Sie tragen dich zu fernen Orten.";
            break;
        case FO | EF:
            groesse = "";
            desc = "Sie tragen dich zu fernen Orten und zu deinem eigenen Flugziel.";
            break;
        case FO | FF:
            groesse = "";
            desc = "Sie tragen dich zu fernen Orten und zu deinem eigenen Schiff.";
            break;
        case FO | FF | EF:
            groesse = "große";
            desc = "Sie tragen dich zu fernen Orten, zu deinem eigenen Flugziel und zum Schiff.";
            break;
        case FS:
            groesse = "";
            desc = "Sie tragen dich zu anderen Spielern.";
            break;
        case FS | EF:
            groesse = "";
            desc = "Sie tragen dich zu anderen Spielern und zu deinem eigenen Flugziel.";
            break;
        case FS | FF:
            groesse = "";
            desc = "Sie tragen dich zu anderen Spielern und zu deinem eigenen Schiff.";
            break;
        case FS | FF | EF:
            groesse = "große";
            desc = "Sie tragen dich zu anderen Spielern, zu deinem eigenen Flugziel und zum Schiff.";
            break;
        case FS | FO:
            groesse = "große";
            desc = "Sie tragen dich zu anderen Spielern und zu fernen Orten.";
            break;
        case FS | FO | EF:
            groesse = "große";
            desc = "Sie tragen dich zu anderen Spielern, zu fernen Orten und zu deinem eigenen Flugziel.";
            break;
        case FS | FO | FF:
            groesse = "große";
            desc = "Sie tragen dich zu anderen Spielern, zu fernen Orten und zu deinem eigenen Schiff.";
            break;
        case FS | FO | FF | EF:
            groesse = "gewaltige";
            desc = "Sie tragen dich praktisch überall hin.";
            break;

        default:
            groesse = "winzige";
            desc = "Sie tragen dich immerhin schon in den Himmel.";
    }

#undef FS
#undef FO
#undef FF
#undef EF

    // Kraft & Desc2:
    if(gabe("fg", 1) || gabe("fgl", 1))
    {
        if(groesse == "winzige") kraft = "aber kräftige";
        else kraft = "kräftige";
        desc += " Ihnen ist dabei nichts zu schwer.";
    }

    else if(gabe("fgn", 1))
    {
        kraft = "starke";
        desc += " Ihre Kraft reicht für normales Gepäck völlig aus.";
    }

    else if(gabe("fgh", 1))
    {
        kraft = "";
        desc += " Sie tragen auch Dein Handgepäck.";        
    }

    else
    {
        if(groesse == "gewaltige") kraft = "aber schwache";
        else kraft = "schwache";
        desc += " Sie sind zu schwach, um auch noch dein Gepäck zu tragen.";
    }

    // Zusatz:
    if(gabe("tf", 1) && gabe("te", 1))
    {
        zusatz = " Ein edler, goldener Glanz ziert ihre Federspitzen.";
    }

    else if(gabe("tf", 1))
    {
        zusatz = " Ihre Federspitzen schimmern in einem matten Silber.";
    }

    else if(gabe("te", 1))
    {
        zusatz = " Du kannst einen zarten Hauch von Bronze an ihren "
                 "Federspitzen ausmachen.";
    }

    else
    {
        zusatz = "";
    }

    // Zusammenbasteln und ausgeben:
    if(who == environment())
    {
        // Spieler betrachtet seine Fluegel
        adj = liste( ({groesse, kraft})-({""}), ", " );

        if(strlen(adj))
        {
            adj += " ";
        }

        text = sprintf("Zwei %sFluegel. %s%s%s", adj, desc, zusatz || "", zustand);

        if(gabe("fl",1)&&fluegel) 
            return wrap(fluegel[V_FL_LONG]+"\n"+text);
        else 
            return wrap(text);
   }


    if(gabe("fl",1)&&fluegel) 
    {
        return wrap(fluegel[V_FL_LONG]);
    }
    
    // Jemand betrachtet / zeigt fremde Fluegel
    adj = ({groesse[..<2], kraft[..<2]}) - ({""});

    if(!sizeof(adj)) adj = 0;
    else adj[0] = "zwei "+adj[0];

    return wrap( Ihr( ([ "name"     : "flügel",
                         "adjektiv" : adj,
                         "plural"   : 1,
                         "gender"   : "maennlich" ]), 0, environment() ) + "." );
}

void init()
{
   if(this_player() && this_player() == environment())
      if(hlpp(this_player()) || wizp(this_player()))
      {
         verbote = __FILE__->query_verbote();

        // Standardfluegel montieren, falls noch keine Vorhanden
        // wird nur gebraucht beim erstmaligem Erlangen der Kugel
        // ab dann erledigt das init_arg()
        if(!fluegel) fluegel_montieren();
	 add_action("fluegel", "flügel");                                   
	 add_action("list_vitem", "?detail");
	 add_action("list_vitem", "?details");
	 add_action("remove_vitem", "-detail");
	 add_action("create_vitem", "+detail");
	 add_action("evolk", "evolk");
	 add_action("ebruelle", "ebruelle", -7);
	 add_action("eich", "eich");
	 add_action("erede", "erede");
	 add_action("sichtbar", "sichtbar");
	 add_action("unsichtbar", "unsichtbar");
	 add_action("unsichtbar_meldung", "unsichtbarkeitsmeldung");
	 add_action("sichtbar_meldung", "sichtbarkeitsmeldung");
	 add_action("unsichtbar_meldung", "Unsichtbarkeitsmeldung");
	 add_action("sichtbar_meldung", "Sichtbarkeitsmeldung");
	 add_action("adjektiv_com", "adjektiv");
	 add_action("geruch", "geruch");
	 add_action("geraeusch", "geräusch");
	 add_action("anfuehlen","anfühlen");
	 add_action("aussehen", "aussehen");
	 add_action("eigentuemlich","eigentümlich");
	 add_action("heile", "heile", -4);
	 add_action("heller", "heller");
	 add_action("dunkler", "dunkler");
	 add_action("ankommen", "ankommen");
	 add_action("verlassen", "verlassen");
	 add_action("zankommen", "zankommen");
	 add_action("zverlassen", "zverlassen");
	 add_action("ansicht", "ansicht");
	 add_action("ansicht", "eansicht");
	 add_action("titel", "titel");
//	 add_action("ansehen", "ansehen");
//	 add_action("align", "align");
	 add_action("inhalt", "inhalt");
	 add_action("verbrauch", "verbrauch");
	 add_action("keinverbrauch", "keinverbrauch");
	 add_action("verbrauch", "hunger");
	 add_action("keinverbrauch", "keinhunger");
	 add_action("ziele", "ziele");
	 add_action("ziele", "flugziele");
	 add_action("fliege", "fliege", -5);
	 add_action("fliege", "flug");
	 add_action("lande","lande");
	 add_action("flughafen", "flughafen");
	 if (this_player()->query_gilde() != "Sehergilde")
	     add_action("sehe", "sehe" ,-3);
	 add_action("sehe", "esehe" ,-4);
	 add_action("sehe", "siehe",-4);
	 add_action("lerne", "lerne", -4);
	 add_action("lerne", "erlerne", -6);
#if 0
	 add_action("spielstand", "sp");
	 add_action("spielstand", "spielstand");
#endif
	 bank::init();
	 add_action("waehrung", "währungen",-7);
	 add_action("verfolge", "verfolge",-7);
	 add_action("fliege", "himmel");
	 add_action("ptitel", "ptitel");
	 add_action("fingertext","fingertext");
	 add_action("fingertext","fingerinfo");
	 add_action("flugziel_setzen","setz",1);
	 add_action("flugziel_setzen","merk",1);
	 add_action("survive","survive"); // zusaetzliche Verben auch in
	 add_action("survive","survival"); // int survice() eintragen.
	 if(wizp(this_player()))
	    add_action("verlerne", "verlerne", -7);
	 add_action("gaben", "gaben");
	 add_action("hilfe", "hilfe");
	 call_out ("teste_alle_bewegungsmeldungen",2);
	 call_out ("teste_einige_gaben",4);
      }
      else
      {
	 send_message_to(this_player(),MT_NOTIFY, MA_UNKNOWN,
            "Du darfst mit so einem mächtigen Spielzeug "
	    "noch nicht spielen.\n");
	 destruct(this_object());
      }
}

nomask mapping query_verbote()
{
    if(playerp(environment(previous_object())))
    {
	string nam = environment(previous_object())->query_real_name();
	if(verbote[nam])
	    return mkmapping(verbote[nam]);
    }
}

int verlerne(string str)
{
   if(!str)
      FAIL("Verlerne <Gabenkuerzel>\n");
   if(pointerp(gaben) && member(gaben, str) >= 0)
   {
      gaben -= ({ str });
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,"Ok.\n");
   }
   else
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap("Du besitzt die Gabe '"+str+"' doch gar nicht."));
   return 1;
}

nomask int query_gabenpunkte ()
{
    int gp;
    gp = (environment()->query_sum_skill() - TOTAL_EXPERIENCE ) / 100;
    return gp < 0 ? 0 : gp;
}

int lerne(string str)
{
   string *out, *out2, *ids;
   int gabenpunkte;
   int upkeep;
   int i;

   if (query_surviving()) {
      notify_fail ("Du befindest Dich doch auf einem Survival-Urlaub.\n"
             "Erhol Dich erstmal richtig vom stressigen Engelsleben.\n");
      return 0;
   }

   for(i = sizeof(gaben); i--;)
      upkeep += base[gaben[i],E_COST];

   if (gabe("st",1)) upkeep += 50;

   gabenpunkte = query_gabenpunkte();
   if(!str)
   {
      if(!gabenpunkte)
	 out = ({  "Du hast leider noch keinen Gabenpunkt.",
		   "Damit bleibt Dir leider keine Erfahrung mehr "
		   "für die Gaben der Götter." });
      else
      {
	 if (gabenpunkte == 1)
	    out = ({ "Du hast immerhin schon einen Gabenpunkt."});
	 else
	    out = ({ "Deine Gabenpunkte: "+gabenpunkte+"." });
	 if(upkeep) {
	    i = upkeep/100;
	    if (!i)
		out += ({ "Zur Erhaltung deiner Gaben musst du "+
			  "keinen Gabenpunkt aufwenden." });
	    else if (i == 1)
		out += ({ "Zur Erhaltung deiner Gaben musst du "+
			  "einen Gabenpunkt aufwenden." });
	    else
		out += ({ "Zur Erhaltung deiner Gaben musst du "+
			  i+" Gabenpunkte aufwenden." });
	 }
	 if(gabenpunkte <= upkeep / 100)
	    out += ({ "Damit bleiben Dir leider keine Gabenpunkte mehr "
		      "für weitere Gaben." });
	 else {
	     i = gabenpunkte - upkeep / 100;
	     if (!i)
		out += ({ "Dir verbleibt also leider kein "
			  "Gabenpunkt mehr für weitere Gaben." });
	     else if (i == 1)
		out += ({ "Dir verbleibt also nur noch ein einziger "
			  "Gabenpunkt für weitere Gaben." });
	     else
		out += ({ "Dir verbleiben also noch "+i+
			  " Gabenpunkte für weitere Gaben." });
	 }
      }
      ids = sort_array(m_indices(base)-gaben,#'<);
      if (gabe ("st",1)) ids -= ({"us"});
      ids -= ({"fg"});
      if (gabe ("fg",1)) ids -= ({"fgl","fgh","fgn"});
      for(out2 = ({}) ,
	  i = sizeof(ids); i--;)
	    out2 += ({ left(ids[i],3)+" | "+
		       left(base[ids[i], E_GABE],21)+" | "+
		       right(base[ids[i], E_COST]/100,3)+" | "+
		       (gesperrt(ids[i]) ?
			  "-- für Mörder nicht verfügbar --" :
			   base[ids[i], E_DESC])
		    });

      if(sizeof(out2))
      {
	 out += ({ "", "Weitere verfügbare Gaben der Götter:" }) + out2;
	 out += ({ "", "Lerne weitere Gaben mit 'lerne <kuerzel>'" });
      }
      else
	 out += ({ "", "Du beherrschst bereits alle Gaben der Götter."});
      this_player()->more(out,0,0,M_AUTO_END);
   }
   else
   {
      str = lower_case(str);
      if(!member(base, str))
	 FAIL(str+" bezeichnet keine Gabe der Götter.\n"
	      "Verwende die Kürzel aus der 1. Spalte der 'lerne'-Liste.\n");
      if(member(gaben, str) >= 0)
	 FAIL("Diese Gabe besitzt du doch schon!\n");
      if(gabenpunkte - upkeep / 100 < base[str, E_COST] / 100)
	 FAIL("Du besitzt nicht genügend Gabenpunkte, "
	      "um diese Gabe zu erhalten.\n");
      if ((!gabe ("us",1)) && (str == "st"))
         FAIL(wrap("Du bist doch sterblich. Die Gabe 'Sterblichkeit' "
             "ergibt nur dann einen Sinn, wenn du die Gabe "
             "'Unsterblichkeit', die du nicht besitzt, wieder "
             "ablegen möchtest."));
      if (gabe ("st",1) && (str == "us"))
         FAIL(wrap("Du hast doch bereits mit der Gabe 'Sterblichkeit' "
             "deine Unsterblichkeit wieder zurückgegeben. "
             "Danach kannst du die Gabe 'Unsterblichkeit' nicht "
             "wieder erlangen."));
      if ((str == "tf") && (!gabe ("fs",1)) && (!gabe ("fo",1)))
          FAIL(wrap("Die Gabe 'TurboFlug' bringt Dir nur dann etwas, "
             "wenn du entweder die Gabe 'Flug/Ort' oder 'Flug/Spieler' "
             "bereits gelernt hast."));
      if ((str == "de2") && (!gabe ("de",1)))
          FAIL(wrap("Die Gabe 'Doppelt so viele Details' hat ohne "
              "die Gabe 'Details' keinen Sinn."));
      if ((str == "fi2") && (!gabe ("fi",1)))
          FAIL(wrap("Die Gabe 'Doppelt so großer Fingertext' hat ohne "
              "die Gabe 'Fingertext' keinen Sinn."));
      if ((str == "fgn") && (!gabe ("fgh",1)))
          FAIL(wrap("Die Gabe 'Flug mit normaler Gepaecklast' hat ohne "
              "die Gabe 'Flug mit Handgepaeck' keinen Sinn."));
      if ((str == "fgl") && (!gabe ("fgn",1)))
          FAIL(wrap("Die Gabe 'Flug mit Lasttiergepaeck' hat ohne "
              "die Gabe 'Flug mit normaler Gepaecklast' keinen Sinn."));
      if ((str == "fgl") && (!gabe ("la",1)))
          FAIL(wrap("Die Gabe 'Flug mit Lasttiergepaeck' hat ohne "
              "die Gabe 'Lasttier' keinen Sinn."));
      if (((str == "fgh") || (str == "fgn") || (str == "fgl")) && gabe ("fg",1))
          FAIL(wrap("Diese Gabe zu lernen hat für Dich keinen Sinn, da Du "
              "bereits die Gabe 'Flug mit Gepaeck' besitzt."));
      if (str == "fg")
          FAIL(wrap("Diese Gabe gibt es nicht mehr, es gibt stattdessen "
              "die Gaben 'fgh', 'fgn' und 'fgl'."));
      if (str == "st")
          gaben -= ({"us"});
          
      gaben += ({ str });
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap("Weise gewählt, "+this_player()->query_cap_name()+"!"));
      this_player()->send_message(MT_LOOK, MA_UNKNOWN,
         wrap("Ein heller Blitz schlägt aus "+ihrem()+" und umringt "+
	      ihn(this_player())+". Als das helle, schmerzhafte Licht vergeht, "
	      "siehst du "+den(this_player(),"beschenkt")+" mit einem "
	      "seligen Lächeln auf dem Gesicht dastehen."),
	 wrap("Ein heller Blitz zuckt aus "+deinem()+" und umringt dich. "
	      "Ein Gott hat Dir die Gabe '"+base[str, E_DESC]+"' geschenkt! "
	      "Nütze sie weise und beschäme damit nicht dich und die "
	      "Damen, Wesen und Herrn der Schöpfung!"), this_player());
   }
   return 1;
}

int gaben(string str)
{
   string *out, *ids;
   string *my_gaben;
   string name;
   int i;
   object pl, kugel;
   mixed al;


   if (query_surviving()) {
      notify_fail ("Du befindest Dich doch auf einem Survival-Urlaub.\n"
             "Erhol Dich erstmal richtig vom stressigen Engelsleben.\n");
      return 0;
   }
   if(str && wizp(this_player()))
   {
      str = capitalize(str);
      if(!(pl = find_player(lower_case(str))))
	 FAIL(str+" ist nicht im Spiel.\n");
      if(!(kugel = present("hlp#tool", pl)))
	 FAIL(Der(pl, "")+" hat noch keine Kristallkugel!\n");
      my_gaben = pointerp(al = kugel->query_auto_load()) ?
	 al[0..<3] : al[AL_GABEN];
      name = str;
   }
   else
      my_gaben = gaben;
   if(sizeof(my_gaben))
   {
      out = ({ (name ? name : "Du")+" besitzt folgende Gaben der Götter:" });
      for(i = sizeof(ids = sort_array(my_gaben,#'<)); i--;)
	 if (base[ids[i]])
	 out += ({ left(ids[i],3)+" | "+
		   left(base[ids[i], E_GABE],20)+" | "+
		   right(base[ids[i],E_COST]/100,3)+" | "+
		   (gesperrt(ids[i]) ?
		      "-- für Mörder nicht verfügbar --" :
		      base[ids[i],E_DESC])
		      });
      this_player()->more(out,0,0,M_AUTO_END);
   }
   else
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         (name ? name : "Du")+" besitzt noch keine Gaben der Götter.\n");
   return 1;
}

int unsichtbar()
{
   TEST("un");
   if(environment()->query_real_name()=="gaspode")
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Diese Gabe haben Dir die Götter wieder genommen.\n");
   else if(environment()->query_invis()==V_SHIMMER)
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du bist bereits unsichtbar.\n");
   else
   {
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du bist nun unsichtbar. "
         "Verwende dieses Geschenk der Götter weise!\n");
      if(environment()->query_msg_invis())
	 environment()->send_message(MT_LOOK,MA_MAGIC,
		 wrap(environment()->query_exp_msg_invis()));
      else
	 environment()->send_message(MT_LOOK,MA_MAGIC,
		 wrap(environment()->query_exp_mmsg_out()));
      environment()->set_invis(V_SHIMMER);
   }
   return 1;
}

int sichtbar()
{
   TEST("un");
   if (!(environment()->query_invis() & V_ATOM_INVIS))
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du bist nicht unsichtbar.\n");
   else
   {
      environment()->set_invis(V_VIS);
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du bist wieder sichtbar.\n");
      if(environment()->query_msg_vis())
	 environment()->send_message(MT_LOOK,MA_MAGIC,
		 wrap(environment()->query_exp_msg_vis()));
      else
	 environment()->send_message(MT_LOOK,MA_MAGIC,
		 wrap(environment()->query_exp_mmsg_in()));
   }
   return 1;
}


int fluegel(string str) 
{
    
    TEST("fl");
    
    string * args;
    int len;
    
    if(!fluegel) 
    {
      fluegel= ([
       V_FL_LONG : "",
         "smell" : "Du riechst nichts Besonderes.",
          "feel" : "Du fühlst nichts Ungewöhnliches.",
         "noise" : "Du hörst nichts Besonderes."
        ]);
    }
    
    if(!str||str=="") FAIL ("Was willst du an deinen Flügeln ändern?");
    
    args=explode(str," ");
    
    args[0]=convert_umlaute(lower_case(args[0]));
    
    //Spielersprache uebersetzen =)
    if(args[0]=="aussehen") { args[0]=V_FL_LONG; len=700; }
    else if(args[0]=="geruch") { args[0]="smell"; len=500; }
    else if(args[0]=="gefuehl")  { args[0]="feel"; len=500; }
    else if(args[0]=="geraeusch") { args[0]="noise"; len=500; }
    else FAIL("Was willst du an deinen Flügeln ändern?\n"
      "Gefühl, Geräusch, Geruch oder das Aussehen?");
    
    if(sizeof(args)<2) FAIL("Du musst angeben, wie du die "
      "Flügel dann gestaltet sein sollen.");

    str=implode(args[1..]," ");
    str=space(str);
    str=wrap(convertstr(str));
    
    if(sizeof(str)>len) FAIL("Dein Text ist einfach zu lang. "
      "Die armen Flügel würden zu schwer werden.");
    
    fluegel[args[0]]=str;
    this_player()->change_v_item(([args[0]:str]),({"flügel"}));
    this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" wirbelt "+seinen()+
       " mit einer eleganten Bewegung um "+
       seinen((["name":"flügel","gender":"weiblich","plural":1]),0,
          this_player())+" herum."),
       wrap("Du wirbelst "+deinen()+" mit einer eleganten Bewegung "
        "um deine Flügel herum."),
       this_player());
      
    return 1;
}

int eigentuemlich(string s)
{
    TEST("et");
    if (s && (s == "an" || s == "ein")) {
        if (!environment()->query_personal())
            FAIL ("Du bist doch schon eigentümlich.\n");
    }
    else if (s && s == "aus") {
        if (environment()->query_personal())
            FAIL ("Du bist doch gar nicht eigentümlich.\n");
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,
        wrap("Du fährst Dir mit "+deinem()+" mit einer eigentümlichen "
	"Bewegung übers Gesicht."));
    this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" fährt sich mit "+seinem()+" mit einer "
       "eigentümlichen Bewegung übers Gesicht."));
    if (environment ()->query_personal()) {
        environment()->set_personal(0);
        set_personal (1);
    } else {
        environment()->set_personal(1);
        set_personal (0);
    }
    return 1;
}

// Interface zum Magen (for internal use only!)
int vollerbauch()
{
    // Der Magen testet schon auf Vorhandensein von "vb",
    // brauchen wir hier also nicht auch noch tun.
    return flags & ALF_VOLLERBAUCH;
}

int keinverbrauch()
{
   TEST("vb");
   if(vollerbauch())
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du hast doch bereits einen angenehm vollen Bauch.\n");
   else
   {
      flags|=ALF_VOLLERBAUCH;
      if(environment()->query_wp()<0)
        environment()->set_wp(0);
      if(environment()->query_fp()<0)
        environment()->set_fp(0);
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Dein Bauch fühlt sich wunderbar gefüllt an.\n");
   }
   return 1;
}

int verbrauch()
{
   TEST("vb");
   if (!vollerbauch())
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du verbrauchst schon wie gewöhnlich Wasser und Nahrung.\n");
   else
   {
      flags&=~ALF_VOLLERBAUCH;
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du hast plötzlich wieder ein flaues Gefühl im Magen.\n");
   }
   return 1;
}

#define DOMAIN(x) (environment(x)->query_room_domain())

string *domainfilter = 0;

int filter_domains(object ob)
{
   string t;

   t = environment(ob)->query_room_domain();
   t = t && lower_case(t);

   if (!t) return 0;
   t = lower_case(t);
   if (member (domainfilter,t) != -1)
       return 1;
   else
       return 0;
}

int sort_who_by_domain(object ob1, object ob2)
{
   string t1, t2;
   t1 = get_displayed_domain(ob1);
   t2 = get_displayed_domain(ob2);
   if (t1 == t2)
       return ob1->query_name() < ob2->query_name();
   return ""+t1 < ""+t2;
}

int filter_pl(object ob)
{
   return !hlpp(ob) && !wizp (ob);
}

int filter_hlp(object ob)
{
   return hlpp(ob);
}

int filter_gods(object ob)
{
   return wizp (ob);
}

int filter_lms(object ob)
{
   return wizp(ob) && GOETTER_REGISTER->query_lehrerlaubnis(ob->query_real_name()) && 1;
}

string infoline (object wer)
{
   string s;
   s = sprintf("%-10s %-14s",wer->query_cap_name(),
             "["+get_displayed_domain(wer)+"]");
   if (!interactive(wer))
      s += " (Statue)";
   else if (query_idle(wer) >= 300)
      if (wizp (wer))
	 s += " (fleissig)";
      else s += " (faul)";
   return s[0..35];
}

int evolk(string str)
{
   int i, anz;
   string *out, klasse;
   object *list, ob;

   TEST("ev");
   domainfilter = 0;
   if (str) str = lower_case (str);
   if (str && (strlen (str) > 4)) {
       string *domains = map (DOMAIN_INFOS->query_domains(),#'lower_case)
          + ({ "ozean", "pantheon" });
       str = regreplace (str, "nordische inseln","arktis",0);
       str = regreplace (str, "kokosinseln","kokosinsel",0);
       for (i = 0; i < sizeof (domains); i++)
           if (strstr (str, domains[i]) != -1) {
               if (domainfilter) domainfilter += ({domains[i]});
               else domainfilter = ({domains[i]});
               str = regreplace (str, domains[i], "",1);
           }
       str = regreplace (str," ","",1);
   }
   if (str && (strlen (str) > 2))
   {
      if(!(ob = find_player(str))) 
         send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    wrap(capitalize(str) +" ist nicht eingeloggt."));
      else
         send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    infoline(ob)+"\n");
      return 1;
   }
   out = ({});
   list = users();
   klasse = " Spielende";
   if (str)
   if (strstr(str,"s") != -1)
      list = filter (list,#'filter_pl);
   else if (strstr(str,"e") != -1)
   {
      list = filter (list,#'filter_hlp);
      klasse = " Engel";
   }
   else if (strstr(str,"g") != -1)
   {
      list = filter (list,#'filter_gods);
      klasse = " Götter";
   }
   else if (strstr(str,"l") != -1)
   {
      list = filter (list,#'filter_lms);
      klasse = " Lehrende";
   }
   if (domainfilter)
      list = filter (list,#'filter_domains);

   anz = sizeof(list);
   list = filter(list, (: !IS_INVIS($1) &&
                          !($1->query_no_wer() && 
                            (wizp($1) || testplayerp($1))) :));

   if (str && strstr(str, "k") != -1)
      list = sort_array(list, #'sort_who_by_domain);
   else
      list = sort_array(list, (: $1->query_name() < $2->query_name() :));

   for(i = sizeof(list); i--;)
      if(list[i]->query_cap_name())
	 out += ({ infoline (list[i]) });
   out = explode(sprintf("%#-79s",implode(out,"\n")),"\n");
   out = ({"In "+MUD_NAME+" befinden sich:"}) + out +
      ({ "Insgesamt "+anz+klasse+
      (anz-sizeof(list)?", "+(anz-sizeof(list))+" davon unsichtbar.":".")
      });
   this_player()->more(out, "--Mehr--", 0, M_AUTO_END);
   return 1;
}

int ebruelle(string str)
{
   string tmp;
   int wiz;

   TEST("eb");
   if(!str)
      FAIL(query_verb()+" was?\n");

   wiz = wizp(environment());
   EVENT_MASTER->event("Engel", environment(), wrap_say (
	 (wiz ? (((tmp=environment()->query_real_gender())=="weiblich")?"Göttin":
                  (tmp=="saechlich")?"Göttliches":"Gott")
	      : "Engel")+" "+environment()->query_real_cap_name(),
	 (wiz ? "redet" : "brüllt") + " zur Engelsschar: " + str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN, "Ok.\n");
   return 1;
}

int eich(string str)
{
   string tmp;
   int wiz;

   TEST("eb");
   if(!str)
      FAIL(query_verb()+" was?\n");

   wiz = wizp(environment());
   EVENT_MASTER->event("Engel", environment(), wrap_say (
	 (wiz ? (((tmp=environment()->query_real_gender())=="weiblich")?"Göttin":
                  (tmp=="saechlich")?"Göttliches":"Gott")
	      : "Engel")+" "+environment()->query_real_cap_name(),
	 str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,"Ok.\n");
   return 1;
}

int erede(string str)
{
   object dest;
   string message, dest_name, tmp;

   TEST("er");
   if(!str)
      FAIL("erede zu wem was?\n");
   sscanf(str, "zu %s", str);
   if(sscanf(str, "%s %s", dest_name, message) != 2)
      FAIL("erede zu wem was?\n");
   if(!(dest = find_living(lower_case(dest_name))))
      FAIL(wrap(capitalize(dest_name)+" ist nicht aufzufinden."));
   if(!hlpp(dest))
      FAIL(wrap(Der(dest)+" gehört nicht der Engelschar an!"));
   if(query_once_interactive(dest) && !interactive(dest))
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap(Der(dest)+" ist versteinert und antwortet wohl nicht!"));
   if(tmp = dest->query_away())
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap_say(Der(dest)+" ist weg:",tmp));
   this_player()->send_message_to(dest,MT_SENSE|MT_FAR,MA_COMM,wrap_say(
      "Engel "+environment()->query_real_cap_name()+
      " redet zu dir:",message));
   dest->add_to_rede_puffer(wrap_say(
      "Engel "+environment()->query_real_cap_name()+
      " redet zu dir:",message));
   environment()->add_sum_comm(1);
   if(tmp = environment()->query_away())
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap_say("(Eigentlich bist du ja weg:", tmp+")"));
   if(environment()->query_echomode())
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_SENSE|MT_FAR,MA_COMM,
         wrap_say ("Du redest zu Engel "
	  +dest->query_real_cap_name()+":",message));
   else
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_SENSE|MT_FAR,MA_COMM,"Ok.\n");
   environment()->add_to_rede_puffer(
      wrap_say ("Du redest zu Engel "
	  +dest->query_real_cap_name()+":",message));
   return 1;
}

int adjektiv_com(string str)
{
   TEST("ad");
   if(!str)
      environment()->set_adjektiv(({}));
   if(strlen(str) > 15)
      FAIL("Mehr als 15 Zeichen sind nicht erlaubt.\n");
   environment()->set_adjektiv(str);
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" fährt mit einer mystischen Bewegung über "+
       seinen()+"."));
   return 1;
}

int geruch(string str)
{
   TEST("ge");
   if(!str)
      environment()->set_smell(0);
   else
      environment()->set_smell(implode(explode(str,"\\n"),"\n"));
   this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" fährt mit einer mystischen Bewegung über "+
       seinen()+"."));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int geraeusch(string str)
{
   TEST("gr");
   if(!str)
      environment()->set_noise(0);
   else
      environment()->set_noise(implode(explode(str,"\\n"),"\n"));
   this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" fährt mit einer mystischen Bewegung über "+
       seinen()+"."));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int anfuehlen(string str)
{
   TEST("gf");
   if(!str)
      environment()->set_feel(0);
   else
      environment()->set_feel(implode(explode(str,"\\n"),"\n"));
   this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" fährt mit einer mystischen Bewegung über "+
       seinen()+"."));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int aussehen(string str)
{
   TEST("au");
   if(!str)
      this_player()->set_description (
	  "/apps/description"->query_merkmal_string());
   else
      if (strlen (str) < 1000)
         this_player()->set_description (
            wrap (implode(explode(str,"\\n"),"\n")));
      else
         return notify_fail ("Findest Du solch eine lange Beschreibung "
            "nicht etwas zu anstrengend zum lesen?\n");
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" wirbelt "+seinen()+" um sich herum."));
   return 1;
}

/*
string extra_look()
{
   return extra_look;
}
*/

int heile(string str)
{
   int time_to_fly;

   TEST("he");
   if(!str)
      FAIL("Wen willst du denn heilen?\n");
   if(str != "mich" && lower_case(str) != environment()->query_real_name())
      FAIL("Als Engel reicht deine Heilkraft gerade mal für dich!\n");
   if(!environment(environment())->query_type("tempel"))
   {
      FAIL("Du musst dich zur Heilung an einen spirituellen Ort begeben.\n"
	   "Nur dort hast du die Ruhe, die du zur Genesung brauchst.\n");
   }
   if(environment()->query_hp() < 0)
      FAIL("Da ist leider nichts mehr zu retten.\n");
   if((time_to_fly = find_call_out("fly_again")) != -1)
      remove_call_out("fly_again");
   else
      time_to_fly = 0;
   call_out("fly_again", time_to_fly + 180);
//   environment()->set_sp(environment()->query_max_sp());
   environment()->set_hp(environment()->query_max_hp());
   this_player()->send_message(MT_LOOK,MA_CRAFT,
       wrap(Der(this_player())+" fährt über "+seinen()+", "+
       wen(0,ART_NUR_DER)+" in einem hellen Lichte zu leuchten beginnt "+
       "und "+den(this_player(),"")+" für kurze Zeit einhüllt. "
       +Er(this_player())+" scheint sich nun deutlich wohler zu fühlen."));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,
         wrap("Du fährst über "+deinen()+", "+
	 wen(0,ART_NUR_DER)+" in einem hellen Lichte zu leuchten beginnt "+
	 "und dich für kurze Zeit einhüllt. Du fühlst dich gleich "
	 "viel wohler."));
   return 1;
}

int heller()
{
   int start;
   string own_msg, room_msg, own2_msg;

   TEST("li");
   own_msg = room_msg = own2_msg = "";


   if((start = query_own_light()) == -1)
   {
      own_msg = Sein(0,"")+ " hört auf, Licht zu schlucken.";
      own2_msg = Dein(0,"")+ " hört auf, Licht zu schlucken.";
   }
   else if(!start)
   {
      own_msg = Sein(0,"")+ " fängt an, in einem warmen Licht zu leuchten.";
      own2_msg = Dein(0,"")+ " fängt an, in einem warmen Licht zu leuchten.";
   }
   else if(start < -1)
   {
      own_msg = Sein(0,"")+ " schluckt jetzt weniger Licht.";
      own2_msg = Dein(0,"")+ " schluckt jetzt weniger Licht.";
   }
   else
   {
      own_msg = Sein(0,"")+ " leuchtet jetzt heller.";
      own2_msg = Dein(0,"")+ " leuchtet jetzt heller.";
   }

   if(!environment(this_player())->query_light())
   {
      this_player()->do_command("sage Es werde Licht!");
      room_msg = " Es wird hell.";
   }

   add_own_light(1);
   this_player()->send_message(MT_LOOK,MA_UNKNOWN,
      wrap(Der(this_player())+" konzentriert sich... " + own_msg + room_msg));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap("Du konzentrierst dich... " + own2_msg + room_msg));
   return 1;
}

int dunkler()
{
   int start;
   string own_msg, room_msg, own2_msg;

   TEST("li");
   own_msg = room_msg = own2_msg = "";


   if((start = query_own_light()) == 1)
   {
      own_msg = Sein(0,"")+ " hört auf zu leuchten.";
      own2_msg = Dein(0,"")+ " hört auf zu leuchten.";
   }
   else if(!start)
   {
      own_msg = Sein(0,"")+ " fängt an, Licht zu absorbieren.";
      own2_msg = Dein(0,"")+ " fängt an, Licht zu absorbieren.";
   }
   else if(start > 1)
   {
      own_msg = Sein(0,"")+ " leuchtet nun schwächer.";
      own2_msg = Dein(0,"")+ " leuchtet nun schwächer.";
   }
   else
   {
      own_msg = Sein(0,"")+ " schluckt jetzt noch mehr Licht.";
      own2_msg = Dein(0,"")+ " schluckt jetzt noch mehr Licht.";
   }

   if(environment(this_player())->query_light() == 1)
   {
      this_player()->do_command("sage Es werde finster!");
      room_msg = " Es wird dunkel.";
   }

   add_own_light(-1);
   this_player()->send_message(MT_LOOK,MA_UNKNOWN,
      wrap(Der(this_player())+" konzentriert sich... " + own_msg + room_msg));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         wrap("Du konzentrierst dich... " + own2_msg + room_msg));
   return 1;
}

int bewegungsmeldung_okay (string msg, int wflag)
{
    string gfun;
    int x;
    if (!msg) {
        if (wflag) send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	              "Etwas länger sollte sie schon sein.\n");
        return 0;
    }
    if (strstr(msg,"#'")!=-1) // Kurdel: keine Closures fuer Grammatikfunkt.
    {
        if (wflag) send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	              "\"#'\" in der Bewegungsmeldung ergibt für dich "
                      "keinen Sinn.\n");
        return 0;
    }
    msg = lower_case (msg);
    // wir muessen Konstruktionen der Art $dir($der()) verhindern.
    // das ist ziemlich krank, aber Engel machen sowas.
    for (x = 0; x < strlen(msg); x++) {
        if (msg[x]=='$') {
            gfun = msg[x+1..x+5];
            if (!member((["der()","des()","dem()","den()","ein()","dir()"]), gfun)) {
                if (wflag) send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
		              wrap ("Als Grammatikfunktionen sind $der(), $des(), "
		              "$dem(), $den(), $ein() und $dir() zulässig. "
		              "Nicht jedoch \"$"+
			      gfun+"\"."));
                return 0;
            }
	    // Vor und nach den Funktionen duerfen keine Buchstaben kommen
	    if ((x && msg[x-1]>='a' && msg[x-1]<='z')
	      ||( strlen(msg)>x+6 && msg[x+6]>='a' && msg[x+6]<='z'
	        && (msg[x+6]!='s' ||
		    (strlen(msg)>x+7 && msg[x+7]!=' ')))) // Genitiv erlauben.
	    {
                if (wflag) send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
		              wrap ("Deine Name und die Richtung "
			      "müssen als einzelne Wörter vorkommen."));
                return 0;
	    }
            x += 5;
        }
    }
    if (strstr (msg,"$der()") == -1 && strstr (msg,"$ein()") == -1
        && strstr (msg,"$des()") == -1
        && strstr (msg,"$den()") == -1 && strstr (msg,"$dem()") == -1)
    {
	if(!sizeof(regexp(({msg}),
	    "(^|[^a-z])"+this_player()->query_real_name()+"(s |[^a-z]|$)")))
	{
	    if (wflag) send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Die Bewegungsmeldung muss deinen Namen oder $der() oder $ein()\n"
	       "als einzelnes Wort enthalten.\n");
	    return 0;
	}
    }
    return 1;
}

void teste_einige_gaben ()
{
    object ob;
    ob = environment ();
    if (!ob) return;
    if (fail_gabe ("vb",1))
        ob->set_kein_verbrauch (0);
    if (fail_gabe ("fh",1))
        ob->set_no_airport (0);
}

void teste_alle_bewegungsmeldungen ()
// wird per call out aufgerufen, da das login eh schon genug evals frisst
{
    object ob; string t;
    if (!(ob = environment()) || !playerp (ob) || wizp (ob)) return;
    if (!bewegungsmeldung_okay(ob->query_msg_in(),0))
	ob->set_msg_in("$Ein() nähert sich $dir().");
    if (!bewegungsmeldung_okay(ob->query_msg_out(),0))
	ob->set_msg_out("$Der() entfernt sich $dir().");
    if (!bewegungsmeldung_okay(ob->query_mmsg_in(),0))
	ob->set_mmsg_in("$Ein() erscheint in einer Rauchwolke.");
    if (!bewegungsmeldung_okay(ob->query_mmsg_out(),0))
	ob->set_mmsg_out("$Der() verschwindet in einer Rauchwolke.");
    if ((t=ob->query_msg_invis()) && !bewegungsmeldung_okay(t,0))
	ob->set_msg_invis(0);
    if ((t=ob->query_msg_vis()) && !bewegungsmeldung_okay(t,0))
	ob->set_msg_vis(0);
}

int ankommen(string str)
{
   TEST("me");
   if (!bewegungsmeldung_okay (str,1))
      return 1;
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" schwenkt "+seinen()+"."));
   this_player()->set_msg_in(space(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int verlassen(string str)
{
   TEST("me");
   if (!bewegungsmeldung_okay (str,1))
      return 1;
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" schwenkt "+seinen()+"."));
   this_player()->set_msg_out(space(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int zankommen(string str)
{
   TEST("me");
   if (!bewegungsmeldung_okay (str,1))
      return 1;
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" schwenkt "+seinen()+"."));
   this_player()->set_mmsg_in(space(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int zverlassen(string str)
{
   TEST("me");
   if (!bewegungsmeldung_okay (str,1))
      return 1;
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" schwenkt "+seinen()+"."));
   this_player()->set_mmsg_out(space(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int unsichtbar_meldung(string str)
{
   TEST("me");
   TEST("un");
   if (!str || str == "") {
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,
         "Unsichtbarkeitsmeldung gelöscht.\n");
      this_player()->set_msg_invis(0);
      this_player()->send_message(MT_LOOK,MA_CRAFT,
         wrap(Der(this_player())+" schwenkt "+seinen()+"."));
      return 1;
   }
   if (!bewegungsmeldung_okay (str,1))
      return 1;
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" schwenkt "+seinen()+"."));
   this_player()->set_msg_invis(space(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int sichtbar_meldung(string str)
{
   TEST("me");
   TEST("un");
   if (!str || str == "") {
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,      
         "Sichtbarkeitsmeldung gelöscht.\n");
      this_player()->set_msg_vis(0);
      this_player()->send_message(MT_LOOK,MA_CRAFT,
         wrap(Der(this_player())+" schwenkt "+seinen()+"."));
      return 1;
   }
   if (!bewegungsmeldung_okay (str,1))
      return 1;
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" schwenkt "+seinen()+"."));
   this_player()->set_msg_vis(space(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int titel(string str)
{
   TEST("ti");
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" wirbelt "+seinen()+" um sich herum."));
   this_player()->set_title(str||"");
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

/*
int ansehen(string str)
{
   TEST("ti");
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      Der(this_player())+" wirbelt "+seinen()+" um sich herum.\n");
   set_align_string(!str ? "": (str == "0"? 0: str));
   this_player()->set_align_title(query_align_string());
   if(!query_align_string())
      this_player()->add_align(0);
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int align()
{
   TEST("ti");
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Du scheinst "+this_player()->query_align_title()+" zu sein.\n"
	 "Du bist tatsaechlich "+get_align_string(this_player()->query_align())+
	 ".\n");
   return 1;
}
*/

int ansicht()
{
   string tmp;
   string *out=({});

   TEST("an");
#define WLN(x)		out+=({x})
#define W(x)		out+=explode(x,"\n")[0..<2]
#define MWRAP(x,y)	sprintf("%-13s %=-65s\n",x,y)
#define OWN		this_player()
#  include "/i/zauberstab/show_msg.inc"
   this_player()->send_message(MT_LOOK,MA_LOOK,
      wrap(Der(this_player())+" betrachtet sich durch "+seinen()+"."));
   this_player()->more(out, 0, 0, M_AUTO_END);
   return 1;
}

int inhalt(string str)
{
   TEST("in");
   this_player()->set_content_message(str ? "\t"+str : 0);
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" wirbelt "+seinen()+" um sich herum."));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   return 1;
}

int ptitel(string str)
{
   TEST("pt");
   if(!str) {
      environment()->set_personal_title (0);
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
      return 1;
   }
   if(strlen(str) > 15)
      FAIL("Mehr als 15 Zeichen sind nicht erlaubt.\n");
   if(strstr(str," ") != -1)
      FAIL("Ein Leerzeichen im Titel ist nicht möglich.\n");
   environment()->set_personal_title(capitalize(str));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" wirbelt "+seinen()+" um sich herum."));
   return 1;
}

int fingertext(string str)
{
   int faktor;
   TEST("fi");
   if (gabe ("fi2",1)) faktor = 2; else faktor = 1;
   if(!str) {
      environment()->set_finger_info (0);
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
      return 1;
   }
   if(strlen(str) > 500 * faktor)
      FAIL("Mehr als "+500*faktor+" Zeichen sind nicht erlaubt.\n"+
      ((faktor==1)
        ?"Du kannst aber die Gabe 'Doppelter Fingertext' lernen.\n"
        :""));
   environment()->set_finger_info(implode (explode (str,"\\n"),"\n"));
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,"Ok.\n");
   this_player()->send_message(MT_LOOK,MA_CRAFT,
      wrap(Der(this_player())+" wirbelt "+seinen()+" um sich herum."));
   return 1;
}

int hilfe(string str)
{
   if(str && id(str) || str == "engel")
   {
       send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
          copies("-",78)+"\n\n"+wrap(
       "Deine Kristallkugel ist das Bindeglied zwischen Dir und den "
       "Göttern "+MUD_NAME+"s, von denen du all deine Fähigkeiten als Engel, "
       "die sogenannten 'Gaben der Goetter' erhältst.\n"
       "Mit Hilfe des Kommandos 'lerne' kannst du neue Gaben erhalten. "
       "Mit dem Befehl 'gaben' kannst du schauen, welche Gaben du schon "
       "von den Göttern geschenkt bekommen hast.\n"
       "Hilfe zu den Gaben allgemein erhältst du mit 'hilfe gaben'.\n"
       "Hilfen zu den einzelnen Gaben erhältst du über "
       "'hilfe <gabenkuerzel>'. "
       "Die Kürzel entnimmst du den Listen der Befehle 'lerne' und 'gaben'.\n"
       "Zum Thema Engel und Mörder erfährst du was mit 'hilfe moerder'."
	 )+"\n"+ copies("-",78)+"\n");
      return 1;
   }
   else if(str)
   {
      str = lower_case(str);
      if(file_size(HELP+"/"+str) > 0)
      {
	 cat(HELP+"/"+str);
	 return 1;
      }
   }
}

int query_ort(string str)
{
   int wo;
   if(fail_gabe("pf",1))
       return 0;

   if((wo = HLP_ORTE->query_ort(str)) && test_bit(orte, wo-1))
      return wo;
}

int add_ort(string str)
{
   int wo;
   string *out;

   if(fail_gabe("pf",1))
       return 0;

   if(wo = HLP_ORTE->add_ort(str))
   {
      if(!IS_INVIS(environment()))
         environment()->send_message(MT_LOOK,MA_UNKNOWN,
            wrap(Ihr()+" blitzt kurz auf."),
            wrap(Dein()+" blitzt kurz auf."),environment());
      if(sizeof(out =
	 sort_array(m_indices(mkmapping(TELE_MASTER->is_tele(str))),#'>)))
	    send_message_to(environment(),MT_NOTIFY,MA_UNKNOWN,
	       wrap("Neues Ziel: "+implode(out,", ")));
	 
      orte = set_bit(orte, wo-1);
      return wo;
   }
}

int delete_ort(string str)
{
   int wo;

   if(fail_gabe("pf",1))
       return 0;

   if(wo = HLP_ORTE->query_ort(str))
   {
      orte = clear_bit(orte, wo-1);
      return wo;
   }
}

int ziele(string str)
{
   string teles;
   string *wos;
   string ustr = capitalize(convert_umlaute(lower_case(str||"")));

   TEST("pf");

   switch (ustr)
   {
        case "Nordische inseln":
        case "Nordische insel":
            ustr = str = "Arktis";
            break;

        case "Kokosinseln":
            ustr = str = "Kokosinsel";
            break;
   }

   if (str && (member(MASTER_OB->query_domains(),ustr) != -1))
   {
      if(!stringp(teles = TELE_MASTER->all_teles(this_object(),ustr))
	 || teles == "")
      {
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	     "Du hast Dir noch keine Flugziele dort"
	     " eingeprägt.\n");
	 return 1;
      }
      switch(str) {
	  case "Arktis": str = "auf den Nordischen Inseln"; break;
	  case "Campus": str = "auf dem Campus"; break;
	  case "Ebenen": str = "in den Ebenen"; break;
	  case "Kokosinsel": str = "auf den Kokosinseln"; break;
	  case "Maerchenland": str = "im Märchenland"; break;
	  case "Doerrland": str = "in Dörrland"; break;
	  default: str = "in "+str; break;
      }
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Dir "+str+" bekannte Flugziele:\n");
   } else {
      if(!stringp(teles = TELE_MASTER->all_teles(this_object())) || teles == "")
      {
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du hast Dir noch keine Flugziele eingeprägt.\n");
	 return 1;
      }
      if(str)
	 teles = implode(regexp(explode(teles, "\n"), "\\<"+str+"\\>") || ({}),
		      "\n");
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Dir bekannte Flugziele:\n");
   }
   wos = map(explode(teles,"\n"), lambda(({'data}),({#'+,'data,"  "})));
   this_player()->more(explode(
      sprintf("%-79#s\n", implode(wos,"\n"))
      ,"\n")-({""})
      +(eigene_flugziele && sizeof (eigene_flugziele) ?
      ({"Dein eigenes Flugziel: "+eigene_flugziele[1]}):({}))
      ,
      "--Mehr--",0,M_AUTO_END);
   return 1;
}

int gepaeck_gewicht()
{
   int i, gewicht;
   object *obs;

   gewicht = environment()->query_internal_encumbrance();

   for(i = sizeof(obs = all_inventory(environment())); i--;)
      if(obs[i]->query_invis()
          || obs[i]->query_no_move()
          || obs[i]->allowed("hlp_flug"))
         gewicht -= obs[i]->query_weight();
   return gewicht;
}

int zuviel_gepaeck()
{
   int gewicht, la, mie;

   // Engel mit fg (alt) bzw. fgl darf alles tragen:
   if(!fail_gabe("fg",1) || !fail_gabe("fgl",1)) return 0;
   // Engel mit fgn ohne la darf auch alles tragen:
   la = fail_gabe("la");
   if(la && !fail_gabe("fgn",1)) return 0;

   // Gepaeck ermitteln...
   gewicht = gepaeck_gewicht();
   // wenn er nix dabei hat, ist eh alles okay:
   if(!gewicht) return 0;
   // wenn er keinen Flug mit Handgepaeck hat, hat er jetzt schon verloren:
   if (fail_gabe("fgh",1)) return 1;
   mie = environment()->query_max_internal_encumbrance();
   // wenn der Spieler die Gabe Lasttier hat, ist die max internal encumbrance
   // um 50% hoeher als "normal", also runterrechnen:
   if (!fail_gabe("la",1)) mie = mie * 2 / 3;
   // hat er die Gabe "fgn" dann darf er "mie" an Gewicht tragen:
   // Debug: "gewicht: "+gewicht+" mie: "+mie+"\n");
   if (!fail_gabe("fgn",1))
       return gewicht > mie;
   // okay, er hat also nur die Gabe fgh:
   return gewicht > mie / 2;
}

void compute_zeitpunkt_des_naechsten_fluges ()
{
    if (flugsperre)
	zeitpunkt_des_naechsten_fluges = 4 * gepaeck_gewicht () + 100;
    else
	zeitpunkt_des_naechsten_fluges = gepaeck_gewicht () + 20;
    if (!fail_gabe ("te",1))
        zeitpunkt_des_naechsten_fluges = zeitpunkt_des_naechsten_fluges * 2 / 3;
    remove_call_out ("zeitpunkt_des_naechsten_fluges_erreicht");
    call_out ("zeitpunkt_des_naechsten_fluges_erreicht",
               zeitpunkt_des_naechsten_fluges);
    zeitpunkt_des_naechsten_fluges += time();
}


void zeitpunkt_des_naechsten_fluges_erreicht ()
{
    if ((find_call_out ("landung") != -1)
      || (find_call_out ("fly_again") != -1)
      || (environment()->query_hp() < 0)) return;
    environment()->send_message_to (environment(),MT_FEEL,MA_FEEL,
        wrap ("Deine Flügel fühlen sich wieder erholt und kräftig "
            "genug an, um Dich hoch hinaus in die Lüfte zu tragen."));
}

void fly_again ()
{
    if ((find_call_out ("landung") != -1)
      || (find_call_out ("zeitpunkt_des_naechsten_fluges_erreicht") != -1)
      || (environment()->query_hp() < 0)) return;
    environment()->send_message_to (environment(),MT_FEEL,MA_FEEL,
        wrap ("Nach der anstrengenden Genesung hast Du nun wieder "
            "genug Kraft, Dich in die Lüfte zu erheben."));
}

void zu_frueh_wieder_geflogen ()
{
    int abzug;
    if (find_call_out ("landung") == -1) return;
    if (!environment(this_player())->query_flugraum()) return;
    abzug = zeitpunkt_des_naechsten_fluges - time() + 10;
    if (abzug < 10) return;
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
        "Uff, du hättest deine Flügel doch etwas besser schonen "
	"sollen!\n");
    if (this_player()->query_hp()-abzug < 10) {
        if (environment()->query_hp() >= 0)
	    environment()->set_hp(1);
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Das war jetzt aber echt zuviel für deine Flügel!\n"
	    "Du beschließt, vorsichtig die Thermik ausnutzend zur Erde "
	    "hinabzugleiten,\num dich dort ersteinmal gründlich zu "
	    "erholen!\n");
	flugraum->set_long (
	    "Du gleitest, vorsichtig die Thermik ausnutzend, zur Erde "
	    "hinab, um dich dort ersteinmal gründlich zu "
	    "erholen!");
	flugsperre = 1;
	remove_call_out ("landung");
	remove_call_out ("notlandung");
	remove_call_out ("zu_frueh_wieder_geflogen");
	remove_call_out ("meldung");
	remove_call_out ("meldung");
	call_out ("landung",20);
	flugziel = rueckflugziel;
	notlandeziel = rueckflugnotlandeziel;
	flugziel_ist_spieler = 0;
    } else {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Das schlägt sich deutlich auf deine Ausdauer nieder.\n");
	environment()->add_hp(-abzug, ([
	    AH_DAMAGE_TYPE: ({ "anstrengung" }),
	]));
    }
}

private int earth_bind()
{
   if(find_call_out("fly_again") != -1)
   {
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
            "So kurz nach der Genesung hast du noch nicht die nötige Kraft,\n"
	    "dich in die Luft zu erheben.\n");
      return 1;
   }
}

private int abflug_erlaubt(object woher)
{
   mixed ret;

   if(stringp(ret = woher->query_type("teleport_raus_verboten")))
      FAIL(ret);
   else if(ret)
      FAIL("Eine magische Kraft lässt dich nicht starten!\n");
   return 1;
}

private int anflug_erlaubt(object wohin)
{
   mixed ret;

   if(stringp(ret = wohin->query_type("teleport_rein_verboten")))
      FAIL(ret);
   else if(ret)
      FAIL("Eine magische Kraft lässt dich nicht landen! Du kehrst um.\n");
   return 1;
}

int drinnen (object raum)
{
   if (!raum) return 0;
   if (raum->query_type("fliegen_erlaubt")) return 0;

   return query_innenraum (raum) || (raum->query_type(LANDSCHAFT)&L_UNTERWASSER);
}

int landeplatz_umleitung(object raum)
{
    string lp;
    if (!raum) return 0;
    lp = raum->query_type("landeplatz");
    if (lp && object_name(raum) != lp)
        return 1;
    return 0;
}

int flugziel_setzen (string s)
{
    object ort;
    if (!s || fail_gabe("ef",1)) return 0;
    s = lower_case (s);
    if (strstr(s,"flugziel") == -1)
        return notify_fail("Was willst Du Dir hier merken? Ein eigenes Flugziel?\n",
        FAIL_NOT_CMD);
    ort = environment (this_player());
    if (drinnen (ort))
        FAIL (wrap ("Du kannst nur unter freiem Himmel landen, daher kannst Du Dir auch "
            "kein Flugziel merken, welches nicht im Freien liegt."));
    if (!anflug_erlaubt(ort))
        FAIL (wrap ("Eine magische Kraft sorgt dafür, dass Du hier nicht "
            "landen könntest; daher kannst Du Dir auch hier kein Flugziel "
            "merken."));
    if (ort->query_flugraum())
        FAIL ("Du kannst Dir kein Flugziel in der Luft merken.\n");
    if (landeplatz_umleitung(ort))
        FAIL(wrap("Der Landeplatz wurde umgeleitet, daher kannst Du Dir "
            "hier kein Flugziel merken."));

    if (environment(this_player())->query_type(LANDSCHAFT) & L_WASSER) {
        this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
            wrap ("Du legst "+deinen()+" vorsichtig vor Dir ins Wasser, "
            "freust Dich, dass "+er()+" schwimmt und schwimmst dreimal "
            "hektisch um "+ihn()+" herum und nimmst "+ihn()+" wieder auf."));
        this_player()->send_message(MT_LOOK,MA_LOOK,
            wrap (Der(this_player())+" legt "+seinen()+" vorsichtig vor sich "
            "ins Wasser, schwimmt dreimal hektisch um "+ihn()+
            " herum und nimmt "+ihn()+" wieder auf."));
    } else {
        this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
            wrap ("Du legst "+deinen()+" vor dir auf den Boden, tanzt drei mal um "
            +ihn()+" herum und nimmst "+ihn()+" wieder auf."));
        this_player()->send_message(MT_LOOK,MA_LOOK,
            wrap (Der(this_player())+" legt "+seinen()+" vor sich auf den Boden, "
            "tanzt dreimal um "+ihn()+" herum und nimmt "+ihn()+" wieder auf."));
    }
    if (clonep (ort)
        || (!ort->query_short())
        || ort->query_ship()
        || (ort->query_room_domain() == "Pantheon")) { // clones braucht man gar nicht erst versuchen
        this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
            wrap (Dein()+" leuchtet kurz in traurigem, mattem, grauem Licht "
            "auf, hier kann "+er()+" sich wohl kein Flugziel merken."));
        this_player()->send_message(MT_LOOK,MA_LOOK,
            wrap (Der()+" von "+dem(this_player())+" leuchtet kurz in "
            "mattem, grauem Licht auf."));
    } else {
        this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
            wrap (Dein()+" leuchtet kurz in fröhlichem, kräftigem, grünem Licht "
            "auf, das scheint wohl geklappt zu haben."));
        this_player()->send_message(MT_LOOK,MA_LOOK,
            wrap (Der()+" von "+dem(this_player())+" leuchtet kurz in kräftigem, "
            "grünem Licht auf."));
        eigene_flugziele = ({object_name (ort), ort->query_short()});
        sys_log ("eigene_flugziel",
        left(this_player()->query_real_cap_name()+":",12)+object_name (ort)+": "+ort->query_short()+"\n\n");
    }
    return 1;
}

nomask int query_surviving ()
{
    return find_call_out ("survival") + 1;
}

void survival ()
{
    if (query_surviving()) return;
    this_player()->send_message(MT_LOOK, MA_MAGIC,
	wrap (
            "Auf einmal beginnt "+der()+" von "+dem(environment())+
            " zu pulsieren, "
            "die Facetten schimmern in tausend Farben."),
	wrap (
            "Auf einmal beginnt "+dein()+" zu pulsieren und "
            "die Facetten schimmern wieder wie gewohnt in tausend Farben."),
	    this_player());
    call_out ("set_adj_long",0);
}

int survive (string s)
{
    int sui;
    object ob;
    if (((query_verb() != "survive") && (query_verb() != "survival"))
        || (this_interactive() != environment())) return 0;
    if (sui = query_surviving()) {
        write ("Dein Survival-Urlaub dauert noch "
            +format_vseconds(sui)+" an.\n");
        return 1;
    }
    if (fail_gabe("su",1)) return 0;
    if (!s) FAIL (wrap ("Falls Du wirklich einen Survival-Urlaub machen "
        "möchtest, so gib an, wieviele Zeit in Spieltagen dieser Urlaub "
        "andauern soll; beispielsweise: \"survival 5 Tage\".\n"
        "Beachte dabei unbedingt die Hilfe zu dieser Gabe."));
    if (sscanf (lower_case(s),"%d tag%~s",sui) != 2) 
        FAIL ("Syntax: "+query_verb()+" 5 Tage\n");
    if (sui <= 0) return notify_fail ("Dein Survival Urlaub sollte schon "
        "eine vernünftige Zeit dauern.\n");
    if (sui > 10000) return notify_fail ("Meinst Du nicht, dass solch ein "
        "langer Urlaub etwas arg lang ist?\n");
    call_out ("survival", sui * VDAY);
      this_player()->send_message(MT_LOOK, MA_MAGIC,
	wrap (
            "Auf einmal hört "+der()+" von "+dem(environment())+
            " in tausend Farben zu schimmern und sieht nur noch"
            " trübe aus."),
	wrap (
            "Auf einmal hört "+dein()+" auf, "
            "in tausend Farben zu schimmert und sieht nur noch trübe "
            "aus.")
            + "Dein Survival-Urlaub hat begonnen, gute Erholung!\n",
	    this_player());
    set_own_light (0);
    call_out ("set_adj_long",0);
    if (ob = present ("newsreader",environment())) ob->remove ();
    if (ob = present ("mailreader",environment())) ob->remove ();
    remove_call_out ("zeitpunkt_des_naechsten_fluges_erreicht");
    return 1;
}

private int *get_map_koords(string str)
{
    int x, y;

    if (sscanf(str,"/map/m%d_%d",x,y) == 2)
       return ({x,y});
    str = MAP_OB->get_map_file_name(str);
    if (!str) return 0;
    if (sscanf(str,"/map/m%d_%d",x,y) == 2)
       return ({x,y});
    return 0;
}

private int get_dist (int x1, int y1, int x2, int y2)
{
    float fx1, fy1, fx2, fy2;
    // wegen Ueberlaeufen bereits bei (x1-x2) im Quadrat muessen hier
    // floats hin.
    fx1 = (float)x1; fy1 = (float)y1; fx2 = (float)x2; fy2 = (float)y2;
    return (int)sqrt ((fx1-fx2)*(fx1-fx2)+(fy1-fy2)*(fy1-fy2));
}

string get_ziel_name(string file)
{
   int i, len, pos;
   string *res;

   for(pos = len = 0, i = sizeof(res = TELE_MASTER->is_tele(file)); i--;)
      if(strlen(res[i]) >= len)
      {
	 pos = i;
	 len = strlen(res[i]);
      }
   if(pointerp(res))
       return res[pos];
}

int fliege(string str)
{
   string ziel, ziel_domain, hier_domain, startraum, tmp, start_meldung;
   object here, target;
   int kosten, himmel, dauer, x1, x2, y1, y2, *koords, move_wie;

   if (query_verb() == "himmel") himmel = 1;
   else if(!str) {
      string *errmsg =
         (!fail_gabe("fs",1) ? ({"fliege zu <Spieler>"}) : ({}))
        +(!fail_gabe("fo",1) ? ({"fliege nach <Ort>"}) : ({}))
        +(!fail_gabe("ff",1) ? ({"fliege zum Schiff"}) : ({}))
        +(!fail_gabe("ef",1) ? ({"fliege zu meinem eigenen Flugziel"}) : ({}));
      if (!sizeof (errmsg))
          FAIL("Du kannst noch nicht fliegen.\n");
      FAIL("Wohin willst Du fliegen?\n"+
          wrap(liste (errmsg," oder ")+"?\n"));
   }
   if(earth_bind())
      return 1;
   if (flugsperre && zeitpunkt_des_naechsten_fluges > time())
      FAIL("Du hattest doch nach deiner letzten peinlichen "
	 "Notlandung beschlossen, dich\n"
	 "erstmal wieder richtig zu erholen, bevor du wieder fliegst!\n");
   flugsperre = 0;
   if(find_call_out("landung") != -1) {
      if (environment(this_player())->query_flugraum())
	 FAIL("Du fliegst doch bereits!\n");
      remove_call_out ("landung");
      remove_call_out ("notlandung");
      remove_call_out ("zu_frueh_wieder_geflogen");
   }
   if(drinnen (environment(this_player())))
      FAIL("Du kannst nur unter freiem Himmel zu einem Flug starten!\n");

   if (!himmel)
      str = lower_case(str);
   if (himmel) {
      kosten = fail_gabe("hi",1) ? this_player()->query_max_sp() / 2 : 0;
      if(kosten > this_player()->query_sp())
	 FAIL("Du hast nicht genügend "+this_player()->query_sp_name()
            +", um in den Himmel zu steigen.\n");
      flugziel = "/room/hlp/wolke";
      target = touch (flugziel);
      flugziel_ist_spieler=0;
      if(!abflug_erlaubt(environment(this_player())))
	 return 0;
   }
   else if (str=="aufs schiff" || str=="auf mein schiff"
       || str=="zu meinem schiff" || str=="zum schiff"
       || str=="nach meinem schiff" || str=="zu schiff") {
      TEST("ff");
      if (!(target = "/z/Schiffe/Werft/master_object"->query_has_ship(
               this_player()->query_real_name()))) {
#ifdef UNItopia
#include "/d/Kokosinsel/sys/ehe_ex.h"
         string ehepartner=STANDESAMT->query_marriage_partner(
                        this_player()->query_real_name());
         if (ehepartner)
            if (!(target = "/z/Schiffe/Werft/master_object"->query_has_ship(
                ehepartner)))
                return notify_fail("Du und Dein Ehepartner habt leider beide kein Schiff.\n");

            else ;
         else
#endif
         FAIL("Du hast leider kein Schiff.\n");
      }
      flugziel = target->query_enter_room();
      if (!environment(target)) FAIL("Dein Schiff ist nicht erreichbar.\n");
      if (!flugziel) flugziel = object_name(environment (target));
      if (!flugziel) FAIL ("Dein Schiff ist nicht erreichbar.\n");
      if(zuviel_gepaeck())
	 FAIL("Du bist mit all deinem Gepäck viel zu schwer zum Fliegen!\n");
      flugziel_ist_spieler=0;
      if(!(target = touch(flugziel, NO_WRITE)))
	 FAIL("Dein gewünschtes Flugziel ist nicht erreichbar!\n");
      if(!abflug_erlaubt(environment(this_player())))
	 return 0;
      flugzielname = "zum Schiff";
   }
   else if ((strstr (str,"flugziel") != -1) && 
        ((strstr (str, "mein") != -1) || (strstr (str, "eigene") != -1))) {
      // Spieler will zu eigenem Flugziel fliegen
      TEST("ef");
      if (!eigene_flugziele || !sizeof (eigene_flugziele))
          FAIL ("Du hast noch kein eigenes Flugziel gesetzt.\n");
      // hier kann man, falls es mal mehrere Flugziele geben sollte,
      // abpruefen, welches eigene Flugziel gemeint ist
      target = touch (eigene_flugziele[0], NO_WRITE|NO_LOG);
      if (!target)
      {
          do_warning2("Eigenes Flugziel nicht erreichbar\n", 
            eigene_flugziele[0],eigene_flugziele[0], 1);
          FAIL("Dein gewünschtes Flugziel ist nicht erreichbar!\n");
      }
      if(!abflug_erlaubt(environment(this_player())))
          return 0;
      if (!anflug_erlaubt(target))
          return 0;
      flugziel = eigene_flugziele[0];
      flugzielname = "zum eigenen Flugziel: "+eigene_flugziele[1];
      if(zuviel_gepaeck())
	 FAIL("Du bist mit all deinem Gepäck viel zu schwer zum Fliegen!\n");
      if (!abflug_erlaubt(environment(this_player())))
	 return 0;
      flugziel_ist_spieler=0;
   }
   else if(sscanf(str, "zu %s", ziel) || sscanf(str, "zur %s", ziel) ||
      sscanf(str, "zum %s", ziel))
   {
      TEST("fs");
      if(!(target = find_player(ziel)))
         FAIL(wrap(capitalize(ziel)+" ist nicht aufzufinden!"));
      if( (wizp(target) || testplayerp(target))
             && (target->query_no_wer() 
                 || target->query_invis()== V_INVIS) )
         FAIL(wrap(capitalize(ziel)+" ist nicht aufzufinden!"));
      if (target == this_player())
	  FAIL("Zu Dir selber? Du bist doch schon da, wo du bist!\n");
      if(zuviel_gepaeck())
	 FAIL("Du bist mit all deinem Gepäck viel zu schwer zum Fliegen!\n");
      if (!abflug_erlaubt(environment(this_player())))
	 return 0;
      if(target->query_no_airport())
	 FAIL(wrap(Der(target)+
	 " möchte nicht, dass du zu "+ihm(target)+" fliegst."));
#ifdef UNItopia	 
      if(target->query_gilde()=="Orkgilde")
         FAIL( wrap (
              "Du kannst mit einer göttlichen Gabe, wie dem Engelsflug, "
              "nicht zu so einem gottvergessenen Wesen, wie einem Ork fliegen. "
              "Außerdem sehen die eh alle gleich aus."));
#endif
      if(wizp(target) &&
         testplayerp(this_player()) != target->query_real_name())
	 FAIL("Zu Göttern kannst du nicht fliegen.\n");
      if(testplayerp(target) && !wizp(this_player()) &&
         testplayerp(target) != testplayerp(this_player()))
	 FAIL(wrap("Die Götter wollen nicht, dass du zu "+dem(target)+
	      " fliegst."));
      if(environment(target)->query_flugraum())
	 FAIL(wrap(Der(target)+" fliegt gerade irgendwo in der Luft herum, "
	    "Du kannst "+ihn(target)+" daher gerade leider nicht erreichen."));
      // get_environment holt die richtige Umgebung (z.B. bei Schiffen)
      // Das || environment(target) ist nur zur Absicherung, falls das Schiff
      // durch einen Fehler im Nirwana steht.
      flugzielname="zu "+target->query_real_cap_name();
      target = get_environment(target) || environment(target);
      flugziel=ziel;
      flugziel_ist_spieler=1;
   } else if(sscanf(str, "nach %s", ziel)) {
      TEST("fo");
      if(zuviel_gepaeck())
	 FAIL("Du bist mit all deinem Gepäck viel zu schwer zum Fliegen!\n");
      if(!(tmp = TELE_MASTER->get_tele(ziel)) || !query_ort(tmp))
	 FAIL(wrap("Du kennst kein Flugziel namens '"+ziel+"'."));
      flugziel = tmp;
      flugziel_ist_spieler=0;
      if(!(target = touch(flugziel, NO_WRITE)))
	 FAIL("Dein gewünschtes Flugziel ist nicht erreichbar!\n");
      if(!abflug_erlaubt(environment(this_player())))
	 return 0;
      flugzielname = "nach " + implode(map(explode(
	   (get_ziel_name(flugziel)||ziel),
	   " "),#'capitalize)," ");
   } else {
      string *errmsg =
         (!fail_gabe("fs",1) ? ({"fliege zu <Spieler>"}) : ({}))
        +(!fail_gabe("fo",1) ? ({"fliege nach <Ort>"}) : ({}))
        +(!fail_gabe("ff",1) ? ({"fliege zum Schiff"}) : ({}))
        +(!fail_gabe("ef",1) ? ({"fliege zu meinem eigenen Flugziel"}) : ({}));
      FAIL("Wohin willst Du fliegen?\n"+
          wrap(liste (errmsg," oder ")+"?\n"));
   }
   ziel_domain = target->query_room_domain();
   if(ziel_domain == "Pantheon")
	 FAIL("In die Gefilde der Götter darfst du nicht fliegen.\n");

   if (ziel_domain == "Ozean" && !drinnen(target) && anflug_erlaubt(target))
      notlandeziel = object_name (target);
   else
      notlandeziel = STARTRAUM_SERVER->query_startraum_of_domain(ziel_domain);

   here = environment(this_player());
   rueckflugziel = startraum = object_name (here);
   // Wenn der Spieler in einem Schiff rumsteht so interessiert uns nicht
   // dessen Dateiname sondern der Ort, an dem sich das Schiff auf der
   // Map befindet
   here = get_environment(this_player()) || here;
   // Wenn der Spieler gerade fliegt, dann heisst das, dass er sein
   // Ziel nicht erreichen konnte, (Ziel ist ein geschlossener Raum,
   // Ziel war ein Spieler, der sich ausgeloggt hat o.ae.) aber theoretisch
   // dort ist; dann ist das "notlandeziel" eine bessere Wahl als
   // Startraum fuer den Flug als alles andere.
   if (here->query_flugraum() && notlandeziel)
      startraum=notlandeziel;
   hier_domain = here->query_room_domain();
   if (hier_domain == "Ozean")
       rueckflugziel = object_name (environment(environment()));
   else
       rueckflugnotlandeziel = STARTRAUM_SERVER->query_startraum_of_domain(hier_domain);

   if(hier_domain==ziel_domain) {
      // Flug innerhalb einer Domain
      if(koords = get_map_koords(object_name(here))) {
	 x1 = koords[0]; y1 = koords[1];
	 if(koords = get_map_koords(object_name(target))) {
	    x2 = koords[0]; y2 = koords[1];
	    if (gabe("tf",1))
		    dauer = get_dist(x1,y1,x2,y2) / 13;
	    else
        	    dauer = get_dist(x1, y1, x2, y2) / 9;
	    if (dauer < 4) dauer = 4;
	    else if (dauer > 20) dauer = 10 + (dauer - 10) / 2;
	 }
      }
      if (!dauer) {
         if (gabe("tf",1))
 	    dauer = 4;
         else
	    dauer = 8;
      }
   } else {
      // Flug zwischen Domains und oder ueber dem Ozean
      if ((hier_domain == "Campus") || (hier_domain == "Ebenen") ||
	 (ziel_domain == "Campus") || (ziel_domain == "Ebenen"))
	 if (gabe("tf",1))
	     dauer = 16;
	 else
	     dauer = 24;
      else {
	 koords = get_map_koords(object_name(here));
	 if (!koords) koords = get_map_koords("/d/"+hier_domain+"/m0_0");
	 if (koords) {
	    x1 = koords[0]; y1 = koords[1];
	    koords = get_map_koords(object_name(target));
	    if (!koords) koords = get_map_koords("/d/"+ziel_domain+"/m0_0");
	    if (koords) {
	       x2 = koords[0]; y2 = koords[1];
	       if (gabe("tf",1))
		   dauer = get_dist(x1,y1,x2,y2) / 27 + 2;
	       else
		   dauer = get_dist(x1, y1, x2, y2) / 18 + 2;
	       if(gabe("tf",1))
	       {
	           // mindestdauer 18 MUSS auch beim Turboflug gewahrt
	           // bleiben, sonst gibts Probleme mit dem Domainmeldungen
		   if (dauer < 18) dauer = 18;
		   else if (dauer > 22) dauer = 22 + (dauer - 22) / 4;
	       }
	       else
	       {
		   if (dauer < 18) dauer = 18;
	           else if (dauer > 30) dauer = 30 + (dauer - 30) / 3;
	       }
	    }
	 }
	 if (!dauer) // das sollte eigentlich nie passieren.
	    dauer = 20;
      }
      if (IS_DAY && this_player()->query_eye_option("kurz")!=1) {
	 if (((hier_domain == "Ozean") && (str = abflug_meldung ["map"]))
	   || (str = abflug_meldung [hier_domain]))
	    call_out ("meldung",6,str);
	 if (((ziel_domain == "Ozean") && (str = ankunft_meldung ["map"]))
	   || (str = ankunft_meldung [ziel_domain]))
	    call_out ("meldung",dauer-6,str);
      }
   }
#if 0
   if (wizp(this_player())) {
      write ("Debug - Infos:\n");
      write ("Geschätzte Flugdauer: "+dauer+" Sekunden.\n");
      write ("Notlandeziel: "+notlandeziel+"\n");
      write ("Flug von: "+object_name(here)+"\nnach: "+object_name(target)+"\n");
      write ("Rueckflugziel: "+rueckflugziel+",\nRueckflugnotlandeziel: "+
	 rueckflugnotlandeziel+"\n");
      if (x1 && x2 && y1 && y2)
      write ("Koordinaten: ("+x1+"/"+y1+") -> ("+x2+"/"+y2+"), Distanz: "
      +get_dist(x1,y1,x2,y2)+"\n");
   }
#endif
   if (flugraum!=environment(environment())) {
      flugraum = clone_object("/obj/flugraum");
      flugraum->add_type("startraum",startraum);
   }
   flugraum->set_short("Du fliegst");
   if (himmel)
      flugraum->set_long ("Du fliegst in der Luft über den Wolken auf dem "
	 "Weg in den Himmel.");
   else
      flugraum->set_long ("Du fliegst in der Luft über den Wolken auf dem "
      "Weg " + flugzielname + ".");
   if(environment(this_player())!=flugraum) {
      if (start_meldung=here->query_type("flugstart_meldung")) {
	 move_wie = MOVE_MAGIC | MOVE_SECRET;
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_MOVE,
	    wrap (start_meldung));
      } else move_wie = MOVE_MAGIC;
      if(this_player()->move(flugraum, ([
        MOVE_FLAGS:     move_wie,
        MOVE_TYPE:      MOVE_TYPE_FLIEGEN,
        MOVE_MSG_LEAVE: himmel ? "$Der() fliegt gen Himmel davon" : 0
      ])) != MOVE_OK) 
        {
         if(!this_player()->query_not_moved_reason())
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Irgendwas hindert dich am Abfliegen.\n");
         flugraum->remove();
         flugziel = 0;
         return 1;
        }
      else
	flugraum->set_target(target);
   } else
      if (himmel)
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_MOVE,
	     wrap ("Du fliegst weiter, diesmal auf dem Weg "
	     "in den Himmel."));
      else
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_MOVE,
	    wrap ("Du fliegst weiter, diesmal auf dem Weg "
	    +flugzielname+"."));

   if(kosten)
      this_player()->add_sp(-kosten);
   remove_call_out("notlandung");
   call_out("landung",dauer);
   if (zeitpunkt_des_naechsten_fluges > time())
      call_out ("zu_frueh_wieder_geflogen",4);
   remove_call_out ("zeitpunkt_des_naechsten_fluges_erreicht");
   return 1;
}

void meldung (string s)
{
   if (this_player() && flugraum && (flugraum == environment(this_player())))
        send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,wrap(s));
}

int versuche_alternatives_landeziel (object target)
{
   string s, *x;
   if ((!(s = target->query_type("landeplatz"))) || !stringp (s))
   {
      object env = get_environment(target);
      if(clonep(env) || env==target || drinnen(env) ||
    	 env->query_type("teleport_rein_verboten"))
	    return 0;
      
      flugziel = object_name(env);
      flugziel_ist_spieler = 0;
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
           "Du suchst Dir einen möglichst nahegelegenen alternativen "
           "Landeplatz unter freiem Himmel.\n");
      call_out ("landung",4);
      return 1;
   }
   // aus einem moeglicherweise relativen Pfad einen absoluten machen
   if (strstr (s,"/") == -1) {
      x = explode (object_name (target),"/");
      x[sizeof(x)-1] = s;
      s = implode (x,"/");
   }
   flugziel = s;
   flugziel_ist_spieler = 0;
   this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
      "Du suchst Dir einen möglichst nahegelegenen alternativen "
      "Landeplatz unter freiem Himmel.\n");
   call_out ("landung",4);
   return 1;
}

void landung(int schonda)
{
    object player, target;
    mixed tmp;
    string lande_meldung;

    if (environment(this_player()) != flugraum) {
	if (flugraum) flugraum->remove();
	return;
    }
    if (flugziel_ist_spieler) {
	if (!player=find_player(flugziel)) {
           this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
	       wrap("Das Ziel deines Fluges, "+capitalize(flugziel)
		+", ist verschwunden."));
	    flugziel = 0;
	    flugraum->set_long("Du flatterst unschlüssig in der Luft "
		"herum und solltest Dir ein neues Flugziel suchen, bevor "
		"deine Flügel müde werden und du eine Notlandung machen "
		"musst.");
            this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
	        wrap ("Du flatterst unschlüssig in der Luft "
		"herum und solltest Dir ein neues Flugziel suchen, bevor "
		"deine Flügel müde werden und du eine Notlandung machen "
		"musst. Oder du landest einfach am nächstgelegenen Ort."));
	    call_out ("notlandung",20);
	    return;
	}
	target=environment(player);
	if (target->query_flugraum()) {
            this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
	        wrap(capitalize(flugziel)+" fliegt in der Luft umher; "
		"du fliegst hinterher."));
	    call_out ("landung",10);
	    return;
	}
	if (!schonda) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_MOVE,
	       "Du setzt zur Landung an...\n");
	    call_out ("landung",2,1);
	    return;
	}
	if (tmp=target->query_type("teleport_rein_verboten")) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	      stringp(tmp)
	      ? wrap("Du kannst am Ziel deines Fluges bei "
		+capitalize(flugziel)+" nicht landen. " + tmp)
	      : wrap("Irgendetwas lässt dich am Ziel deines Fluges bei "
		+capitalize(flugziel)+" nicht landen."));
	    if (versuche_alternatives_landeziel(target))
	       return;
	    flugziel = 0;
	    flugraum->set_long("Du flatterst unschlüssig in der Luft "
		"herum und solltest Dir ein neues Flugziel suchen, bevor "
		"deine Flügel müde werden und du eine Notlandung machen "
		"musst.");
            this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
	        wrap("Du flatterst unschlüssig in der Luft "
		"herum und solltest Dir ein neues Flugziel suchen, bevor "
		"deine Flügel müde werden und du eine Notlandung machen "
		"musst. Oder du landest einfach am nächstgelegenen Ort."));
	    call_out ("notlandung",20);
	    return;
	}
   } else {
      if (!schonda) {
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_MOVE,
	    "Du setzt zur Landung an...\n");
	 call_out ("landung",2,1);
	 return;
      }
      target = touch(flugziel, NO_WRITE);
   }
   if (!target)
       this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_UNKNOWN,
          "Das Ziel deines Fluges ist nicht erreichbar.\n");
   else if (drinnen(target)) {
       this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_UNKNOWN,
          "Du kannst leider nur unter freiem Himmel landen.\n");
       if (versuche_alternatives_landeziel (target))
	  return;
       target = 0;
   } else {
      if (lande_meldung = target->query_type("lande_meldung"))
          this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
	     wrap (lande_meldung));
      if (this_player()->move(target, ([MOVE_FLAGS: MOVE_MAGIC, MOVE_TYPE: MOVE_TYPE_FLIEGEN])) != MOVE_OK) 
      {
	  if (this_player()->query_not_moved_reason())
             this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	        "Du kannst daher dort nicht landen.\n");
	  else 
             this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	         "Irgendwas lässt dich dort nicht landen.\n");
	  if (versuche_alternatives_landeziel (target))
	     return;
	  target = 0;
      } else {
	  compute_zeitpunkt_des_naechsten_fluges ();
	  flugraum = 0;
	  return;
      }
   }
   flugziel = 0;
   if (flugsperre) {
      flugraum->set_long("Du fliegst mit letzter Kraft dahin auf der "
	 "verzweifelten Suche nach einer Möglichkeit, zu landen, bevor "
	 "Du total erschöpfst hinunterknallst.");
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
         wrap ("Du fliegst mit letzter Kraft umher auf der "
	 "verzweifelten Suche nach einer Möglichkeit, zu landen, bevor "
	 "du total erschöpfst hinunterknallst."));
      call_out ("notlandung",10);
   } else {
      flugraum->set_long("Du flatterst unschlüssig in der Luft "
	 "herum und solltest Dir ein neues Flugziel suchen, bevor "
	 "deine Flügel müde werden und du eine Notlandung machen "
	 "musst.");
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
         wrap ("Du flatterst unschlüssig in der Luft "
	 "herum und solltest Dir ein neues Flugziel suchen, bevor "
	 "deine Flügel müde werden und du eine Notlandung machen "
	 "musst. Oder du landest einfach am nächstgelegenen Ort."));
      call_out ("notlandung",20);
   }
}

void notlandung (int schonda)
{
   if (environment(this_player()) != flugraum) {
      if (flugraum) flugraum->remove();
      return;
   }
   if (!schonda) {
      this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Deine Flügel schmerzen fürchterlich.\n"
	 "Mit letzter Kraft setzt du zur Notlandung an.\n");
      call_out ("notlandung",2,1);
      return;
   }
   compute_zeitpunkt_des_naechsten_fluges ();
   if((!notlandeziel||(this_player()->move(notlandeziel,
            ([MOVE_FLAGS: MOVE_MAGIC, MOVE_TYPE: MOVE_TYPE_FLIEGEN])) != MOVE_OK))
      && (this_player()->move ("/room/hlp/wolke",
            ([MOVE_FLAGS: MOVE_MAGIC, MOVE_TYPE: MOVE_TYPE_FLIEGEN])) != MOVE_OK)
      && (this_player()->move ("/room/void",
            ([MOVE_FLAGS: MOVE_MAGIC, MOVE_TYPE: MOVE_TYPE_FLIEGEN])) != MOVE_OK))
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Argl! Da ist ein besonders bösartiger Fehler "
	    "aufgetreten.\n");
   else
   {
      if (flugsperre)
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du musst dich jetzt aber mal so richtig erholen.\n");
      else
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du solltest deine Flügel jetzt mal ne Weile schonen!\n");
      flugraum = 0;
   }
}

int lande ()
{
   if (environment(this_player()) != flugraum) {
      if (flugraum) flugraum->remove();
      FAIL("Du fliegst doch gar nicht!\n");
   }
   if(flugsperre) FAIL("Jaja, du landest ja schon.\n");
   if(find_call_out("landung") != -1) {
      if (environment(this_player())->query_flugraum())
	 FAIL("Du fliegst doch bereits zu einem Flugziel!\n");
      remove_call_out ("landung");
      remove_call_out ("notlandung");
      remove_call_out ("zu_frueh_wieder_geflogen");
      FAIL("Du fliegst doch gar nicht!\n");
   }
   this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_MOVE,
      "Du suchst Dir einen halbwegs geeigneten Landeplatz und "
      "setzt zur Landung an...\n");
   remove_call_out ("notlandung");
   call_out ("notlandung",6,1);
   return 1;
}

int flughafen(string str)
{
   TEST("fh");
   if(str == "?")
      if(environment()->query_no_airport())
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du kannst nicht angeflogen werden.\n");
      else
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du kannst angeflogen werden.\n");
   else
      if(environment()->set_no_airport(environment()->query_no_airport() ^ 1))
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du kannst jetzt nicht mehr angeflogen werden.\n");
      else
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    "Du kannst jetzt wieder angeflogen werden.\n");
   return 1;
}

int sehe(string str)
{
   object who, env;
   string long;
   mixed ret;

   TEST("se");
   if(!str)
      FAIL("Sehe nach <wem>?\n");
   sscanf(str, "nach %s", str);

   
   
   this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
      "Du wirfst einen Blick in "+deinen()+"... ");
   this_player()->send_message(MT_LOOK,MA_LOOK,
      wrap(Der(this_player())+" wirft einen Blick in "+seinen()+"..."));
   if (!(who = find_player(lower_case(str)))  ||
       wizp (who) || testplayerp (who) ||
       IS_HIDDEN(who) ||
       ((env = environment(who)) && env->query_room_domain() == "Pantheon"))
   {
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
         "vergeblich.\n");
      this_player()->send_message(MT_LOOK,MA_LOOK,
         "kann aber nichts darin erkennen.\n");
      return 1;
   }
   
   ret = environment(who) && environment(who)->forbidden("spy_here", this_object());
   if(ret)
   {
      if(stringp(ret))
         ret = ({ret});
      else if(!pointerp(ret))
         ret = ({});
      this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
         (sizeof(ret)>0)?("\n"+wrap(ret[0],79)):"vergeblich.\n");
      this_player()->send_message(MT_LOOK,MA_LOOK,
         (sizeof(ret)>1)?wrap(ret[1],79):"kann aber nichts darin erkennen.\n");
      return 1;
   }
   
   this_player()->send_message(MT_LOOK,MA_LOOK,
      "und sieht eine Gestalt darin!\n");
   this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
      "und siehst:\n"+copies("-",79)+"\n"+
     ((!(env = environment(who)) ||
       !(long = env->query_flugraum()
	  ? wrap(Der(who)+" fliegt hoch in der Luft über den Wolken.")
	  : this_player()->describe_room(env, EYE_NO_EXITS | EYE_FORCE_LONG | EYE_SHOW_ME)))
      ?wrap("Ein leerer Raum, in dem sich nur " +der(who)+" aufhält.")
      :long)
     +copies("-",79)+"\n");
   return 1;
}

/*
FUNKTION: forbidden_spy_here
DEKLARATION: mixed forbidden_spy_here(object wer, object raum)
BESCHREIBUNG:
Wenn Spieler 'wer' mit der Engelskugel (oder evntl. auf andere magische
Weise) in den Raum 'raum' schaut, wird raum->forbidden("spy_here", wer)
aufgerufen. forbidden ruft dann in allen mit raum->add_controller(
"forbidden_spy_here", other) angemeldeten Objekten other die Funktion
other->forbidden_spy_here(wer, raum) auf. Diese Objekte koennen dann durch
Rueckgabe eines String-Arrays dieses Sehen unterbinden.

Das zurueckzuliefernde Array hat den Aufbau ({ "Meldung an wer", 
"Meldung an alle anderen im Raum" }). Diese Meldungen werden automatisch
umgebrochen. Liefert diese Funktion statt einem Array nur eine 1 zurueck,
so wird das Sehen auch verhindern, jedoch mit den Standardmeldungen.

Diese Funktion sollte nur sehr selten und nur mit guter Begruendung
genutzt werden.
VERWEISE: forbidden_hlp_gabe, forbidden_hlp_gabe_here
GRUPPEN: level
*/

#if 0
int spielstand(string str)
{
   int i;
   object who;

   if(!str)
      return 0;
   if(fail_gabe("we",1))
   {
      write("Du besitzt die Gabe 'Weisheit' gar nicht!\n");
      return 1;
   }
   TEST("we");
   if(!(who = present(lower_case(str), environment(this_player()))))
   {
      write(wrap(capitalize(str)+" ist gar nicht hier!"));
      return 1;
   }
   if(!playerp(who))
   {
      write(wrap(Der(who)+ " ist kein Mitspieler!"));
      return 1;
   }
   write(wrap("Du betrachtest "+den(who)+" durch "+deinen()+":"));
   write(wrap(Er(who)+" ist "+who->query_short()+".\n"+
	 Er(who)+" hat "+who->query_experience_promille()/10.0+"% "
	 "der zum Aufstieg notwendigen Erfahrung.\n"+
	 who->query_hp()+" Ausdauer-Punkte("+who->query_max_hp()+") und "+
	 who->query_sp()+" Zauber-Punkte("+who->query_max_sp()+").\n"+
	 Sein((["name":"fähigkeiten","gender":"weiblich","plural":1]),
	      0,who)+
	 " sind:\n"));
   for(i=0; i < STAT_NUMBER; i++)
      write(capitalize(STAT_NAMES[i])+": "+who->query_stat(i)+"   ");
   write("\nAlter:\t"+format_seconds(who->query_age())+".\n");
   this_player()->send_message(MT_LOOK,MA_MAGIC,
      wrap(Der(this_player())+" betrachtet "+den(who)+
      " durch "+seinen()+"."),
      wrap(Der(this_player())+" betrachtet dich durch "+seinen()+"."),
      who);
   return 1;
}
#endif


int wechsle(string str)    { TEST("ba"); return ::wechsle(str);    }
int kontostand(string str) { TEST("ba"); return ::kontostand(str); }

int waehrung(string str)
{
   string aktuell, out;
   int i;

   TEST("ba");
   if(str)
   {
      string val;
      str = lower_case(str);
      val = query_accepted_valutas(str);
      
      if(val)
      {
	 set_valuta(query_accepted_valuta(val));
	 set_valutas(val);
         send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    wrap("Neue Währung: "+capitalize(query_valutas())+"."));
      }
      else
	 FAIL(wrap("Die Währung '"+capitalize(str)+"' kennst du nicht."));
      this_player()->send_message(MT_LOOK|MT_NOISE,MA_UNKNOWN,
          wrap(Der(this_player())+
	  " flüstert ein magisches Wort zu "+seinem()+"."));
   }
   else
   {
      string *valutas = query_valutas_tafel();
      out = "";
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         "Verfügbare Währungen:\n");
      aktuell = query_valutas();
      
      for(i = 0; i < sizeof(valutas); i++)
	 if(valutas[i] == aktuell)
	    out += ">"+capitalize(valutas[i])+"<\n";
	 else
	    out += capitalize(valutas[i])+"\n";
      send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
         sprintf("%-79#s\n", out));
      this_player()->send_message(MT_LOOK,MA_UNKNOWN,
         wrap(Der(this_player())+
	 " liest ein paar magische Worte aus "+seinem()+"."));
   }
   return 1;
}

int zahle(string str)
{
   string waehrun;
   TEST("ba");
   notify_fail ("zahle <wieviel> <Waehrung> ein?\n");
   if (!str) return 0;
   if (sscanf(str,"%~d %s ein",waehrun) != 2)
      return ::zahle (str);
   if (!waehrung(waehrun))
      return 0;
   return ::zahle(str);
}

int hebe(string str)
{
   string waehrun;
   TEST("ba");
   notify_fail ("hebe <wieviel> <Waehrung> ab?\n",FAIL_NOT_OBJ);
   if (!str) return 0;
   if (sscanf(str,"%~d %s ab",waehrun) != 2)
      return 0;
   if (!waehrung(waehrun))
      return 0;
   return ::hebe(str);
}

void notify_moved(mapping mv_infos)
{
   if(environment() && !interactive(environment()) && followed_ob)
   {
      followed_ob->delete_controller("notify_moved");
      followed_ob = 0;
      follow = 0;
      return;
   }

   if(follow < 0)
      follow = 0;
   else if(mv_infos[MOVE_FLAGS] == MOVE_NORMAL 
        && follow >= 0 && follow < 2)
   {
      follow++;
      call_out("do_follow", 0, mv_infos);
   }
   else if(followed_ob)
      followed_ob->send_message_to(environment(),MT_LOOK|MT_NOTIFY,MA_MOVE,
         wrap(Der(followed_ob)+" springt Dir davon."));
}

void do_follow(mapping mv_infos)
{
   object who;
   mixed dest = mv_infos[MOVE_DIRECTION] ? mv_infos[MOVE_DIRECTION]: mv_infos[MOVE_NEW_ROOM];

   if(who = environment())
      call_with_this_player(#'call_other, who, "move", dest, mv_infos);
   else
   {
      if(followed_ob)
        followed_ob->delete_controller("notify_moved");
      follow = 0;
      followed_ob = 0;
      return;
   }
   if(follow > 0)
      follow--;
   if(!follow && followed_ob && environment(followed_ob) != environment(who))
   {
        followed_ob->delete_controller("notify_moved");
      followed_ob = 0;
   }
}

int verfolge(string str)
{
   object ob;

   TEST("ve");
   if(!str)
      if(followed_ob)
      {
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	    wrap("Verfolgung von "+dem(followed_ob,"")+" aufgegeben."));
	 followed_ob->delete_controller("notify_moved");
	 followed_ob = 0;
	 follow = 0;
	 return 1;
      }
      else
	 FAIL("Verfolge <wen>?\n");

   if(!(ob = present(lower_case(str), environment(this_player()))))
      FAIL(wrap(capitalize(str)+" ist doch gar nicht hier!"));
   if(!playerp(ob))
      FAIL("Du kannst nur Spielern folgen!\n");
   if(ob == this_player())
      FAIL("Willst du dich etwa selbst verfolgen?\n");
   if(followed_ob)
	 followed_ob->delete_controller("notify_moved");

   follow = 0;
   followed_ob = ob;
   ob->add_controller("notify_moved");
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
      wrap("Du folgst nun "+dem(ob)+"."));
   this_player()->send_message(MT_LOOK,MA_UNKNOWN, wrap(
      Der(this_player())+" deutet mit "+seinem()+" auf "+den(ob)+". "+
      Der(this_player())+" folgt "+dem(ob)+" jetzt auf Schritt und Tritt."),
      wrap(Der(this_player())+" folgt Dir jetzt."), ob);
   return 1;
}


//
// V-Items hinzufuegen / loeschen / listen
//

int list_vitem()
{
    TEST("de");
    if (!vitems || !sizeof (vitems)) {
        this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
           "Du hast gar keine Details beschrieben.\n");
        return 1;
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY|MT_LOOK,MA_LOOK,
      wrap ("Du hast "
        +liste(map (vitems, 
	    (: einen($1+($1[V_ADJ]?(["adjektiv":({$1[V_ADJ]})]):([]))) :)),
	    " und ")
        +" an Dir."));
    return 1;
}

int remove_vitem(string str)
{
   int i;
   TEST("de");
   if (!vitems || !sizeof (vitems)) {
       this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
          "Du hast noch gar keine Details beschrieben.\n");
       return 1;
   }
   if (!str || str == "") {
       this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
          "Welches Detail möchtest du entfernen (Abbruch mit ~q)?\n");
       input_to ("remove_vitem", INPUT_PROMPT, "Name: ");
       return 1;
   }
   if (str == "~q") {
       this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
          "Du brichst ab.\n");
       return 1;
   }
   str = lower_case (str);
   for (i = 0; i < sizeof (vitems); i++)
      if (str == lower_case (vitems[i][V_NAME])) {
         vitems[i][V_ADJ] = ({ vitems[i][V_ADJ] }); // fuer die Meldung.
         this_player()->delete_v_item( ({vitems[i][V_NAME]}) );
         this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
            wrap (Der(vitems[i])+plural(" wird"," werden",vitems[i])
            +" entfernt."));
         this_player()->send_message(MT_LOOK,MA_USE,
           wrap(Der(this_player())+" wirft "+seinen()+
	   " hoch und wartet, bis "+er()+" wieder runterschwebt."));
         vitems = arr_delete (vitems, i);
         return 1;
   }
   this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
      "Kein solches von Dir selbst erschaffenes Detail gefunden.\n");
   return 1;
}


// Also so zur Uebersicht woran gedacht wurde:
//	* Doppelte Belegungen, und generell vitems, die man bereits hat, sind verboten.
//	* Zauberstab und Spielerausweis als Name und ID sind verboten.
//	* Name und IDs muessen aus Zeichen bestehen.
//	* Scrollschutz: \n\n\n\n wird zu \n convertiert.

// Beschraenkungen:
//	2 < Name < 15 Zeichen
//	max Id-Anzahl 5
//	2 < ID < 15 Zeichen
//	Adjektiv < 15 Zeichen
//	Geruch, Gefiehl, Geraeusch < 160 Zeichen
//	Langbeschreibung < 320 Zeichen


string convertstr(string str)
{
    string salt;
    do {
        salt = str;
        str = regreplace (str,"\\\\n\\\\n","\\\\n",1);
    } while (str != salt);
    return regreplace (str,"\\\\n","\n",1);
}

int create_vitem(string str)
{
    int faktor;
    
    TEST("de");
    if (gabe ("de2",1)) faktor = 2; else faktor = 1;
    
    if (vitems && (sizeof (vitems) >= faktor * V_ITEM_MAX)) {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
           faktor == 1
	     ? wrap ("Du hast bereits alle "+faktor*V_ITEM_MAX+" möglichen Details "
	        "belegt. Um ein neues anzulegen, musst du erst eines löschen "
	        "oder die Gabe 'Doppelt so viele Details' erwerben.")
	     : wrap ("Du hast bereits alle "+faktor*V_ITEM_MAX+" möglichen Details "
	        "belegt. Um ein neues anzulegen, musst du erst eines löschen.")
	     );
	return 1;
    }
    
    new_vitem = ([]);
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
       "In den folgenden Schritten kannst du stets mit ~q abbrechen.\n"
       "Name des Details (2 bis 30 Zeichen, keine Sonderzeichen)\n");
    input_to("step2", INPUT_PROMPT, "Name: ");
    return 1;
}

string *forbidden_vitems = ({"zauberstab","spielerausweis","ausweis"});

void step2(string name)
{
    string *woerter, tmp;
    int i;
    if (!name||name=="") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Du musst den Namen des Details angeben. Versuchs nochmal.\n");
	input_to("step2", INPUT_PROMPT, "Name: "); 
	return; 
    }
    name = lower_case(name);
    if (name=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ok, du brichst ab.\n"); 
	return; 
    }
    if (this_player()->query_v_item(({name}))) {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ein Detail mit diesem Namen oder Id hast du bereits.\n");
	input_to("step2", INPUT_PROMPT, "Name: "); 
	return;
    }
    woerter = explode (name," ");
    for (i = sizeof (woerter); i--; )
	if (member(forbidden_vitems,lower_case(woerter[i])) != -1) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       woerter[i]+" geht nicht. Versuchs nochmal.\n");
	    input_to("step2", INPUT_PROMPT, "Name: "); 
	    return;
	}
    if ((strlen(name) > 30)||(strlen(name) < 2)) {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Mehr als 30 oder weniger als 2 Zeichen sind nicht erlaubt.\nVersuchs nochmal.\n"); 
	input_to("step2", INPUT_PROMPT, "Name: "); 
	return; 
    }
/*
    if (player_exists (name)) {
        write ("Es gibt bereits einen Spieler dieses Namens, sowas fuehrt zu Problemen.\nName: ");
        input_to("step2");
        return;
    }
*/
    tmp = lower_case(name);
    for (i=strlen(name); i--; ) {
       	if ((tmp[i] < 'a' || tmp[i] > 'z') && tmp[i] != ' ') {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Der Name darf nur aus Buchstaben bestehen.\n");
	    input_to("step2", INPUT_PROMPT, "Name: "); 
	    return;
	}
    }
    new_vitem [V_NAME] = name;
    input_to("step3", INPUT_PROMPT,
	"Geschlecht des Details ([m]aennlich,[w]eiblich oder [s]aechlich): ");
}


void step3(string gender)
{
    if (!gender||gender=="") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Du musst das Geschlecht des Details angeben. Versuchs nochmal.\n");
	input_to("step3", INPUT_PROMPT,
	    "Geschlecht des Details ([m]aennlich,[w]eiblich oder [s]aechlich): ");
	return;
    }
    gender=lower_case(gender);
    if (gender=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
           "Ok, du brichst ab.\n");
	return;
    }
    if (gender=="m"||gender=="maennlich")
        gender="maennlich";
    else if (gender=="w"||gender=="weiblich")
	gender="weiblich";
    else if (gender=="s"||gender=="saechlich")
	gender="saechlich";
    else {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Nicht eindeutig, vertippt? Versuchs nochmal.\n");
	input_to("step3", INPUT_PROMPT,
	    "Geschlecht des Details ([m]aennlich,[w]eiblich oder [s]aechlich): ");
	return;
    }
    new_vitem[V_GENDER] = gender;
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
       "IDs des Details (Trennen durch Leerzeichen oder Komma, mindestens eine,\nmaximal 5, jede ID mindestens 2, maximal 15 Zeichen, keine Sonderzeichen)\n");
    input_to("step4", INPUT_PROMPT, "IDs: "); 
}

void step4(string id)
{
    string *ids;
    int i,k;
    
    if (!id||id=="") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Du musst mindestens eine ID angeben (Trennen durch Leerzeichen, maximal 5)\n");
	input_to("step4", INPUT_PROMPT, "IDs: ");
	return;
    }
    id=lower_case(id);
    if (strstr (id,"~q") != -1) {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
           "Ok, du brichst ab.\n");
        return;
    }
    ids = (regexplode(id,"[ ,;]"))-({0,""," ",",",";"});
    for (i = 0; i < sizeof(ids); i++) {
    	if(i==5) { 
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Es sind maximal 5 Ids erlaubt. Wähle die, die dir am sinnvollsten erscheinen.\nIds des Details (mindestens eine, maximal 5, trennen durch Leerzeichen)\n"); 
	    input_to("step4", INPUT_PROMPT, "IDs: ");
	    return;
	}
	if (member(forbidden_vitems,ids[i]) != -1) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Verwenden von "+ids[i]+" ist dir nicht erlaubt, versuchs nochmal.\n"); 
	    input_to("step4", INPUT_PROMPT, "IDs: "); 
	    return;
	}
/*	if (player_exists (ids[i])) {
	    write ("Es gibt leider einen Spieler mit Namen \""+ids[i]+"\".\nDa Probleme zu erwarten sind, geht dies nicht.\nIDs: ");
	    input_to("step4");
	    return;
	}
*/
	for (k=strlen(ids[i]); k--; ) {
            if ((ids[i][k] < 'a' || ids[i][k] > 'z')) {
                this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
		   "IDs dürfen nur aus Buchstaben bestehen. \""+ids[i][k]+"\" ist nicht möglich.\n");
		input_to("step4", INPUT_PROMPT, "IDs: "); 
		return;
	    }
	}
	if(this_player()->query_v_item(({ids[i]}))) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Ein Detail \""+ids[i]+"\" existiert bereits.\n");
	    input_to("step4", INPUT_PROMPT, "IDs: "); 
	    return;
	}
	if((strlen(ids[i]) > 15)||strlen(ids[i]) < 2) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Mehr als 15 oder weniger als 2 Zeichen sind bei Ids nicht erlaubt.\nDie ID \""+ids[i]+"\" ist nicht in Ordnung.\n");
	    input_to("step4", INPUT_PROMPT, "IDs: "); 
	    return; 
	}
    }
    new_vitem[V_IDS] = ids + ({new_vitem[V_NAME]});
    input_to("step5", INPUT_PROMPT,
       "Ist das Detail im Plural (Beispiel: \"Wolken\") (ja / nein): "); 
}


void step5(string pl)
{
    int plural;

    if(pl==""||!pl) {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Du musst ja oder nein wählen.\n"); 
	input_to("step5", INPUT_PROMPT, "Ist das Detail im Plural (ja / nein): "); 
	return;
    }
    if (pl=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
           "Ok, du brichst ab.\n");
        return;
    }
    pl = lower_case (pl);
    if (pl =="ja" || pl=="j" || pl=="1") plural = 1;
    else if (pl == "nein" || pl=="n" || pl == "nö" || pl=="0") plural = 0;
    else {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Nicht eindeutig, bitte nur ja oder nein. Versuchs nochmal.\n"); 
	input_to("step5", INPUT_PROMPT, 
	    "Ist das Detail im Plural zu sehen (ja / nein): "); 
	return;
    }
    new_vitem[V_PLURAL] = plural;
    input_to("step6", INPUT_PROMPT,
       "Adjektiv des Details? (maximal 15 Zeichen, Leer für keines): "); 
}


void step6(string adj)
{
    if (adj=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ok, du brichst ab.\n");
	return;
    }
    if (!adj||adj==""||adj==" ") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
           "Kein Adjektiv gewählt, ok.\n");
    } else {
        if (strlen(adj) > 15) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
               "Mehr als 15 Zeichen sind nicht erlaubt. Versuchs nochmal.\n"); 
	    input_to("step6", INPUT_PROMPT,
		"Adjektiv des Details (Leereingabe für keines): "); 
	    return;
        }
        new_vitem[V_ADJ] = adj;
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
        "\nFür alle folgenden Eingaben gilt:\n"
        "Abbruch mit ~q, Zeilenumbruch erzwingen mit \\n im Text, wenn du kein Text\n"
        "haben möchtest, gib einfach nichts ein (Leereingabe).\n"
        "Gib nun das Geräusch des Details ein (maximal 200 Zeichen)\n");
    input_to("step7", INPUT_PROMPT, "Geräusch: ");
}


void step7(string noise)
{
    if (noise=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ok, du brichst ab.\n");
	return;
    }
    if (!noise||noise==""||noise==" ") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Kein Geräusch gewählt, ok.\n");
    } else {
        noise = convertstr(noise);
        if(strlen(noise) > 210) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Ich sagte doch, nicht mehr als 200 Zeichen. Versuchs nochmal.\n"); 
	    input_to("step7", INPUT_PROMPT, "Geräusch: "); 
	    return; 
        }
        new_vitem[V_NOISE] = noise;
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
       "Gib nun den Geruch des Details ein (max 200 Zeichen)\n");
    input_to("step8", INPUT_PROMPT, "Geruch: "); 
}


void step8(string smell)
{
    if (smell=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ok, du brichst ab.\n"); 
	return;
    }
    if (!smell || smell=="" || smell==" ") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Kein Geruch gewählt, auch gut.\n");
    } else {
        smell = convertstr(smell);
        if(strlen(smell) > 210) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
               "Mehr als 200 Zeichen sind zuviel. Versuchs nochmal.\n"); 
	    input_to("step8", INPUT_PROMPT, "Geruch: "); 
	    return;
        }
        new_vitem[V_SMELL] = smell;
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
       "Gib nun das Gefühl des Details ein (maximal 200 Zeichen)\n");
    input_to("step9", INPUT_PROMPT, "Gefühl: "); 
}


void step9(string feel)
{
    if (feel=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ok, du brichst ab.\n"); 
	return;
    }
    if (!feel||feel==""||feel==" ") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Kein Gefühl gewählt, Auch gut.\n");
    } else {
        feel=convertstr(feel);
        if(strlen(feel) > 210) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Mehr als 200 Zeichen sind nicht erlaubt. Versuchs nochmal.\n");
	    input_to("step9", INPUT_PROMPT, "Gefühl: "); 
	    return;
        }
        new_vitem [V_FEEL] = feel;
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
       "Jetzt der Lese - Text (max 200 Zeichen)\n");
    input_to("step10", INPUT_PROMPT, "Lesen: "); 
}


void step10(string read)
{
    if (read=="~q") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Ok, du brichst ab.\n"); 
	return;
    }
    if (!read||read==""||read==" ") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
           "Kein Lese-Text gewählt, Auch gut.\n");
    } else {
        read=convertstr(read);
        if(strlen(read) > 210) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Mehr als 200 Zeichen sind nicht erlaubt. Versuchs nochmal.\n");
	    input_to("step10", INPUT_PROMPT, "Lesen: "); 
	    return;
        }
        new_vitem [V_READ] = read;
    }
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
       "Zuletzt das Aussehen des Details (max 500 Zeichen)\n");
    input_to("step11", INPUT_PROMPT, "Aussehen: "); 
}


void step11(string long)
{
    if (!long||long==""||long==" ") {
        this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	   "Kein Aussehen eingegeben, auch gut.\n"); 
    } else {
        if (long=="~q") {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
	       "Ok, du brichst ab.\n"); 
	    return;
        }
        long = convertstr (long);
        if(strlen(long) > 510) {
            this_player()->send_message_to(this_player(),MT_NOTIFY,MA_UNKNOWN,
               "Mehr als 500 Zeichen sind nicht erlaubt. Versuchs nochmal.\n"); 
	    input_to("step11", INPUT_PROMPT, "Aussehen: ");
	    return;
        }
        new_vitem[V_LONG] = long;
    }
    this_player()->add_v_item(new_vitem);
    if (!vitems) vitems = ({});
    vitems += ({new_vitem});
    sys_log ("HLP_VITEMS",
        wrap (this_player()->query_real_name()+": "+mixed2str(new_vitem)));
    this_player()->send_message(MT_LOOK,MA_USE,
        wrap (Der(this_player())+" wirft "+seinen()+
        " hoch in die Luft und wartet, bis "+er()+" wieder herunterschwebt."));
    this_player()->send_message_to(this_player(),MT_NOTIFY,MA_CRAFT,
       "Fertig. Du hast es geschafft, herzlichen Glückwunsch!\n");
}

