// This file is part of UNItopia mudlib.
// -------------------------------------------------------------------
// File:        /room/bank/test_factory.c
// Description: test factory fuer ein paar Mudlib objekte als Beispiel.
// Author:      Myonara (30.12.2015)
// Modified by:
//  Myonara 03.Sep.2016  Rewrite fuer mudlib-Objekte only...

#include <move.h>
#include <properties.h>
#include <stats.h>

string precheck_conservation(object ob,mapping check_attributes)
{
    if (!objectp(ob)) return "Unbekanntes Objekt!";
    switch(ob->query(P_CONSERVATION,P_CONSERVATION_IDENTIFIER))
    {
    case "ROOT:FACKEL": return ob->query_fuel()<=0
        ?"Die Fackel hat ihr Lebensende erreicht.":0;
    case "ROOT:MESSER": return (ob->query_broken() || ob->query_life()<=0)
        ? "Zerbrochene Messer werden nicht eingelagert.":0;
    case "ROOT:SCHATZ": return 0;
    default: return "Unbekanntes Objekt.";
    }
}

mixed get_conservation_data(object ob)
{
    if (!objectp(ob)) return 0;
    switch(ob->query(P_CONSERVATION,P_CONSERVATION_IDENTIFIER))
    {
    case "ROOT:FACKEL": return ob->query_fuel();
    case "ROOT:MESSER": return ob->query_life();
    case "ROOT:SCHATZ": return 1;
    default: return 0;
    }
}

varargs object get_conservation_object(string identifier,mixed data)
{
    object ob;
    int life;
    switch (identifier)
    {
    case "ROOT:FACKEL":
        ob = clone_object("/obj/fackel");
        if (intp(data) && data > 0 && data < ob->query_fuel())
        {
            ob->add_fuel(data-ob->query_fuel());
        }
        break;
    case "ROOT:MESSER":
        life = (intp(data) && data > 0) ? ({int})data : 100;
        ob = clone_object("/obj/nahkampf_waffe");
        ob->set_id("messer");
        ob->set_value(35);
        ob->set_name("messer");
        ob->set_long("Ein scharfes Messer. "
                  "Als reines Essutensil geht das nicht mehr durch. "
                  "Es besteht aus Metall.");
        ob->set_gender("saechlich");
        ob->set_material("metall");
        ob->set_weight(2);
        ob->set_skill_path(({ "skill", "offensiv", "scharf", "messer" }));
        ob->set_used_stats(({ STAT_STR, STAT_DEX, STAT_DEX, STAT_INT }));
        ob->set_damage(2,7);
        ob->set_max_life(100);
        ob->set_life(life);
        break;
    case "ROOT:SCHATZ":
        ob = clone_object("/obj/schatz");
        ob->set_value(2000);
        ob->add(P_CONSERVATION,P_CONSERVATION_TROPHEY,1);
        ob->add(P_CONSERVATION,P_CONSERVATION_ITEM_TARIFF,1.0);
        break;
    default: return 0;
    }
    ob->add(P_CONSERVATION,P_CONSERVATION_FACTORY,__FILE__);
    ob->add(P_CONSERVATION,P_CONSERVATION_IDENTIFIER, identifier);
    ob->clear_initial_conservation_data();
    return ob;
}

float query_conservation_item_rent(object ob)
{
    if (!objectp(ob)) return 1.1;
    switch(ob->query(P_CONSERVATION,P_CONSERVATION_IDENTIFIER))
    {
    case "ROOT:SCHATZ": return 1.0;// Sonderfall Trophey...
    default: break;
    }
    return to_float(ob->query_value())*0.05;// Diese Factory vergibt 5%
}

// Gute Idee, die Factory immer im Speicher zu halten...
void prepare_renewal() {}
void abort_renewal() {}
void finish_renewal(object neu) {}
