// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/room/kirche/glocken.c
// Description:	
// Author:	

#ifdef UNItopia
#include "/d/Vaniorh/sys/vaniorh_exports.h"
#endif

inherit "/i/room";

#include <message.h>

#define NEUER_SAKROTE "/room/kirche/npc/sakrote"

string *listeners =
({
   "/room/kirche/glocken",
   "/room/kirche/uhr",
   "/room/kirche/treppe3",
   "/room/kirche/treppe2",
   "/room/kirche/treppe1",
   "/room/kirche/unten",
   "/room/church",
   "/room/kirche/gewoelbe"
#ifdef UNItopia
   ,K_PLATZ_1,
   K_PLATZ_2,
   K_PLATZ_3,
   K_PLATZ_4
#endif
});

int *modi = ({ 0, 1, 2, 2, 2, 2, 3, 3, 4, 4, 4, 4 });

string *intros =
({
   "Dir fällt fast das Ohr ab, als direkt neben Dir die Glocken ertönen:\n",
   "Direkt über Dir beginnt der Glockenstuhl zu beben:\n",
   "Der Turm fängt unter einem Glockenschlag an zu beben:\n",
   "Weit über Dir hörst Du die Glocken im Turm erklingen:\n",
   "Oben im Kirchturm setzen sich die Glocken in Bewegung:\n",
});

void glockenschlag(string str)
{
   int i;

   for(i = 0; i < sizeof(listeners); i++)
      touch(listeners[i])->send_message(MT_NOISE,MA_UNKNOWN,
	      intros[modi[i]]+str);
}

void angelus()
{
   object sakrote;
   int hole_ihn;

   touch("/room/kirche/uhr");
#ifndef NEUER_SAKROTE
   if(sakrote = find_living("sakrote"))
   {
      if(hole_ihn = !present(sakrote))
         sakrote->do_command("hoch");
#else
   if (sakrote = (find_object(NEUER_SAKROTE)||touch(NEUER_SAKROTE)))
   {
      if(hole_ihn = !present(sakrote))
         sakrote->zu_den_glocken();
#endif
      sakrote->send_message(MT_NOISE,MA_USE,
	      "Sakrote läutet im fliegenden Wechsel alle Glocken!\n");
      glockenschlag("Berta, Konrad und Lutzie erzeugen "
		    "im Chor das Angelusläuten!\n");
      if(hole_ihn)
         sakrote->do_command("runter");
   }
}

void create()
{
   add_type("kunstlicht", 1);
   set_own_light(1);
   add_type("landeplatz","balkon");
   set_short("Im Glockenstuhl");
   set_long("Du befindest dich auf einer kleinen hölzernen Galerie, "
	    "die ringsum läuft. "
	    "In der Mitte hängen drei große schwere Glocken, um diese "
	    "herum verteilt noch ein paar kleinere. Die drei großen "
	    "tragen die Namen 'Dicke Berta', 'Schwarzer Konrad' und "
	    "'Lutzie von Dur-Scharrukin'. Die kleinen sind unbeschriftet. "
	    "An jeder Glocke ist ein Seil befestigt, mit dem man die "
	    "jeweilige Glocke läuten kann. "
	    "Nach unten führt eine hölzerne Stiege, die etwas baufällig "
	    "aussieht. Unterhalb der Galerie siehst Du das große Uhrwerk "
	    "der Kirchenuhr.");
   add_v_item(([
      "name": "glocken",
      "gender": "weiblich",
      "plural": 1,
      "long": "Die großen Glocken hörst Du regelmäßig in Tadmor, "
	      "die kleineren werden nur zu besonderen Anlässen "
	      "geläutet. Besonders auffällig sind die Glocken "
	      "Berta, Konrad und Lutzie."]));
   add_v_item(([
      "name": "konrad",
      "gender": "maennlich",
      "eigen" : 1,
      "id" : ({ "konrad", "glocke" }),
      "adjektiv" : ({ "schwarz" }),
      "long" :
	 "Der schwarze Konrad ist die größte Glocke hier im Glockenstuhl, "
	 "sie ist wohl auf Grund der schwarzen Lackierung zu ihrem Namen "
	 "gekommen. Allein 'Konrad' würde mehrere Zentner auf die Waage "
	 "bringen, so ganz klar, wie er hier auf den Turm gekommen ist, "
	 "ist es Dir nicht." ]));
   add_v_item(([
      "name" : "berta",
      "gender" : "weiblich",
      "eigen" : 1,
      "id" : ({ "berta", "glocke" }),
      "adjektiv" :({ "dick" }),
      "eigen" : 1,
      "long": "Die dicke Berta ist ein wenig kleiner als der schwarze Konrad, "
	      "und damit hat sie auch einen helleren Ton."]));
   add_v_item(([
      "name": "lutzie",
      "gender": "weiblich",
      "eigen" :1 ,
      "id" : ({ "lutzie", "glocke" }),
      "adjektiv" :({ "silbern" }),
      "long": "Die Lutzie ist die kleinste unter den großen Tadmorer "
	      "Kirchenglocken. "
	      "Sie hat einen wunderschönen silbernen Glanz und den "
	      "schönsten Klang "
	      "von allen Glocken hier im Turm."]));
   add_v_item(([
      "name" : "seile",
      "gender": "saechlich",
      "plural": 1,
      "id":({"seil", "seile"}),
      "look_msg": "$Der() bewundert die starken Hanfseile an den Glocken",
      "long": "Starke Hanfseile, die an jeder der Glocken hängen. "
              "Mit ihrer Hilfe kann man jede Glocke einzeln läuten!"]));
   add_v_item(([
      "name":"uhrwerk",
      "gender":"saechlich",
      "id":({"uhrwerk","uhr","werk","turmuhr","kirchturmuhr",
         "wirrwarr","zahnräder","gewichte"}),
      "long":"Das reichlich mittelalterlich anmutende Uhrwerk ist ein "
         "völlig unverständliches Wirrwarr aus Zahnrädern, Gewichten "
	 "und Metallteilen, die sich in ständiger Bewegung befinden, manche "
	 "schneller, manche langsamer.",
      "noise":"Tick, Tack, Tick, Tack, (usw, usf)",
      "smell":"Du riechst jahrzehntelange Ablagerungen von Staub und "
    	      "Schmieröl.",
      "feel": "Finger, Hände oder andere Körperteile zwischen große, sich "
              "bewegende Zahnräder zu stecken ist meist keine gute Idee. "
	      "Der Überlebenswille Deiner Gliedmaßen hindert Dich daran.",
      "feel_msg": "$Der(OBJ_TP) streckt seine Hand kurz nach dem Uhrwerk aus, "
                  "überlegt es sich dann aber anders.",
   ]));

   set_exits( ({ "/room/kirche/uhr" }), ({ "runter" }) );
}

void init()
{
   add_action("laeute", "läute");
   add_action("ziehe", "ziehe", -4);
}

int laeute(string str)
{
   mapping ob;

   if(!here(str, "glocke", &ob))
   {
      notify_fail("Läute was?\n");
      return 0;
   }
   write("Du hängst Dich an ein Seil und läutest mit Mühe "+den(ob)+".\n");
   say(Der(this_player())+" hängt sich an ein Seil und läutet mit Mühe "+
       den(ob)+".\n");
   switch(ob["name"])
   {
      case "berta" :
         glockenschlag("Die dicke Berta lockt mit ihrem vollen Ton "
                       "die Gläubigen in die Kirche!\n");
	 break;
      case "konrad" :
         glockenschlag("Der schwarze Konrad ruft befehlend zum Gebet!\n");
         break;
      case "lutzie" :
         glockenschlag("Ein sanfter, heller Klang erinnert Dich "+
                       "an Deinen Glauben.\n");
   }
   this_player()->set_handeln();
   return 1;
}

int ziehe(string str)
{
   if(!str)
   {
      notify_fail("Ziehe woran?\n");
      return 0;
   }
   if(strstr(str, "seil") >= 0)
   {
      write("Um die Sache zu vereinfachen... "
            "läute einfach eine der Glocken!\n");
      return 1;
   }
   if(strstr(str, "glocke") >= 0)
   {
      write(wrap("An die Glocken kommst Du von hier gar nicht direkt ran. "
            "Versuch's mal mit den Seilen."));
      return 1;
   }
   notify_fail("Ziehe woran?\n");
}
