// This file is part of UNItopia Mudlib.
// -----------------------------------------------------------------------
//  Datei:  /room/rathaus/aufderwendeltreppe.c
//  Autor:  Myonara 14.Okt.2014 
// -----------------------------------------------------------------------
// Beschreibung: Der Zugang zum Versammlungsraum 
//               fuer Pantheonstreffen mit Spielern.
// -----------------------------------------------------------------------

inherit "/i/room.c";

#include <level.h>
#include <message.h>
#include <misc.h>
#include <move.h>
#include <room_types.h>

private mapping mleser = ([ ]);

string lies_schild(string parse_rest, string str,
                            mapping vitem, object leser)
{
   if (!playerp(leser))
       return wrap("Das Schild ist für dich unleserlich und trotzdem "
           "macht es Dir deutlich, dass Du nicht weiterdarfst.");
   mleser[RN(leser)] = 1;
   return wrap(
"Bitte in der goldenen Wolke bei der Versammlung auf unnötigen Scroll "
"verzichten. Bitte respektvoll miteinander diskutieren. "
"Für scrollgeplagte Spieler sei \"einst kurier aus\" erwähnt.");
}

int filter_hoch(object who)
{
    if (!playerp(who) || !member(mleser,RN(who)) )
    {
    	who->send_message_to(who, MT_NOTIFY, MA_MOVE, wrap(
    	    "Lies zuerst das Hinweisschild, dann darfst Du weiter."));
    	return 1;
    }
    return 0;
}

void create()
{
    "*"::create();

    set_short("Auf der goldenen Wendeltreppe");
    set_long("Du befindest dich eine goldenen Wendeltreppe, welche "
        "hinauf zur goldenen Wolke und hinab zur Rathaustreppe führt. "
        "Ein wichtiges Hinweisschild ist an der Wendeltreppe befestigt.");

    add_type(RT_GRABEN_VERBOTEN, 1);
    add_type(RT_KUNSTLICHT, 1);
    add_type(RT_KEIN_VERBRAUCH,1);
    add_type(RT_KEIN_KOMPASS, 1);
    add_type(RT_FLUG_LANDEPLATZ, "/room/rathaus/treppe");
    add_type(RT_STARTRAUM, "/room/rathaus/treppe");
    add_type(RT_SPERRGEBIET, 1);
    L_SET(L_DRINNEN|L_HAUS|L_SIEDLUNG);
    set_own_light(1);
    add_v_item( ([
            "name" : "hinweisschild",
            "id" : ({ "hinweisschild","schild" }),
            "gender" : "saechlich",
            "long" : "Das Hinweisschild kann man lesen.",
            "look_msg" : "",
            "read" : #'lies_schild,
            "read_msg" : "",
            ]) );
    add_exit("wolke","hoch");
    add_exit("/room/rathaus/treppe","runter");
}



void abort_renewal() {}  // TODO rescue logic...
void finish_renewal(object neu) {}
void prepare_renewal() {}