// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:        /room/rathaus/div/inschriften.c
// Description: Spieleinschriften
// Author:      Croft
// Modified by: Croft (24.06.2000) durchsuchbar gemacht

inherit "/i/object/buch";

#include <game.h>
#include <invis.h>

int size;

void update_size(int nr) {
    size = nr;
    set_max_page(size);
    set_long("Es sind genau "+size+" Inschriften.");
}


void create() {
    mixed obs;

    ::create();
    set_id(({"inschriften" }));
    set_name("inschriften");
    set_gender("weiblich");
    set_plural(1);
    set_material("stein");
    set_weight(1);
    set_no_store(1);
    set_no_move(1);
    set_invis(V_NOLIST);

    set_page_mode("page");
    set_open_close(0);
    set_searchable(1);
    set_seiten_desc(([
              "name" : "Abschnitt",
            "gender" : "maennlich",
               "ids" : ({"inschrift", "absatz", "abschnitt"}),
          "no_pages" : "Alle Abschnitte wurden wohl von einem Vandalen unleserlich gemacht.",
        "which_page" : "Welchen Abschnitt willst du lesen?",
      "invalid_page" : "Diesen Abschnitt gibt es nicht.",
     "page_overflow" : "Soviele Abschnitte gibt es nicht.",
  "no_previous_page" : "Das ist schon der erste Abschnitt $des('book_ob).",
      "no_next_page" : "Das ist schon der letzte Abschnitt $des('book_ob).",
      "stop_reading" : "Du hörst auf $den('book_ob) zu studieren.",
  "stop_reading_msg" : "$Der(OBJ_TP) hört auf $den('book_ob) zu studieren.",
     "read_page_msg" : "$Der(OBJ_TP) liest sich eine Inschrift durch.",
         "search_beyond_end" : "Weiter kannst du nicht suchen, das ist bereits die "
                               "letzte Inschrift.",
  "search_reached_last_page" : "Du überfliegst die Inschriften ab Abschnitt 'page_nr "
                               "bis zum Letzten, findest aber nichts.",
"search_too_long_evaluation" : "Du überfliegst ab Inschrift 'page_nr einige "
                               "Abschnitte, findest aber nichts.",
        ]));

    obs = GAME_ROOM->query_game_values(G_ALL, G_OBJ);
    update_size(obs && sizeof(obs));
}


string query_page_inhalt(int nr) {
    mixed obs;

    obs = GAME_ROOM->query_game_values(G_ALL, G_OBJ);
    update_size(obs && sizeof(obs));
    if ((nr < 1) || (nr > size)) {
        return "Die Inschrift ist unleserlich.\n";
    } else {
        return obs[nr-1]->query_hint();
    }
}


// aus /room/rathaus/reinkarnation und modifiziert
varargs mapping query_v_item(mixed *path, int flag) {
    int nr;
    string long, name, read;
    string look_msg, read_msg;
    mixed obs;

    if (sizeof(path)!=1)
        return buch::query_v_item(path,flag);
    if (stringp(path[0]))
        name=path[0];
    else
        name=path[0]["name"];

    if (!name || name=="")
        return 0;

    nr=mappingp(path[0])?path[0]["nummer"]:0;

    if (!nr) {
        if (name == "inschriften" || name == "inschrift") {
            obs = GAME_ROOM->query_game_values(G_ALL, G_OBJ);
            update_size(obs && sizeof(obs));
            name="inschriften";
            if (size <= 0) {
                long="Irgendjemand scheint die Inschriften unleserlich "+
                     "gemacht zu haben.\n";
                read="Du kannst nichts lesen.\n";
            } else {
                long="Es sind genau "+size+" Inschriften.\n";
                read=obs[random(size)]->query_hint();
            }
            read_msg = Der(this_player())+" schaut sich die Inschriften an.";
        }
    } else {
        if (name == "inschrift") {
            obs = GAME_ROOM->query_game_values(G_ALL, G_OBJ);
            update_size(obs && sizeof(obs));
            if (nr <= size && nr > 0) {
                read_msg = Der(this_player())+" liest die "+nr+". Inschrift.";
                look_msg = Der(this_player())+" schaut sich die "+nr+
                        ". Inschrift an.";
                read=obs[nr-1]->query_hint();
                long="Die Schriftzeichen sind ziemlich altertümlich.\n";
            }
        }
    }
    if (long)
        return (["name":name,
		 "gender":"weiblich", // Inschriften
                 "plural": (name=="inschriften"),
                 "look_msg":look_msg,
                 "read_msg":read_msg,
                 "long":long,
                 "read":read,
		 "smell": "Du riechst das unbändige Verlangen in dir, "
			  "mal wieder etwas zu spielen.",
		 "feel":  "Die Inschriften fühlen sich recht interessant "
		          "an. Es lohnt sich bestimmt, sie mal zu lesen.",
		 "noise": "Nein, nein und nochmals nein: Inschriften werden "
		          "gelesen! Sie erzählen nichts von sich aus!",
               ]);
    else
        return buch::query_v_item(path,flag);
}
