// This file is part of UNItopia Mudlib.
// ---------------------------------------------------------------------
// File:        /room/rathaus/div/lager.c
// Description: Ein Lager aus Sofas, Sesseln usw.
//              ausschliesslich fuer das Forum
// Author:      Gnomi

#ifdef UNItopia
#include <invis.h>

// Weitere Vorschlaege sind sehr willkommen.

#define LAGER_ID "Lager"

#define PFLANZEN_ID "Pflanze"

// Liefert ein Moebelstueck nach wo.
// Wenn small>0 ist, dann werden soviele kleiner Stuecke
// ansonsten ein grosses oder mehrere kleine geliefert.
varargs void get_moebel(object wo, int small)
{
    object moebel;
    if(small)
    {
      while((small--)>0)
      {
        if(present(LAGER_ID+(small?small:""),wo)) continue;
	switch(random(7))
	{
	    case 0:	
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
                moebel->set_name("sessel");
		moebel->set_gender("maennlich");
    	        moebel->set_id(({"sessel"}));
    	        moebel->set_invis(V_NOLIST);
		moebel->set_no_move_reason(
	           "Der Sessel flüchtet panisch vor Dir.");
        	moebel->set_commands( ({
                             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
        	moebel->set_adjectiv(0);
	        moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(1);
		break;
	    case 1:	
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
                moebel->set_name("ledersessel");
		moebel->set_gender("maennlich");
    	        moebel->set_id(({"sessel","ledersessel"}));
	        moebel->set_long(
		   "Ein bequemer Ledersessel. Er zwingt Dich direkt, Dich "
		   "dahinzusetzen.");
    	        moebel->set_invis(V_NOLIST);
		moebel->set_no_move_reason(
	           "Der Sessel flüchtet panisch vor Dir.");
        	moebel->set_commands( ({
                             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
        	moebel->set_adjectiv(0);
	        moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(1);
		break;
	    case 2..4:
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/schaukelstuhl");
		moebel->set_invis(V_NOLIST);
		moebel->set_no_move_reason(
    		   "Der Schaukelstuhl ist am Boden festgenagelt.\n"
	           "Halt! Wie kann man dann damit schaukeln? Da ist irgendwas faul...");
                moebel->set_adjectiv(0);
		    break;
	    case 5..6:
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/ledercouch");
	        moebel->set_invis(V_NOLIST);
    	        moebel->set_adjectiv(0);
		break;
	}
	moebel->add_id(LAGER_ID+(small?small:""));
	moebel->move(wo);
      }
    }
    else
    {
	if(present(LAGER_ID,wo)) return;
        switch(random(8))
	{
	    case 0:
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
                moebel->set_name("sofaecke");
        	moebel->set_gender("weiblich");
		moebel->set_id(({"sofa","sofaecke","ecke","sessel"}));
		moebel->set_long(
	           "Ein Sofa und ein paar Sessel stehen zur Entspannung einladend "
	           "in dieser Ecke.");
		moebel->set_invis(V_NOLIST);
		moebel->set_feel("Die Polster der Möbel fühlen sich weich an.");
		moebel->set_no_move_reason(
                   "Du ziehst und zerrst und ziehst an den Möbeln, doch "
	           "sie wollen keinen Spalt nachgeben. Ob da wohl höhere "
	           "Mächte am Werk sind?");
        	moebel->set_commands( ({
                             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
        	moebel->set_sit_message("Du nimmst in der Sofaecke Platz.",
        	    "$Der(OBJ_TP) nimmt in der Sofaecke Platz.");
        	moebel->set_adjectiv(0);
	        moebel->set_long_text(
    		    " hast es Dir hier gemütlich gemacht.\n",
        	    " haben es sich in der Ecke gemütlich gemacht.\n",
		    " hat es sich dort gemütlich gemacht.\n");
	        moebel->set_fail_messages("In $dem(OBJ_TO) ist kein Platz mehr.");
		moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(20);
		break;
	    case 1:
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
    	        moebel->set_name("sofa");
		moebel->set_gender("saechlich");
	        moebel->set_adjektiv("richtig breit");
	        moebel->set_id(({"sofa"}));
	        moebel->set_long(
	           "Ein extrem breites Sofa ziert die Wand. Also das ist ein "
		   "breites Sofa, so ein breites Sofa hast Du nur selten gesehen. "
	           "Das Sofa ist wirklich sowas von breit. Du kannst Dir kaum "
		   "vorstellen, wieviel Leute auf so einem breiten Sofa "
	           "Platz haben können.");
		moebel->set_invis(V_NOLIST);
	        moebel->set_feel("Dieses sowas von breite Sofa ist auch so weich, "
		    "dass Du es Dir kaum bequemer vorstellen kannst. Es ist einfach ideal.");
	        moebel->set_no_move_reason(
		    "Dieses sowas von breite Sofa ist auch sowas von schwer, "
		    "das ist schon unglaublich.");
    	        moebel->set_commands( ({
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
            	             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
        	moebel->set_sit_message("Du nimmst auf diesem hübsch breiten Sofa Platz.",
        	    "$Der(OBJ_TP) nimmt auf dem Sofa Platz.");
    	        moebel->set_adjectiv(0);
		moebel->set_long_text(
        	    " sitzt darauf.\n",
        	    " sitzten darauf.\n",
		    " sitzt darauf.\n");
	        moebel->set_fail_messages("Auf $dem(OBJ_TO) ist unglaublicherweise kein Platz mehr.");
		moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(50);
		break;
	    case 2:	
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
                moebel->set_name("sessel");
		moebel->set_gender("maennlich");
    	        moebel->set_id(({"sessel"}));
	        moebel->set_long(
		   "10 Sessel stehen hier verteilt im Raum und schaffen so "
	           "eine besonders lockere Athmosphaere.");
    	        moebel->set_invis(V_NOLIST);
		moebel->set_feel("Weich und gemütlich. So richtig toll, "
		    "um sich dahineinzusetzen.");
		moebel->set_no_move_reason(
	           "Der Sessel flüchtet panisch vor Dir.");
        	moebel->set_commands( ({
                             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
    	        moebel->set_sit_message("Du nimmst in einem Sessel Platz.",
    		    "$Der(OBJ_TP) nimmt in einem Sessel Platz.");
        	moebel->set_adjectiv(0);
		moebel->set_long_text(
        	    " hast es Dir in einem Sessel bequem gemacht.\n",
        	    " haben es sich in je einem Sessel bequem gemacht.\n",
		    " hat es sich in einem Sessel bequem gemacht.\n");
		moebel->set_fail_messages("Es ist kein Sessel mehr frei.");
	        moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(10);
		break;
	    case 3:	
		moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
    	        moebel->set_name("ledersessel");
	        moebel->set_gender("maennlich");
		moebel->set_plural(1);
		moebel->set_id(({"sessel","ledersessel"}));
	        moebel->set_long(
		   "Du siehst hier 8 Ledersessel in einem Halbkreis oder eher "
	           "Halbellipse, nein, es ist viel mehr eine halbkreisähnliche "
		   "Kurve. Auf jeden Fall kann man sich hervorragend in so "
	           "einen Sessel hineinsetzen.");
		moebel->set_invis(V_NOLIST);
	        moebel->set_feel("Hmm. Leder.");
	        moebel->set_no_move_reason(
	           "Kurz bevor Du zupacken willst, sagt Dir Dein Gewissen, "
		   "dass die Ledersessel hierher viel besser passen...");
    	        moebel->set_commands( ({
                             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
        	moebel->set_sit_message("Du nimmst in einem Ledersessel Platz.",
        	    "$Der(OBJ_TP) nimmt in einem Ledersessel Platz.");
    	        moebel->set_adjectiv(0);
		moebel->set_long_text(
        	    " hast es Dir in einem der Ledersessel bequem gemacht.\n",
        	    " haben es sich in je einem der Ledersessel bequem gemacht.\n",
		    " hat es sich in einem Ledersessel bequem gemacht.\n");
	        moebel->set_fail_messages("Du findest keinen freien Ledersessel.");
		moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(8);
		break;
	    case 4:	
	        moebel = clone_object("/p/Item/Moebel/Sessel/obj/sessel");
        	moebel->set_name("teppich");
    	        moebel->set_gender("maennlich");
		moebel->set_id(({"teppich","boden"}));
	        moebel->set_long(
	           "Ein besonders flauschiger Fußboden, der sofort dazu "
	    	   "einlädt, sich auf ihm niederzulassen.");
		moebel->set_invis(V_NOLIST);
	        moebel->set_feel("Schön weich. Er wurde auch mit Olympia, "
	    	    "dem Weichmacher der Götter, gewaschen.");
	        moebel->set_no_move_reason(
	    	    "Hmm. Nimm lieber erst die Decke und die Wände mit, bevor "
		    "Du den Boden hier rausholst.");
    	        moebel->set_commands( ({
                             ({"sitz","auf"}), ({"setze","auf"}),({"setz","auf"}),
                             ({"sitz","in"}), ({"setze","in"}), ({"setz","in"}), 
			     ({"knie","auf"}), ({"kniee","auf"})
                          }),
                          ({
                             ({"steh","auf"}), ({"stehe","auf"})
                          }) );
        	moebel->set_sit_message("Du lässt Dich auf den weichen Boden fallen.",
        	    "$Der(OBJ_TP) lässt sich auf den weichen Boden fallen.");
    	        moebel->set_adjectiv(0);
		moebel->set_long_text(
        	    " liegst hier rum.\n",
        	    " liegen darauf.\n",
		    " liegt darauf.\n");
	        moebel->set_fail_messages("Der Raum ist bereits überfüllt.");
		moebel->set_heal_data(0,0,0);
	        moebel->set_max_persons(100);
		break;
	    case 5..6:
		get_moebel(wo,3);
		return;
	    case 7:
		get_moebel(wo,2);
		return;
	}
	moebel->add_id(LAGER_ID);
	moebel->move(wo);
    }
}

// Liefert eine oder mehrere Pflanzen nach wo.
// Wenn small>0 ist, dann werden soviele Pflanzen nach wo geliefert,
// andernfalls nur eines.

varargs void get_pflanze (object wo, int count)
{
    if (count < 1) count = 1;
    
    object pflanze;
    while((count--)>0) {
        if(present(PFLANZEN_ID+count,wo)) continue;
	switch(random(3))
	{
	    case 0:	
                pflanze = clone_object ("/obj/schatz");
                pflanze->set_name("riesenkaktus");
		pflanze->set_gender("maennlich");
    	        pflanze->set_id(({"kaktus","riesenkaktus"}));
		pflanze->set_no_move_reason(
	           "Du würdest dich nur bestialisch stechen und dann "
	           "schreiend davonrennen. Nene, lass mal.");
	        pflanze->set_long("In einem großen Pflanzenkübel steht "
	            "ein großer, grüner, mächtiger Kaktus mit drei "
	            "grünen Armen vor Dir und reckt seine Arme "
	            "nach oben, dahin, wo eigentlich die Sonne sein müsste.");
	        pflanze->set_smell("Du würdest gerne an dem Kaktus riechen, "
	            "doch, bevor er Dir Dein Gesicht zerkratzt und Dir die "
	            "Augen aussticht überlegst Du es Dir doch noch einmal "
	            "anders.");
	        pflanze->set_feel("Es tut ganz schön mächtig weh, als "
	            "Du mit Deinen Händen, die sofort tierisch zu bluten "
	            "beginnen, über den Kaktus streichst, um ihn zu "
	            "befühlen. Irgendwie sind diese Stacheln ziemlich im "
	            "Weg, außer Schmerzen fühlst Du irgendwie nichts.");
	        pflanze->add_v_item (([
	            "name":"stacheln",
	            "gender":"maennlich",
	            "plural":1,
	            "id":({"stachel","stacheln"}),
	            "long":"Fürchterlich dünne, spitze Stacheln wie "
	                "Nadeln bewachen den Kaktus, damit ihm nichts "
	                "und niemand zu nahe kommt.",
	            "smell":"Als Du an den Stacheln riechst, steigt "
	                "Dir der Geruch Deines Blutes in die Nase.",
	            "noise":"Du hörst rechtzeitig auf Deine innere "
	                "Stimme, die Dir laut zuruft, bloß nicht "
	                "an dem Kaktus zu horchen.",
	            "feel":"Es fühlt sich mächtig schmerzhaft an, als "
                         "sich die spitzen Stacheln des Kaktus tief in deine "
                         "Hand bohren. Es fühlt sich viel besser an, als Du "
                         "deine Hand wieder zurückziehst; warum schreist "
                         "du so?"
                ]));
                pflanze->add_vitem (([
                    "name":"pflanzenkübel",
                    "gender":"mannlich",
                    "id":({"pflanzenkübel","kübel"}),
                    "adjektiv":({"hölzern"}),
                    "long":"Ein kräftiger, hölzerner Pflanzenkübel steht hier rum "
                        "und passt auf seine Pflanze auf.",
                    "take":"Der ist viel viel zu schwer.",
                    "smell":"Du riechst an dem Kübel; der Geruch von Tannenholz "
                        "steigt in Deine Nase. Oder ist das ein Käfer?"
                ]));
                break;

	    case 1:
                pflanze = clone_object ("/obj/schatz");
	        pflanze->set_name("zimmerpalme");
	        pflanze->set_gender("weiblich");
	        pflanze->set_id(({"palme","zimmerpalme"}));
	        pflanze->set_long("Breite, kräftige, wunderschön "
	            "dunkelgrüne Palmwedel recken "
	            "sich nach oben zur Zimmerdecke hinauf und wedeln "
	            "im leisen Windzug, der durchs Rathaus windet, "
	            "sanft hin und her.");
	        pflanze->set_smell("Riecht nach frischem Meer, weiter "
	            "Welt, Sandstrand und Kokosmilch.");
	        pflanze->set_noise("Rausch rausch rausch.");
	        pflanze->set_feel("Die Palmwedel fühlen sich recht "
	            "kräftig und hart an, du spürst ein leichtes "
	            "Vibrieren, was durch sie hindurch vibriert.");
                pflanze->add_vitem (([
                    "name":"pflanzenkübel",
                    "gender":"mannlich",
                    "id":({"pflanzenkübel","kübel"}),
                    "adjektiv":({"hölzern"}),
                    "long":"Ein kräftiger, hölzerner Pflanzenkübel steht hier rum "
                        "und passt auf seine Pflanze auf.",
                    "take":"Der ist viel viel zu schwer.",
                    "smell":"Du riechst an dem Kübel; der Geruch von Tannenholz "
                        "steigt in Deine Nase. Oder ist das ein Käfer?"
                ]));
	        break;
	    case 2:
	        pflanze = clone_object ("../obj/drachenbaum");
	        break;
	}
	pflanze->add_id(({"pflanze",PFLANZEN_ID+count}));
	pflanze->move(wo);
    }
}

void create()
{
    seteuid(getuid());
}
#endif
