// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:	/room/rathaus/i/new_tip.c
// Description: Alles, was man braucht, um einen neuen Tip
//              zu erstellen
//              Um einen neuen Tip zu erstellen: new_tip aufrufen.
//              Wurde der neue Tip (erfolgreich) erstellt, wird
//              new_tip_done aufgerufen.
// Author:	Sissi (22.01.2000)

#include <level.h>
#include <more.h>
#include <browser.h>
#include <apps.h>
#include <input_to.h>

static void new_tip ()
{
    if (!this_player() || (this_player()!=this_interactive())) return;
    if (query_input_pending (this_player())
        || query_editing (this_player())) {
        write ("Jetzt geht das nicht. Eines nach dem anderen.\n");
        return;
    }
    write (wrap ("Gib bitte den Text für den Tip ein, Beenden des "
        "Tip-Textes mit Leereingabe, Abbruch mit ~q"));
    input_to ("tip_input", INPUT_PROMPT, "Tip: ", "", 0, "");
}

static void tip_input (string s, string tip, int mode, string for_whom)
{
    if ((mode && (!s || s=="")) || s=="~q") {
        write ("Abgebrochen.\n");
        return;
    }
    if (mode) {
        s = lower_case (s);
        if ((s == "j") || (s == "ja"))
            for_whom += ([1:"n",2:"s",3:"e",4:"g"])[mode];
        else if ((s != "n") && (s != "nein") && (s != "nö")) {
            input_to("tip_input", INPUT_PROMPT,
        	"ja oder nein, Abbruch mit Leereingabe: ",
		tip,mode,for_whom);
            return;
        }
    }
    else {
        if (s && s != "" && s != "." && s != "**") {
            if (!tip || tip=="") tip = space (s);
            else tip += " "+space(s);
            input_to("tip_input", INPUT_PROMPT, "Tip: ", tip, mode, for_whom);
            return;
        }
    }
    if (mode == 4) {
        if (for_whom == "") {
            write ("Ähm, ein Tip, der für niemanden geeignet ist?\n"
                "Na, das ist aber suboptimal. Probiers nochmal.\n");
            new_tip ();
            return;
        }
        if (!TIPS_MASTER->add_tip (tip, for_whom))
            write ("Da ist was schiefgelaufen. Wende Dich bitte an "
            "einen Admin.\n");
        else call_out ("new_tip_done",0);
    }
    else {
        input_to("tip_input", INPUT_PROMPT, 
    	    "Ist dieser Tip für "
            +([0:"Anfänger",1:"normale Spieler",2:"Engel",3:"Götter"])[mode]
            +" geeignet (ja/nein"
            +(!mode?"/Abbruch mit Leereingabe":"")
            +")? ", tip, mode+1, for_whom);
    }
}

