/* File: /d/Vaniorh/fizban/npc/tussnelda.c
   Autor: Fizban
   Datum: 14.05. 1996
   Bemerkung: Tussnelda, die Sekraeterin des Traegerkreises
              Sie verteilt Infos und die Vereinssatzung
*/
// 3.3.2008 sin aenderung parse_conversation
// 1.6.2008 Tiberian Umzug nach Root

inherit "/i/monster/monster";


#include <verein.h>
#include <stats.h>
#include <level.h>
#include <move.h>
#include <monster.h>

#define MAX_ANZAHL 5


object who;
int zaehler;


// Diese Funktionen sind nur zu Test- und Debuggingzwecken
// und sollten daher normalerweise NICHT verwendet werden.
void set_zaehler(int i) { zaehler=i; }
int query_zaehler() { return zaehler; }


void reset() {
    object ob;

    if(!ob=present("seele",TO)) {
        ob=clone_object("/obj/soul");
        ob->move(TO);
    }

    zaehler=MAX_ANZAHL;
    new_inv();
}


void create() {
    ::create();

    initialize("tussnelda",40);
    set_id(({"tussnelda","tuss","tussi","sekraeterin","frau"}));
    set_gender("weiblich");
    set_title(", die Vereinssekraeterin");

    set_one_stat(STAT_INT,20);
    set_align(10+random(50));

    set_macht_bei_rollen_mit(1);
    set_personal(1);

    give_hp(50+random(100));
    give_sp(10+random(60));

//    set_long("Tussnelda ist die Sekraeterin des Traegerkreises UNItopia. "+
//      "Sie ist nicht arg klug, aber dafuer umso blonder. Naja, der "+
//      "Vereinsvorstand setzt halt ganz besondere Prioritaeten.");

    set_long("Tussnelda ist die Sekretärin des Trägerkreises UNItopia. "+
        "Sie ist ein wenig schusselig, dafür herzensgut. Und sie kennt "+
        "alle Marotten der Vorstände und Beiräte - eine Grundvoraussetzung "+
        "für dieses Amt.");

    set_mmsg_in("Tussnelda betritt lächelnd den Raum");
    set_mmsg_out("Tussnelda verlässt eiligst den Raum");

    set_only_parse_players(1);
    set_parse_conversation(TO,({
        "gruss: hallo||hi||hiho||[gut] && tag||[gut] && morgen||[gut] && abend"+
        "||moin||gruess gott||wie && [geht]",PARSE_SAY,
        "knuddeln: knuddelt && dich||umarmt && dich||haetschelt && dich",
        "kuessen: küsst && dich||gibt && dir && kuss||streichelt && dich",
        "winken: winkt && dir||winkt && zu",
        "treten: tritt && dich||tritt && dir||zwickt && dich||zwickt && dir||"+
        "gibt && dir && [ohrfeig]||schlaegt && dich||trifft && dich",
        "heisse: heisse||mein name ist||werde && genannt",PARSE_SAY,
        "info: will && [satzung]||[moecht] && [satzung]||haette && [gern] && [satzung]",PARSE_SAY,
        "gegeben: gibt && dir||schenkt && dir||reicht && dir",
        "geht_weg: entfernt sich||verschwindet||geht && nach||geht && weg",
        "beirat: [beirat] || [admin] || [fuff]",PARSE_SAY,
        "gruender: [gruend] || [mitglied]",PARSE_SAY,
        "vorstand: [vorstand] || [chef]",PARSE_SAY,
        "weg: geh && weg && [tuss]|| sagt && hau && ab && [tuss]",PARSE_SAY}));

    reset();
}


void init() {
    ::init();
    reset();

    if(!TP || !playerp(TP) ||
       TP->query_invis() ||
       (find_call_out("begrüßung")>0))
        return;

    call_out("begruessung",1,TP);
}


void geht_weg() {
    if(!TP || !playerp(TP) || TP->query_invis() || random(2))
        return;

    do_command("sage Auf Wiedersehen, "+TP->query_cap_name()+"!");
}


void begruessung() {
    if(!TP || !present(TP,HIER) || TP->query_invis())
        return;

    if(CHEF(TP)) {
        do_command("sage Einen wunderschönen Tag, "+TP->query_cap_name()+"!");
        do_command("sage Es liegt eine ganze Menge Arbeit für Sie in Ihrem Büro.");
        return;
    }

    if(query_in_fight()) {
        do_command("sage Ha! Nimm das!");
        do_command("mache holt zu einem mächtigen Schlag aus.");
        return;
    }

    do_command("sage Guten Tag!");
    do_command("frage Was kann ich für Sie tun, "+TP->query_cap_name());
}


void gruss() {
    if(!TP || !present(TP,HIER) || TP->query_invis())
        return;

    if(CHEF(TP)) {
        do_command("sage Guten Tag, "+TP->query_cap_name()+"!");
        do_command("frage Haben Sie eine Aufgabe für mich");
        return;
    }

    if(query_in_fight()) {
        do_command("frage Was willst Du denn");
        do_command("sage Störe mich nicht beim Kämpfen!");
        return;
    }

    do_command("sage Hallo, ich heiße Tussnelda. Ich bin hier die Sekraeterin.");
    exec_command("lächle ",TP," freundlich");
    do_command("frage Wollen Sie vielleicht eine Vereinssatzung, "+TP->query_cap_name());
}


void knuddeln() {
    if(!TP || !present(TP,HIER) || TP->query_invis())
        return;

    if(query_in_fight()) {
        do_command("sage Aaaah! Danke! Du bist mein letzte Rettung, "
          +TP->query_cap_name()+"!");
        do_command("sage Bitte! Hilfe mir doch!");
        return;
    }

    if(CHEF(TP)) {
        do_command("sage Oh, "+TP->query_cap_name()+", das ist aber lieb!");
        exec_command("knuddle",TP);
        do_command("denke Was für ein toller Chef! Und immer so nett zu mir.");
        return;
    }

    if((TP->query_gender())=="weiblich") {
        do_command("sage Ach, das tut gut, eine Freundin zu haben!");
        exec_command("knuddle",TP);
        return;
    }

    do_command("frage Was fällt Dir ein, Du Widerling!?!");
    exec_command("ohrfeige",TP);
}


void kuessen() {
    if(!TP || !present(TP,HIER) || TP->query_invis())
        return;

    if(query_in_fight()) {
        do_command("sage Juhu! Die Rettung! Vielen Dank, "+TP->query_cap_name()+"!");
        do_command("sage Bitte hilf mir armen schwachen Frau!");
        return;
    }

    if(CHEF(TP)) {
        do_command("sage Huch, "+TP->query_cap_name()+", nicht so stürmisch!");
        exec_command("knutsche",TP);
        do_command("denke Was man für Vorgesetzte nicht alles tut!?!");
        return;
    }

    do_command("frage Was soll denn das, "+TP->query_cap_name()+"!?!");
    exec_command("ohrfeige",TP);
}


void winken() {
    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    if(CHEF(TP)) {
        do_command("sage Auf Wiedersehen, "+TP->query_cap_name()+"!");
        do_command("sage Falls eine Nachricht für Sie eintrifft, "
                   "mache ich eine Notiz.");
        return;
    }

    do_command("sage Tschüss, "+TP->query_cap_name()+"!");
    exec_command("winke",TP);
}


void treten() {
    if(!TP || !present(TP,HIER) || TP->query_invis())
        return;

    if(CHEF(TP)) {
        do_command("sage AUA!");
        do_command("frage Warum tun Sie das? "
                   "Mache ich meine Arbeit nicht gut genug");
        return;
    }

    if(query_in_fight()) {
        do_command("sage Das war aber wirklich gemein, "+TP->query_cap_name()+"!");
        do_command("sage Wenn das der Vereinsvorstand erfährt ...");
        exec_command("spucke",TP);
        return;
    }

    do_command("frage Warum tun Sie das? Was hab ich Ihnen getan");
    exec_command("starre",TP);
}


void heisse() {
    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    if(CHEF(TP)) {
        do_command("sage Wir kennen uns doch? Sie brauchen sich nicht vorzustellen.");
        do_command("lächle verwirrt");
        return;
    }

    do_command("sage Schön Sie kennenzulernen, "+TP->query_cap_name()+".");
    do_command("frage Ich bin Tussnelda, die Sekraeterin. Wollen Sie vielleicht eine Satzung?");
    exec_command("lächle",TP,"lieb");
}


void info() {
    object ob;

    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    if(ob=deep_present(SATZUNG_ID,TP)) {
        do_command("sage Sie haben doch schon "+einen(ob)+".");
        do_command("frage Reicht Ihnen das nicht, "+TP->query_cap_name());
        return;
    }

    if(ob=present(SATZUNG_ID,HIER)) {
        do_command("sage Hier liegt doch "+einen(ob)+" rum.");
        do_command("frage Wie waer's denn damit");
        return;
    }

    if(CHEF(TP)) {
        do_command("frage Wozu brauchen Sie denn eine Satzung, "+TP->query_cap_name());
        do_command("sage Naja, wie Sie wollen ...");
        do_command("mache wühlt in ihrem Schreibtisch rum.");
    }
    else {
        do_command("sage Ahja! Sehr schön. Einen Moment, bitte.");
        do_command("mache wühlt in ihrem Schreibtisch rum.");
    }

    who=TP;
    call_out("satzung",1);
}


void satzung() {
    object ob;

    if(!who || !playerp(who) || !present(who,HIER) || who->query_invis())
        return;

    if((zaehler>0) && (ob=clone_object(SATZUNG_OBJ)) && (MOVE_OK==(ob->move(who)))) {
        do_command("sage Aaah! Hier haben wir doch was ...");
        tell_object(who,wrap(Der(TO)+" gibt Dir "+einen(ob)+"."));
        tell_room(HIER,wrap(Der(TO)+" gibt "+dem(who)+" "+einen(ob)+"."),({who,TO}));
        zaehler--;
        return;
    }

    if(ob) ob->remove();
    do_command("seufz");
    do_command("sage Hmm ... ich kann leider grad keine Satzung mehr finden.");
    do_command("sage Versuchen Sie es doch bitte später nochmal.");

}


void gegeben() {
    int groesse, x;
    object gegenstand;
    object *inventory;

    // neue Ausruestung bestimmen
    inventory=new_inv();
    groesse=sizeof(inventory);

    // keine Ausruestung bekommen? Taeuschungsversuch mit 'mache'!
    if(!inventory || !groesse)
        return;

    tell_room(HIER,Der(TO)+" staunt überrascht: Was soll ich denn damit?\n");
    for(x=0;x<groesse;x++) {
        gegenstand=inventory[x];
        if(gegenstand->id(SATZUNG_ID)) {
            do_command("frage Wollen Sie die Satzung nicht mehr");
            do_command("sage Na gut, dann nehme ich sie halt wieder zurück.");
            tell_room(HIER,wrap(Der(TO)+" legt "+den(gegenstand)+" auf ihren Schreibtisch."));
            zaehler++;
            gegenstand->remove();
        }
        else {
            do_command("frage Was soll ich denn damit");
            do_command("lege "+gegenstand->query_name());
        }
    }
}


void beirat() {
    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    do_command("sage Äh ... wer im Beirat ist? Also ...");
    do_command("grübel");
    do_command("sage ... im Beirat sind momentan "+FUFFI_NAMEN+".");
}


void vorstand() {
    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    do_command("sage Hmmm .. Vorstand? Äh ... das war ...");
    do_command("mache denkt angestrengt nach.");
    do_command("sage Achja, im Vorstand sind zur Zeit "+CHEF_NAMEN+".");
}


void gruender() {
    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    do_command("sage Der Verein hat "+sizeof(GRUENDER)+" Gründungsmitglieder.");
    do_command("sage Es sind "+GRUENDER_NAMEN+".");
}


void weg() {
    if(!TP || !present(TP,HIER) || TP->query_invis() || query_in_fight())
        return;

    if(!CHEF(TP)) {
        do_command("sage SIE haben mir gar nichts zu befehlen, "
          +TP->query_cap_name()+"!");
        exec_command("knurre",TP);
        return;
    }

    do_command("schniefe");
    do_command("sage Warum schicken Sie mich denn weg?");
    do_command("sage Alle wollen mich los werden ...");
    call_out("weg2",0);
}


void weg2() {
    tell_room(HIER,wrap(Der(TO)+" geht weinend fort."));
    remove();
}
