// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:        /room/statue.c
// Description: Der Statuenraum
//              Falls aktiviert kommen hierher erstarrte und ausgeloggte
//              Spieler.
// Author:
//

inherit "/i/room";

#include <move.h>
#include <config.h>
#include <level.h>

#define DEBUG(x) if (find_player("freaky")) tell_object(find_player("freaky"),x)

int query_prevent_shadow(object ob)
{
    return 1;
}

void create()
{
    set_short("Statuen Raum");
    set_long("Hier hat niemand was zu suchen.\n"
    	"In diesem Raum stehen alle Spieler, die sich ausgeloggt haben.\n"
	"Wer an diesem Raum etwas rumpfuscht wird aus dem Pantheon verbannt.\n"
	);
    add_type("kunstlicht",1);
    add_type("kein_verbrauch",1);
    add_type("teleport_rein_verboten",1);
    set_own_light(1);
}

<int|string> let_not_in(mapping mv_infos)
{
    object who = mv_infos[MOVE_OBJECT];
    if (adminp(this_interactive()) && this_player() == this_interactive())
    {
        object po;

	po = previous_object(caller_stack_depth()-1);
	if (po && geteuid(this_interactive()) == geteuid(po))
	    return 0;
    }
    if (!playerp(who) ||
    	    query_living_name(who) != "STATUE "+who->query_real_name())
    	return 1;
}

<int|string> let_not_out(mapping mv_infos)
{
    object who = mv_infos[MOVE_OBJECT];
    if (adminp(this_interactive()) && this_player() == this_interactive())
    {
        object po;

	po = previous_object(caller_stack_depth()-1);
	if (po && geteuid(this_interactive()) == geteuid(po))
	    return 0;
    }
    if (!interactive(who))
	return 1;
}

static int do_logout(object player)
{
    object ob;

    if (interactive(player))
	return 2;

    while (ob = first_inventory(player))
    {
	ob->remove();
	if (ob)
	    destruct(ob);
    }
    player->do_only_save();
    player->remove();
    if (player)
	destruct(player);
    return 1;
}

#if STATUE_TIME > 0
void reset()
{
    object *player;
    int i, j;

    player = all_inventory();

    for (i = sizeof(player); i--; )
        if ((time() - player[i]->query_statue_room_time()) > STATUE_TIME)
	    call_out("do_logout",2*j++,player[i]);
}
#endif

int logout(object player)
{
    if (adminp(this_interactive()) && this_player() == this_interactive() &&
	    geteuid(this_interactive()) == geteuid(previous_object()))
    {
    	if (environment(player) != this_object())
	    return -2;
	return do_logout(player);
    }
    return -1;
}
