// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:        /room/wahlen/srurne.c
// Description: Urne fuer den Spielerrat
// Author:      

inherit "/i/object/urne";

#include <level.h>
#include <config.h>
#include <apps.h>
#include <input_to.h>

#pragma no_clone
// dont clone me!

void create()
{
   ::create();
   set_long(
      "Die Spielerrats - und Admin - Wahlurne. Hier können Admins und der Spielerrat abstimmen. "
      "Dies geht auch aus der Ferne mit dem Befehl 'srurne'.");
}

varargs static int may_vote(object who, string subject, mixed subject_data, string topic, mixed topic_data)
{
    return spielerratp(who) || (!subject_data && adminp(who));
}

static mixed may_add_subject (object who, string subject)
{
    return spielerratp(who) || adminp(who);
}

varargs static int may_read(object who, string subject, mixed subject_data, string topic, mixed topic_data)
{
    return spielerratp(who) || adminp(who);
}

varargs static int may_delete(object who, string subject, mixed subject_data, string topic, mixed topic_data)
{
    return spielerratp(who) || adminp(who);
}

static void do_add_subject(closure callback, object who, string subject)
{
    input_to(
	(:
	    if($1 && sizeof($1) && lower_case($1)[0]=='j')
		funcall($2, 1);
	    else
		funcall($2, 0);
	:), INPUT_PROMPT, "Abstimmung ohne Admins (Ja/Nein)? ", callback);
}
    
static string subject_info(object who, string subject, mixed subject_data)
{
    if(subject_data)
	return "\nDiese Abstimmung soll ohne Beteiligung der Admins stattfinden.\n\n";
}

varargs protected string voted_message(string *namen, string subject, mixed subject_data)
{
    if(subject_data)
    {
	if(sizeof(filter(namen,"is_spielerrat",SPIELERRAT))>=4)
		return "Es haben mindestens 4 Spielerräte gewählt.";
    }
    else
    {
	if(sizeof(filter(namen,"is_spielerrat",SPIELERRAT))>=4 &&
    	    sizeof(namen & ADMINS) >= 2)
		return "Es haben mindestens 4 Spielerräte und 2 Admins gewählt.";
    }
}
