// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:        /secure/dbus/news.c
// Description: RPC-Funktionen fuers Usenet
// Author:      Gnomi

#include <news.h>

static void news_importnews(string* gruppen, string autor, string subject, int date,
    string mid, string* refs, string text)
{
    INEWSD->importnews(gruppen, autor, subject, date, mid, refs, text);
}

static void news_cancelnews(string *gruppen, string autor, string mid)
{
    INEWSD->cancelnews(gruppen, autor, mid);
}

static string** news_get_newsgroups(string name)
{
    return INEWSD->get_newsgroups(name);
}

/* Aufrufe an externe Objekte */
void export_news(string newsgroup, string autor, string addr, string subject, int date, string mid, string* ref, string text)
{
    if(object_name(previous_object()) != INEWSD)
        return;

    dbus_call_method(function void(string errname, varargs mixed* args) {},
        "de.system.inn2", "/de/system/inn2", "de.unitopia.Inn2", "exportnews", "ssssxsass",
        newsgroup, autor, addr, subject, date, mid, ref || ({}), text);
}

void cancel_news(string mid)
{
    if(object_name(previous_object()) != INEWSD)
        return;

    dbus_call_method(function void(string errname, varargs mixed* args) {},
        "de.system.inn2", "/de/system/inn2", "de.unitopia.Inn2", "deletenews", "s", mid);
}