// This file is part of UNItopia Mudlib.
// ----------------------------------------------------------------
// File:        /secure/level_lister.c
// Description: Macht die Top-Spieler-Liste
// Author:      Garthan	(13.07.94)
// Modified by:	Freaky (08.07.95) Player-Log hierher verschoben
//				  Security-Check in new_enter
//              Sissi  (04.06.96) Raetsel - Top - Liste

#pragma no_inherit

#ifndef TestMUD

#include <level.h>
#include <config.h>
#include <quest.h>
#include <uids.h>
#include <time.h>
#include <interactive_info.h>
#define LEVEL_BASE           "/var/level_lister"
#define TOP_PLAYERS          "/var/TOP_PLAYERS"
#define TOP_HLPS             "/var/TOP_HLPS"
#define TOP_PLAYERS_QUESTS   "/var/TOP_PLAYERS_QUESTS"
#define TOP_HLPS_QUESTS      "/var/TOP_HLPS_QUESTS"
#define TOP_PLAYERS_GAMES    "/var/TOP_PLAYERS_GAMES"
#define TOP_HLPS_GAMES       "/var/TOP_HLPS_GAMES"

#define TOP_PLAYERS_QUESTS_SIZE	500
#define TOP_HLPS_QUESTS_SIZE 250
#define TOP_PLAYERS_GAMES_SIZE	500
#define TOP_HLPS_GAMES_SIZE 250

#ifdef UNItopia
#define PLAYER_LIST_DIR ("/var/adm/player_list/"+timearray(time())[TM_YEAR])
#define PLAYER_LIST	(sprintf("/PLAYER_LIST.%04d.%02d.%02d",timearray(time())[TM_YEAR],timearray(time())[TM_MON],timearray(time())[TM_MDAY]))
static mapping zweities = ([]);
static mapping ersties = ([]);
#endif

#define MIN_EXP 50000
#define MIN_QUEST 15
#define COUNT   20

mapping level_base = m_allocate(50,4);
static int count = COUNT;

void create()
{
   string file;
   restore_object(LEVEL_BASE);
#ifdef UNItopia
   file = read_file("/var/adm/SPIELZWEITIES");
   if(file)
      foreach(string line:explode(file,"\n"))
      {
         string *parts;
         line = space(line);
         if(line[0]=='#' || line=="")
	    continue;
	 parts = explode(lower_case(line)," ");
	 if(sizeof(parts)!=2)
	    continue;
	 if(zweities[parts[0]])
	    zweities[parts[0]]+=({parts[1]});
	 else
	    zweities[parts[0]]=({parts[1]});
	 ersties[parts[1]] = parts[0];
      }   
#endif
}

void save()
{
   save_object(LEVEL_BASE);
}

void prepare_renewal() {save();}
void abort_renewal() {}
void finish_renewal() {}

int remove()
{
   save();
   destruct(this_object());
   return 1;
}

int testp(mixed *part)
{
   return !testplayerp(part[0]);
}

int hlpfilter(mixed *part)
{
   return part[<1] == LVL_HLP;
}

int playerfilter(mixed *part)
{
   return part[<1] < LVL_HLP;
}

int sort_fun (mixed a, mixed b)
{
    if (a[1] == b[1]) return a[0] > b[0];
    return a[1] < b[1];
}

int sort_fun2 (mixed a, mixed b)
{
    if (a[1] == b[1])
        if (a[2] == b[2])
            return a[0] > b[0];
        else
            return a[2] < b[2];
    else
        return a[1] < b[1];
}

int sort_fun3 (mixed a, mixed b)
{
    if (a[2] == b[2])
        if (a[1] == b[1])
            return a[0] > b[0];
        else
            return a[1] < b[1];
    else
        return a[2] < b[2];
}

mixed *sort_base, *sort_base2, out_base;

private void stop_make_lists()
{
    while (remove_call_out("make_lists")!=-1);
    while (remove_call_out("make_lists2")!=-1);
    while (remove_call_out("make_lists3")!=-1);
    while (remove_call_out("make_lists4")!=-1);
    while (remove_call_out("make_lists5")!=-1);
    while (remove_call_out("make_lists6")!=-1);
    while (remove_call_out("make_lists6b")!=-1);
    while (remove_call_out("make_lists7")!=-1);
}

void make_lists()
{
   string *idxs;
   int i;

   stop_make_lists();
   sort_base = ({ });
   count = COUNT;

   save();

   rm(TOP_PLAYERS);
   rm(TOP_HLPS);

   for(i = sizeof(idxs = m_indices(level_base)); i--;)
      sort_base += ({({idxs[i], level_base[idxs[i]], level_base[idxs[i],1]})});
   sort_base = filter(sort_base, #'testp);

   call_out("make_lists2", 2);
}

void make_lists2()
{
   stop_make_lists();
   sort_base = sort_array(sort_base,#'sort_fun);
   call_out("make_lists3", 2);
}

void make_lists3()
{
   int i;
   string list;

   stop_make_lists();
   out_base  = filter(sort_base, #'playerfilter);
   list = "*************************\n"+
          "*                       *\n"+
          "* Liste der Top-Spieler *\n"+
          "* --------------------- *\n"+
          "*                       *\n";
   for(i = 0; i < 15 && i < sizeof(out_base); i++)
      list += "*  "+
	      right((i+1)+")",3)+
	      " "+
	      left(capitalize(out_base[i][0]),16)+
	      " *\n";
   list += "*                       *\n"+
	   "*************************\n";
   write_file(TOP_PLAYERS, list);

   call_out("make_lists4", 2);
}

void make_lists4()
{
   int i;
   string list;

   stop_make_lists();
   out_base  = filter(sort_base, #'hlpfilter);
   list = "*************************\n"+
          "*                       *\n"+
          "* Liste der Erzengel    *\n"+
          "* ------------------    *\n"+
          "*                       *\n";
   for(i = 0; i < 15 && i < sizeof(out_base); i++)
      list += "*  "+
	      right((i+1)+")",3)+
	      " "+
	      left(capitalize(out_base[i][0]),16)+
	      " *\n";
   list += "*                       *\n"+
	   "*************************\n";
   write_file(TOP_HLPS, list);
   call_out("make_lists5", 2);
}

// Raetsel - Spiele - Top - Listen

void make_lists5()
{
   int i;
   string *idxs;
   sort_base = ({ });
   stop_make_lists();
   for(i = sizeof(idxs = m_indices(level_base)); i--;)
      sort_base += ({({idxs[i],level_base[idxs[i],2],level_base[idxs[i],3],level_base[idxs[i],1]})});
   sort_base = filter(sort_base, #'testp);

   call_out("make_lists6", 2);
}

void make_lists6()
{
   stop_make_lists();
   sort_base = sort_array(sort_base,#'sort_fun2);
   call_out("make_lists6b", 2, 0);
}

void make_lists6b()
{
   stop_make_lists();
   sort_base2 = sort_array(sort_base,#'sort_fun3);
   call_out("make_lists7", 2, 0);
}

void make_lists7(int l)
{
   string list;
   int i;

   stop_make_lists();
   count = COUNT;

   int top;
   if (l == 0)
       out_base  = filter(sort_base, #'playerfilter);
   else if (l == 1)
       out_base  = filter(sort_base, #'hlpfilter);
   else if (l == 2)
       out_base  = filter(sort_base2, #'playerfilter);
   else if (l == 3)
       out_base  = filter(sort_base2, #'hlpfilter);

   list = "************************************************\n"
          "*                                              *\n";
   if ((l == 0) || (l == 2))
       list +=
              "*                Top - Spieler                 *\n"
              "*                =============                 *\n";
   else
       list +=
              "*                 Top - Engel                  *\n"
              "*                 ===========                  *\n";
   if ((l == 0) || (l == 1))
       list +=
              "*                                              *\n"
              "*   Platz    Name            Rätsel   Spiele   *\n"
              "*   -----    ----            ------   ------   *\n"
              "*                                              *\n";
   else if ((l == 2) || (l == 3))
       list +=
              "*                                              *\n"
              "*   Platz    Name            Spiele  Rätsel    *\n"
              "*   -----    ----            ------  ------    *\n"
              "*                                              *\n";

   if (l == 0) top = TOP_PLAYERS_QUESTS_SIZE;
   else if (l == 1) top = TOP_HLPS_QUESTS_SIZE;
   else if (l == 2) top = TOP_PLAYERS_GAMES_SIZE;
   else if (l == 3) top = TOP_HLPS_GAMES_SIZE;

   if ((l == 0) || (l == 1))
      for(i = 0; i < top && i < sizeof(out_base); i++) {
         list = sprintf("%s*   %4s     %-16s%6d  %6d    *\n",
                     list, 
           ( ( (!i) || (out_base[i][1] != out_base[i-1][1])
               || (out_base[i][2] != out_base[i-1][2]))
           ? (i+1)+"." : ""),
           capitalize(out_base[i][0]), out_base[i][1], out_base[i][2]);
      }
   else if ((l == 2) || (l == 3))
      for(i = 0; i < top && i < sizeof(out_base); i++) {
         list = sprintf("%s*   %4s     %-16s%6d  %6d    *\n",
                     list, 
           ( ( (!i) || (out_base[i][2] != out_base[i-1][2])
               || (out_base[i][1] != out_base[i-1][1]))
           ? (i+1)+"." : ""),
           capitalize(out_base[i][0]), out_base[i][2], out_base[i][1]);
      }

   list += "*                                              *\n"+
           "************************************************\n";
   if (l == 0)
   {
       rm(TOP_PLAYERS_QUESTS);
       write_file(TOP_PLAYERS_QUESTS, list);
   }
   else if (l == 1)
   {
       rm(TOP_HLPS_QUESTS);
       write_file(TOP_HLPS_QUESTS, list);
   }
   else if (l == 2)
   {
       rm(TOP_PLAYERS_GAMES);
       write_file(TOP_PLAYERS_GAMES, list);
   }
   else if (l == 3)
   {
       rm(TOP_HLPS_GAMES);
       write_file(TOP_HLPS_GAMES, list);
   }
   if (l == 1)
       sort_base = 0;
   if (l == 3)
       sort_base2 = 0;

   if (l != 3)
   {
       call_out("make_lists7", 2, l+1);
   }
}

void reset()
{
   object *obs;
   int i, skill, quest;
   string name;

   for(i = sizeof(obs = users()); i--;)
      if(!wizp(obs[i]) &&
	 (((skill = obs[i]->query_sum_skill()) > MIN_EXP) ||
	   (quest = obs[i]->query_quest_count() > MIN_QUEST)) &&
	 (name  = obs[i]->query_real_name()))
      {
	 level_base[name]   = skill;
	 level_base[name,1] = obs[i]->query_level();
         level_base[name,2] = obs[i]->query_quest_count ();
         level_base[name,3] = obs[i]->query_game_count ();
      }
   call_out ("make_lists",2);
}

int check_me(string name)
{
#ifdef UNItopia
    string *namen;
    string on_po = object_name(previous_object());

    if (strstr(on_po,LOGIN_OB"#") &&
        strstr(on_po,"/obj/player#"))
	 return 0;

    if(zweities[name])
	namen = zweities[name];
    else if(ersties[name])
	namen = ({ersties[name]});
    else
	return 0;
    namen = filter(namen, #'find_player);
    if(!sizeof(namen))
	return 0;
    write_file("/var/adm/CHECK",sprintf("%s %s eingeloggt, %s aber bereits drin.\n",
	shorttimestr(time()), capitalize(name), liste(map(namen,#'capitalize))));
    return 1;
#endif
}

void list_me(object who, string name)
{
   string on_po = object_name(previous_object());
   if (strstr(on_po,LOGIN_OB"#") &&
       strstr(on_po,"/obj/player#"))
	return;

   check_me(name);
    
#ifdef PLAYER_LIST
//    if (file_size(PLAYER_LIST)>65000)
//	rename(PLAYER_LIST,PLAYER_LIST+".old");
    if(file_size(PLAYER_LIST_DIR)!=-2)
	mkdir(PLAYER_LIST_DIR);
    if(!who->is_intermud_guest())
        write_file(PLAYER_LIST_DIR+PLAYER_LIST,
               sprintf("%-10s %s %-22s %s\n", 
               stringp(name)?name:"", shorttimestr(time()),
#if __EFUN_DEFINED__(query_ip_name)
               efun::query_ip_number(who)||"", 
               efun::query_ip_name(who)||""));
#else
               efun::interactive(who) && efun::interactive_info(who, II_IP_NUMBER)||"",
               efun::interactive(who) && efun::interactive_info(who, II_IP_NAME)||""));
#endif
#endif
}

#if defined(UNItopia) && defined(PLAYER_LIST)
void correct_list(string ip_name, string ip_number)
{
    if(!playerp(previous_object()))
	return;
    if(file_size(PLAYER_LIST_DIR)!=-2)
	mkdir(PLAYER_LIST_DIR);
    write_file(PLAYER_LIST_DIR+PLAYER_LIST,
               sprintf("%-10s %s %-22s %s\n", 
	       previous_object()->query_real_name(),
	       shorttimestr(time()),
	       ip_number, ip_name));
}
#endif

void new_enter(object who)
{
   string name;
   int skill;

   if (!who)
	return;
   if (strstr(object_name(previous_object()),LOGIN_OB"#") &&
       strstr(object_name(previous_object()),"/obj/player#"))
	return;

   name = who->query_real_name();

   list_me(who, name);

   if(wizp(who) || (skill = who->query_sum_skill()) < MIN_EXP)
      m_delete(level_base, name);
   else
   {
      level_base[name]   = skill;
      level_base[name,1] = who->query_level();
      level_base[name,2] = who->query_quest_count ();
      level_base[name,3] = who->query_game_count ();
      count--;
   }
   if(!count)
   {
      stop_make_lists();
      call_out("make_lists",4);
   }
}

//suicid
int remove_entry(string name)
{
   if(previous_object() &&
   	(playerp(previous_object()) || geteuid(previous_object()) == ROOT_UID)
	&& stringp(name))
   {
      m_delete(level_base, name);
      if(!--count)
      {
        stop_make_lists();
        call_out("make_lists",4);
      }
      return 1;
   }
}

mapping query_level_base() { return copy(level_base); }


#ifdef CONVERT
// OneShot: OldStyle -> New
void convert()
{
   string st, *sts;
   int i, exp;

   if ((st = read_file("/save/TOP_ALL")) && st != "")
   {
      sts = explode(st,"\n")-({""});
      for (i=0; i<sizeof(sts); i++)
	 if (sscanf(sts[i],"%s %d",st,exp)==2 && exp>MIN_EXP)
	 {
	    level_base[st] = exp;
	    level_base[st,1] = 1;
	 }
      save();
   }
   

}
#endif // !CONVERT

#endif // !TestMUD
